unit OtherAppCtrl;

interface

uses
  DDEMAN, Classes, SYSUtils, Windows, Messages, Math;


  ///////////////////////////////////////////////////////////////////////////
  {ALL}
  ///////////////////////////////////////////////////////////////////////////
  function OApp_AddFiles(AFilenames:String):Boolean;
  function OApp_Play():Boolean;
  function OApp_Stop():Boolean;
  function OApp_Pause():Boolean;
  function OApp_Next():Boolean;
  function OApp_Prev():Boolean;
  function OApp_VolumeUp():Boolean;
  function OApp_VolumeDown():Boolean;
  function OApp_SetVolume(Vol:Integer):Boolean;

  ///////////////////////////////////////////////////////////////////////////
  {Lilith}
  ///////////////////////////////////////////////////////////////////////////
  function Lilith_AddFiles(AFilenames:String):Boolean;
  function Lilith_Play():Boolean;
  function Lilith_Stop():Boolean;
  function Lilith_Pause():Boolean;
  function Lilith_Next():Boolean;
  function Lilith_Prev():Boolean;
  function Lilith_VolumeUp():Boolean;
  function Lilith_VolumeDown():Boolean;
  function Lilith_SetVolume(Vol:Integer):Boolean;
  ///////////////////////////////////////////////////////////////////////////
  {WinAmp}
  ///////////////////////////////////////////////////////////////////////////
  function WAmp_AddFiles(AFilenames: String): Boolean;
  function WAmp_Play():Boolean;
  function WAmp_Stop():Boolean;
  function WAmp_Pause():Boolean;
  function WAmp_Next():Boolean;
  function WAmp_Prev():Boolean;
  function WAmp_VolumeUp():Boolean;
  function WAmp_VolumeDown():Boolean;
  function WAmp_SetVolume(Vol:Integer):Boolean;


implementation

  ///////////////////////////////////////////////////////////////////////////
  {WinAmp}
  ///////////////////////////////////////////////////////////////////////////
  function WAmpH: THandle;
  begin
    Result := FindWindow('Winamp v1.x', nil);
  end;
  function WAmp_SendCopyData(AMsgType: Integer; AText: String): Integer;
  var
    CopyData : TCopyDataStruct;
  begin
    with CopyData do
    begin
      dwData := AMsgType;
      lpData := PChar(AText);
      cbData := strlen(lpData)+1;
    end;
    Result := SendMessage(WAmpH,WM_COPYDATA,0,LongInt(@CopyData));
  end;
  function WAmp_SendCmd(AMsgType: Integer; Value: Integer=0): Boolean;
  begin
    Result := SendMessage(WAmpH,WM_USER,Value,AMsgType)<>0;
  end;
  function WAmp_SendZeroCmd(AMsgType: Integer): Boolean;
  begin
    Result := SendMessage(WAmpH,WM_COMMAND,AMsgType,0)<>0;
  end;
  //----------------------------------------------------------------
  function WAmp_AddFiles(AFilenames: String): Boolean;
  var
    i : Integer;
    FilenameList : TStringList;
  begin
    FilenameList := TStringList.Create;
    try
      FilenameList.Text := AFilenames;
      Result := False;
      for i:=0 to FilenameList.Count-1 do
        Result :=
          (WAmp_SendCopyData(100,FilenameList[i])<>0)
          or Result;
    finally
      FilenameList.Free;
    end;
  end;
  function WAmp_Play():Boolean;
  begin
    Result := WAmp_SendCmd(102);
  end;
  function WAmp_Stop():Boolean;
  begin
    Result := WAmp_SendZeroCmd(40047);
  end;
  function WAmp_Pause():Boolean;
  begin
    Result := WAmp_SendZeroCmd(40046);
  end;
  function WAmp_Next():Boolean;
  begin
    Result := WAmp_SendZeroCmd(40048);
  end;
  function WAmp_Prev():Boolean;
  begin
    Result := WAmp_SendZeroCmd(40044);
  end;
  function WAmp_VolumeUp():Boolean;
  var
    i : Integer;
  begin
    for i:=0 to 4 do
      Result := WAmp_SendZeroCmd(40058)and Result;
  end;
  function WAmp_VolumeDown():Boolean;
  var
    i : Integer;
  begin
    for i:=0 to 4 do
      Result := WAmp_SendZeroCmd(40059)and Result;
  end;
  function WAmp_SetVolume(Vol:Integer):Boolean;
  begin
    Result := WAmp_SendCmd(122,Round(255*(Vol/100)));
  end;

  ///////////////////////////////////////////////////////////////////////////
  {Lilith}
  ///////////////////////////////////////////////////////////////////////////
  function QuotedFilenames(AFilenames:String):String;
  var
    i : Integer;
    FilenameList : TStringList;
  begin
    Result := '';
    FilenameList := TStringList.Create;
    try
      FilenameList.Text := AFilenames;
      for i:=0 to FilenameList.Count-1 do
        Result := Result+AnsiQuotedStr(FilenameList[i],'"')+' ';
    finally
      FilenameList.Free;
    end;
  end;
  function ExecuteMacro(Cmd:String):Boolean;
  var
    DDE: TDdeClientConv;
  begin
    DDE := TDdeClientConv.Create(nil);
    try
      if DDE.SetLink( 'LILITH_EXT_CONTROL', 'LILITH_EXT_CONTROL' ) then
        Result :=
          DDE.ExecuteMacro(PAnsiChar(Cmd),False)
      else
        Result := False;
    finally
      DDE.Free;
    end;
  end;
  function RequestData(Cmd:String):String;
  var
    DDE: TDdeClientConv;
  begin
    DDE := TDdeClientConv.Create(nil);
    try
      if DDE.SetLink( 'LILITH_EXT_CONTROL', 'LILITH_EXT_CONTROL' ) then
        Result :=
          DDE.RequestData(Cmd)
      else
        Result := '';
    finally
      DDE.Free;
    end;
  end;
  //----------------------------------------------------------------
  function Lilith_AddFiles(AFilenames:String):Boolean;
  begin
    Result := ExecuteMacro('/add '+QuotedFilenames(AFilenames));
  end;
  function Lilith_Play():Boolean;
  begin
    Result := ExecuteMacro('/play');
  end;
  function Lilith_Stop():Boolean;
  begin
    Result := ExecuteMacro('/stop');
  end;
  function Lilith_Pause():Boolean;
  begin
    Result := ExecuteMacro('/pause');
  end;
  function Lilith_Next():Boolean;
  begin
    Result := ExecuteMacro('/next') and ExecuteMacro('/play');
  end;
  function Lilith_Prev():Boolean;
  begin
    Result := ExecuteMacro('/back') and ExecuteMacro('/play');
  end;
  function Lilith_VolumeUp():Boolean;
  var
    v : Integer;
  begin
    v := StrToIntDef(RequestData('/volume'),100);
    v := Min(100,v+5);
    Result := ExecuteMacro('/volume '+IntToStr(v));
  end;
  function Lilith_VolumeDown():Boolean;
  var
    v : Integer;
  begin
    v := StrToIntDef(RequestData('/volume'),100);
    v := Max(0,v-5);
    Result := ExecuteMacro('/volume '+IntToStr(v));
  end;
  function Lilith_SetVolume(Vol:Integer):Boolean;
  begin
    Result := ExecuteMacro('/volume '+IntToStr(Vol));
  end;

  ///////////////////////////////////////////////////////////////////////////
  {ALL}
  ///////////////////////////////////////////////////////////////////////////
  function OApp_AddFiles(AFilenames:String):Boolean;
  begin
    Result := WAmp_AddFiles(AFilenames);
    Result := Lilith_AddFiles(AFilenames) or Result;
  end;
  function OApp_Play():Boolean;
  begin
    Result := WAmp_Play;
    Result := Lilith_Play or Result;
  end;
  function OApp_Stop():Boolean;
  begin
    Result := WAmp_Stop;
    Result := Lilith_Stop or Result;
  end;
  function OApp_Pause():Boolean;
  begin
    Result := WAmp_Pause;
    Result := Lilith_Pause or Result;
  end;
  function OApp_Next():Boolean;
  begin
    Result := WAmp_Next;
    Result := Lilith_Next or Result;
  end;
  function OApp_Prev():Boolean;
  begin
    Result := WAmp_Prev;
    Result := Lilith_Prev or Result;
  end;
  function OApp_VolumeUp():Boolean;
  begin
    Result := WAmp_VolumeUp;
    Result := Lilith_VolumeUp or Result;
  end;
  function OApp_VolumeDown():Boolean;
  begin
    Result := WAmp_VolumeDown;
    Result := Lilith_VolumeDown or Result;
  end;
  function OApp_SetVolume(Vol:Integer):Boolean;
  begin
    Result := WAmp_SetVolume(Vol);
    Result := Lilith_SetVolume(Vol) or Result;
  end;


end.
