unit TreeNodeList;

interface

uses
  Contnrs, ExtCtrls, StdCtrls, ComCtrls, SYSUtils;

type

  TTreeNodeList = class(TObjectList)
  private
    function GetItem(Index: Integer): TTreeNode;
    procedure SetItem(Index: Integer; const Value: TTreeNode);
  public
    function Add(Node:TTreeNode):TTreeNode;
    function Exists(Node:TTreeNode):Boolean;
    procedure Remove(Node:TTreeNode);
    property Items[Index:Integer]:TTreeNode read GetItem write SetItem; default;
  end;

implementation

  function TreeNodeListComp(Item1, Item2: Pointer): Integer;
  begin
    Result := CompareText(TTreeNode(Item1).Text,TTreeNode(Item2).Text);
  end;

  function TTreeNodeList.Add(Node: TTreeNode): TTreeNode;
  begin
    Result := Node;
    inherited Add(node);
    Sort(TreeNodeListComp);
  end;

  function TTreeNodeList.Exists(Node: TTreeNode): Boolean;
  begin
    Result := IndexOf(Node)>=0;
  end;

  function TTreeNodeList.GetItem(Index: Integer): TTreeNode;
  begin
    Result := TTreeNode(inherited GetItem(Index));
  end;

  procedure TTreeNodeList.Remove(Node: TTreeNode);
  begin
    inherited Remove(TObject(Node));
  end;

  procedure TTreeNodeList.SetItem(Index: Integer; const Value: TTreeNode);
  begin
    inherited SetItem(Index,Value);
  end;


end.
