unit UMainForm;

{$DEFINE ANEKOS}

interface

uses
  OtherAppCtrl, TreeNodeList,GetLyrics, ANekoAudio,
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, ComCtrls, FileCtrl, MP3Plyr, ShellAPI,
  AppEvnts, Buttons, Menus, Contnrs;

const
  WM_TRAY   = WM_USER + 100;
  VERSION   = '050228';

type
  TMainForm = class(TForm)
    Panel1: TPanel;
    MP3Player: TMP3Player;
    Panel2: TPanel;
    DirTree: TTreeView;
    PlayFileList: TListView;
    Splitter1: TSplitter;
    ApplicationEvents1: TApplicationEvents;
    Panel6: TPanel;
    BarPanel: TPanel;
    VolPanel: TPanel;
    Label2: TLabel;
    VolBar: TScrollBar;
    PosPanel: TPanel;
    Label1: TLabel;
    PosBar: TScrollBar;
    Panel7: TPanel;
    PlayBtn: TSpeedButton;
    PauseBtn: TSpeedButton;
    RepeatAllBtn: TSpeedButton;
    RandomBtn: TSpeedButton;
    DirFileListMenu: TPopupMenu;
    CommandEdit: TMemo;
    LoadingPanel: TPanel;
    GetLyricsMenu: TPopupMenu;
    DarkLyricscom1: TMenuItem;
    Song365com1: TMenuItem;
    SendListBtn: TSpeedButton;
    N1: TMenuItem;
    StopBtn: TSpeedButton;
    Play1: TMenuItem;
    Stop1: TMenuItem;
    Pause1: TMenuItem;
    PrevBtn: TSpeedButton;
    NextBtn: TSpeedButton;
    Next1: TMenuItem;
    Prev1: TMenuItem;
    PitPanel: TPanel;
    Pit: TLabel;
    PitchBar: TScrollBar;
    Bevel1: TBevel;
    UpVolume: TMenuItem;
    DownVolume: TMenuItem;
    OpenDirectory: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure CmdEditKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure DirTreeChange(Sender: TObject; Node: TTreeNode);
    procedure MP3PlayerEndPlay(Sender: TObject; Reason: TMP3EndPlayReason);
    procedure CmdEditChange(Sender: TObject);
    procedure PlayFileListKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure DirTreeDblClick(Sender: TObject);
    procedure DirTreeKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure PlayFileListDblClick(Sender: TObject);
    procedure DirTreeCompare(Sender: TObject; Node1, Node2: TTreeNode;
      Data: Integer; var Compare: Integer);
    procedure ApplicationEvents1Minimize(Sender: TObject);
    procedure ApplicationEvents1Restore(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure MP3PlayerChangePosition(Sender: TObject);
    procedure PosBarScroll(Sender: TObject; ScrollCode: TScrollCode;
      var ScrollPos: Integer);
    procedure VolBarScroll(Sender: TObject; ScrollCode: TScrollCode;
      var ScrollPos: Integer);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure PauseBtnClick(Sender: TObject);
    procedure PlayBtnClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure MP3PlayerChangeStatus(Sender: TObject);
    procedure WMHotKey(var Msg: TWMHotKey); message WM_HOTKEY;
    procedure WMDropfiles(var Msg: TWMDropfiles);message WM_DROPFILES;
    procedure WMTRAY(var Msg: TMsg);message WM_TRAY;
    procedure DirTreeExpanded(Sender: TObject; Node: TTreeNode);
    procedure DirTreeCollapsed(Sender: TObject; Node: TTreeNode);
    procedure DirFileListMenuPopup(Sender: TObject);
    procedure CommandEditKeyPress(Sender: TObject; var Key: Char);
    procedure FormShow(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure DarkLyricscom1Click(Sender: TObject);
    procedure Song365com1Click(Sender: TObject);
    procedure SendListBtnClick(Sender: TObject);
    procedure DirTreeDeletion(Sender: TObject; Node: TTreeNode);
    procedure PlayFileListDeletion(Sender: TObject; Item: TListItem);
    procedure StopBtnClick(Sender: TObject);
    procedure PrevBtnClick(Sender: TObject);
    procedure NextBtnClick(Sender: TObject);
    procedure PitchBarScroll(Sender: TObject; ScrollCode: TScrollCode;
      var ScrollPos: Integer);
    procedure PitClick(Sender: TObject);
    procedure UpVolumeClick(Sender: TObject);
    procedure DownVolumeClick(Sender: TObject);
    procedure OpenDirectoryClick(Sender: TObject);
  private
    //
    Inited : Boolean;
    //c[
    Root : TTreeNodeList;
    TempPlayList : TStringList;
    //ݒ
    ActiveHotkey,VolUpHotkey,VolDownHotkey : TShortCut;
    //t
    LastItemIndex : Integer;
    //GUI
    PosBarScrolln,Minimized : Boolean;
    FTrayTip : String;
    //ݒ
    procedure SetHotKey(SC: TSHortCut; ID: Integer);
    procedure LoadSetting;
    procedure SaveSetting;
    //t@C
    function GetFileInfo(AItem: TListItem): TAudioFileInfo; overload;
    function GetFileInfo(Filepath: String; Index: Integer): TAudioFileInfo; overload;
    function GetFileListCaption(AItem: TListItem): String;
    function GetFormCaption(AItem: TListItem): String;
    //t
    function ShowSelDir(Recurse: Boolean=False): Boolean;
    function PlaySelDir(Recurse: Boolean=False): Boolean;
    procedure PlaySelFile;
    procedure RemoveSelDir(Node: TTreeNode);
    function GoNextItem: TListItem;
    //c[
    procedure LoadDir;
    procedure AddRootNode(DirPath: String);
    function GetNextNode(ANode: TTreeNode=nil; APrev: Boolean=False;
      AAll: Boolean=False): TTreeNode;
    function FindEx(AExp: String; ANext:Boolean=False; ANode: TTreeNode=nil;
      APrev: Boolean=False; AAll: Boolean=False): TTreeNode;
    function GetMenuCaption(Path: String; Index: Integer): String;
    procedure GetFileList(ADirPath: String; AFileList: TStringList;
      Recurse: Boolean=False);
    //R}h
    function GetCommand: String;
    procedure SetCommand(const Value: String);
    property Command: String read GetCommand write SetCommand;
    function ExecCommand: Boolean;
    //ǂݍݒpl
    procedure StartLoading;
    procedure EndLoading;
    procedure ReloadDir;
    function GoPrevItem: TListItem;
    procedure PlayNext;
    procedure PlayPrev;
    procedure ChangeSamplingRate(APer: Integer);
    //gC
    procedure SetTrayTip(const Value: String);
  end;

var
  MainForm: TMainForm;
  NID: TNotifyIconData;

implementation

{$R *.dfm}

///////////////////////////////////////////////////////////////////////////
{FUNC}
///////////////////////////////////////////////////////////////////////////

{InBA܂܂Ă邩H}
function InText(A,InB: String): Boolean;
begin
  Result := Pos(UpperCase(A),UpperCase(InB))>0;
end;

{A,B͓H}
function CmpText(A,B: String): Boolean;
begin
  Result := CompareText(A,B)=0;
end;

{pX̍Ō\}
function RmSlash(path: String): String;
begin
  if Copy(path,Length(path),1)='\' then
    Delete(path,Length(path),1);
  Result := path;
end;

{|C^𐶐i[}
function NewPStr(S: String): PString;
begin
  New(Result);
  Result^ := S;
end;

{L[Ă邩}
function GetKeyStat(KeyCode: Byte): Boolean;
begin
  Result := (getkeystate(KeyCode) and $8000 <> 0);
end;

{EChEANeBuɂ}
procedure DoActive;
var
  hTargetWnd,
  dwTargetTID,
  dwActiveTID:  DWORD;
begin
  hTargetWnd := Application.Handle;
  dwTargetTID := GetWindowThreadProcessId(hTargetWnd, nil);
  dwActiveTID := GetWindowThreadProcessId(GetForegroundWindow, nil);
  if dwTargetTID = dwActiveTID then
    BringWindowToTop(hTargetWnd)
  else
  begin
    AttachThreadInput(dwTargetTID, dwActiveTID, True);
    try
      BringWindowToTop(hTargetWnd);
    finally
      AttachThreadInput(dwTargetTID, dwActiveTID, FALSE);
    end;
  end;
end;

{񂩂TShortCutɕϊ}
function TextToShortCutDef(S: String; Def: TShortCut): TShortCut;
begin
  try
    Result := TextToShortCut(S);
  except
    Result := Def;
  end;
end;

{fBNg̖OԂ}
function DirName(Path: String): String;
begin
  path := RmSlash(path);
  Result := ExtractFileName(path);
end;

{^u؂}
function TabSplit(var line: String): String;
var
   i : Integer;
begin
  i := Pos(#9,line);
  if i<1 then
    i := Length(line)+1;
  result := copy(line,1,i-1);
  delete(line,1,i);
end;

{B܂܂Ă邩H - BInA폜}
function CheckCharIn(var InA: String; B: Char): Boolean;
var
  i : Integer;
begin
  Result := False;
  for i:=Length(InA) downto 1 do
    if InA[i]=B then
    begin
      Delete(InA,i,1);
      Result := True;
    end;
end;

{URLJ}
procedure OpenURL(AUrl: String);
begin
  shellexecute(0,'Open',PChar(AUrl),nil,nil,SW_SHOW);
end;

{VFs}
procedure ShellExpOpen(APath,AParam: String);
begin
  ShellExecute(
    0,
    nil,
    PAnsiChar('explorer'),
    PAnsiChar(AParam+','+APath),
    nil,
    SW_SHOW);
end;


///////////////////////////////////////////////////////////////////////////
{t@C}
///////////////////////////////////////////////////////////////////////////

function TMainForm.GetFileInfo(Filepath: String; Index: Integer): TAudioFileInfo;
var
  info : TMP3Info;
begin
  info := TMP3Info.Create;
  try
    try
      MP3Player.ReadInfo(Filepath,info);
    except;
      Result.Title := '';
    end;
    with Result do
    begin
      Track := Index+1;
      Title := info.Title;
      if Title='' then
        Title := ExtractFileName(Filepath);
      Artist := info.Artist;
      Album := info.Album;
    end;
  finally
    info.Free;
  end;
end;
function TMainForm.GetFileInfo(AItem: TListItem): TAudioFileInfo;
begin
  if AItem.Data<>nil then
    Result := GetFileInfo(PString(AItem.Data)^,AItem.Index);
end;

function TMainForm.GetFileListCaption(AItem: TListItem): String;
begin
  with GetFileInfo(AItem) do
    Result := Format('%.2d-%s',[Track,Title]);
end;
function TMainForm.GetFormCaption(AItem: TListItem): String;
begin
  with GetFileInfo(AItem) do
    Result := Format('%.2d-%s/%s/%s',[Track,Title,Artist,Album]);
end;
function TMainForm.GetMenuCaption(Path: String; Index: Integer): String;
begin
  with GetFileInfo(Path,Index) do
    Result := Format('%.2d-%s',[Track,Title]);
end;

///////////////////////////////////////////////////////////////////////////
{ݒ}
///////////////////////////////////////////////////////////////////////////

{zbgL[Zbg}
procedure TMainForm.SetHotKey(SC: TSHortCut; ID: Integer);
var
  i : integer;
  TempStr : string;
  Key: Word; Shift: TShiftState;
begin
  if SC=0 then
    Exit;
  TempStr := ShortCutToText(SC);
  i := 0;
  if Pos('Shift',TempStr) <> 0 then i := i or MOD_SHIFT;
  if Pos('Ctrl',TempStr) <> 0 then i := i or MOD_CONTROL;
  if Pos('Alt',TempStr) <> 0 then i := i or MOD_ALT;
  ShortCutToKey(SC,Key,Shift);
  UnRegisterHotKey(Handle, ID);
  RegisterHotKey(Handle, ID,  i ,Key);
end;

{ݒǂݍ}
procedure TMainForm.LoadSetting;
var
  FN,a,b : String;
  SL : TStringList;
  i,t : Integer;
begin
  //l
  Left := 0;
  Top := 0;
  width := 300;
  height := 300;
  ActiveHotkey := TextToShortCut('Ctrl+Shift+K');
  VolUpHotkey := 0;
  VolDownHotkey := 0;
  //Z[ut@Cǂݍ
  FN := ChangeFileExt(ParamStr(0),'.ini');
  if FileExists(FN) then
  begin
    SL := TStringList.Create;
    try
      SL.LoadFromFile(FN);
      for i:=0 to SL.Count-1 do
      begin
        t := Pos('=',SL[i]);
        a := Trim(Copy(SL[i],1,t-1));
        b := Trim(Copy(SL[i],t+1,$FFFFFF));
        if CmpText(a,'window_alpha') then
        begin
          AlphaBlendValue := StrToIntDef(b,255);
          AlphaBlend := AlphaBlendValue<255;
        end
        else
        if CmpText(a,'window_left') then
          Left := StrToIntDef(b,0)
        else
        if CmpText(a,'window_top') then
          Top := StrToIntDef(b,0)
        else
        if CmpText(a,'window_width') then
          width := StrToIntDef(b,100)
        else
        if CmpText(a,'window_height') then
          height := StrToIntDef(b,100)
        else
        if CmpText(a,'repeat_all') then
          RepeatAllBtn.Down := StrToBoolDef(b,RepeatAllBtn.Down)
        else
        if CmpText(a,'random') then
          RandomBtn.Down := StrToBoolDef(b,RandomBtn.Down)
        else
        if CmpText(a,'hotkey') then
          ActiveHotkey := TextToShortCutDef(b,ActiveHotkey)
        else
        if CmpText(a,'hotkey_volume_up') then
          VolUpHotkey := TextToShortCutDef(b,VolUpHotkey)
        else
        if CmpText(a,'hotkey_volume_down') then
          VolDownHotkey := TextToShortCutDef(b,VolDownHotkey)
        else
        if CmpText(a,'filelist_width') then
          PlayFileList.Width := StrToIntDef(b,100)
        else
        if CmpText(a,'sendlist') then
          SendListBtn.Down := StrToBoolDef(b,SendListBtn.Down)
        else
        if CmpText(a,'volume') then
        begin
          MP3Player.Volume := StrToIntDef(b,100);
          VolBar.Position := MP3Player.Volume;
        end
        else
        if CmpText(a,'root') then
        begin
          while Trim(b)<>'' do
            AddRootNode(TabSplit(b));
        end;
      end;
    finally
      SL.Free;
    end;
  end;
  //ʒuC
  if Left<0 then
    Left := Screen.Width-Width+Left;
  if Top<0 then
    Top := Screen.Height-Height+Top;
  if Left>Screen.Width then
    Left := 0;
  if Top>Screen.Height then
    Top := 0;
  //zbgL[
  SetHotKey(ActiveHotkey,ActiveHotkey);
  SetHotKey(VolUpHotkey,VolUpHotkey);
  SetHotKey(VolDownHotkey,VolDownHotkey);
  //
  SendListBtnClick(SendListBtn);
end;

{ݒ菑}
procedure TMainForm.SaveSetting;
var
  FN : String;
  SL : TStringList;
  procedure Add(a,b:String);overload;
  begin
    SL.Add(a+' = '+b);
  end;
  procedure Add(a:String;b:Integer);overload;
  begin
    Add(a,IntToStr(b));
  end;
  procedure Add(a:String;b:Extended);overload;
  begin
    Add(a,FloatToStr(b));
  end;
  procedure Add(a:String;b:Boolean);overload;
  begin
    Add(a,BoolToStr(b));
  end;
  procedure AddCmd(a:String;b:TShortCut);
  begin
    Add(a,ShortCutToText(b));
  end;
var
  i : Integer;
  RootPaths : String;
begin
  //RootpX
  RootPaths := '';
  for i:=0 to Root.Count-1 do
    RootPaths := RootPaths+PString(Root[i].Data)^+#9;
  //
  FN := ChangeFileExt(ParamStr(0),'.ini');
  SL := TStringList.Create;
  try
    Add('window_left',Left);
    Add('window_top',Top);
    Add('window_width',Width);
    Add('window_height',Height);
    Add('window_alpha',AlphaBlendValue);
    AddCmd('hotkey',ActiveHotkey);
    AddCmd('hotkey_volume_up',VolUpHotkey);
    AddCmd('hotkey_volume_down',VolDownHotkey);
    Add('repeat_all',RepeatAllBtn.Down);
    Add('random',RandomBtn.Down);
    Add('volume',MP3Player.Volume);
    Add('root',RootPaths);
    Add('filelist_width',PlayFileList.Width);
    Add('sendlist',SendListBtn.Down);
    SL.SaveToFile(FN);
  finally
    SL.Free;
  end;
end;

///////////////////////////////////////////////////////////////////////////
{tH[/j}
///////////////////////////////////////////////////////////////////////////

procedure TMainForm.FormCreate(Sender: TObject);
begin
  Inited := False;
  //lݒ
  PosBarScrolln := False;
  Minimized := False;
  DragAcceptFiles(Handle,True);
  caption := caption+' - ver.'+VERSION;
  LastItemIndex := -1;
  RandSeed := GetTickCount;
  //CX^X
  Root := TTreeNodeList.Create;
  TempPlayList := TStringList.Create;
  //ǂݍ
  LoadSetting;
  {$IFNDEF ANEKOS}
     PitPanel.Visible := False;
     VolPanel.Height := BarPanel.Height div 2;
     PosPanel.Height := BarPanel.Height div 2;
  {$ENDIF}
end;

procedure TMainForm.FormShow(Sender: TObject);
begin
  //
end;

procedure TMainForm.FormPaint(Sender: TObject);
begin
  if Inited then
    Exit;
  Inited := True;
  LoadDir;
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Shell_NotifyIcon(NIM_DELETE, @NID);
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
  SaveSetting;
  TempPlayList.Free;
  Root.Free;
end;

///////////////////////////////////////////////////////////////////////////
{c[}
///////////////////////////////////////////////////////////////////////////

{c[\̃\[gp֐}
procedure TMainForm.DirTreeCompare(Sender: TObject; Node1,
  Node2: TTreeNode; Data: Integer; var Compare: Integer);
begin
  Compare := CompareText(Node1.Text,Node2.Text);
end;

{ROOTǉ}
procedure TMainForm.AddRootNode(DirPath:String);
begin
  Root.Add(DirTree.Items.Add(nil,DirName(DirPath))).Data := NewPStr(DirPath);
end;

{ROOTc[𐶐}
procedure TMainForm.LoadDir;
  procedure FindDir(path:string;Parent:TTreeNode);
  var
    Rec     : TSearchRec;
    Next  : boolean;
    NewNode : TTreeNode;
  begin
    path := RmSlash(path);
    Next  := FindFirst(path + '\*.*', faAnyFile, Rec) <> 0;
    while not Next  do
    begin
      if (Rec.Name <> '.') and (Rec.Name <> '..') then
      begin
        if (Rec.Attr and faDirectory) > 0 then
        begin
          NewNode := DirTree.Items.AddChild(Parent,rec.Name);
          NewNode.Data := nil;
          FindDir(path+'\'+Rec.Name,NewNode);
        end
        else
        begin
        end;
      end;
      Next := FindNext(Rec) <> 0;
    end;
    FindClose(Rec);
  end;
var
  i : Integer;
begin
  StartLoading;
  DirTree.Items.BeginUpdate;
  try
    //[g猟
    for i:=0 to Root.Count-1 do
      if Root[i].getFirstChild=nil then
        FindDir(PString(Root[i].Data)^,Root[i]);
    //rootPȂ玩rooẗڂ̎qɈړ
    if Root.Count=1 then
      DirTree.Selected := root[0].getFirstChild;
  finally
    DirTree.Items.EndUpdate;
    EndLoading;
  end;
  DirTree.AlphaSort();
end;

procedure TMainForm.ReloadDir;
var
  i : Integer;
begin
  StartLoading;
  DirTree.Items.BeginUpdate;
  try
    //[gx폜
    for i:=0 to Root.Count-1 do
      Root[i].DeleteChildren;
    LoadDir;
  finally
    DirTree.Items.EndUpdate;
    EndLoading;
  end;
  DirTree.AlphaSort();
end;

{̃m[hԂ - ꍇ͐擪/Ԃ}
function TMainForm.GetNextNode(ANode:TTreeNode=nil;APrev:Boolean=False;
  AAll:Boolean=False):TTreeNode;
begin
  Result := nil;
  if ANode=nil then
    ANode := DirTree.Selected;
  if ANode=nil then
  begin
    if DirTree.Items.Count>0 then
      Result := DirTree.Items[0];
    Exit;
  end;
  if AAll then
  begin
    if APrev then
    begin
      Result := ANode.GetPrev;
      if Result=nil then
        Result := DirTree.Items[DirTree.Items.Count-1];
    end
    else
    begin
      Result := ANode.GetNext;
      if Result=nil then
        Result := DirTree.Items[0];
    end;
  end
  else
  begin
    if APrev then
    begin
      Result := ANode.GetPrevSibling;
      if Result=nil then
      begin
        Result := ANode;
        while Result.GetNextSibling<>nil do
          Result := Result.GetNextSibling;
      end;
    end
    else
    begin
      Result := ANode.GetNextSibling;
      if Result=nil then
      begin
        Result := ANode;
        while Result.GetPrevSibling<>nil do
          Result := Result.GetPrevSibling;
      end;
    end;
  end;
end;

{c[Ĉړ}
function TMainForm.FindEx(AExp: String; ANext: Boolean=False;
  ANode: TTreeNode=nil; APrev: Boolean=False; AAll:Boolean=False):TTreeNode;
var
  All,RegExp : Boolean;
  NextNode : TTreeNode;
  //rp֐ - K\ł͖(ɐ^)B
  function Comp(CompNode:TTreeNode):Boolean;
  begin
    if RegExp then
      Result := True
    else
      Result := InText(AExp,CompNode.Text);
  end;
  //̃m[hݒ肷BFalse
  function GoNext:Boolean;
  begin
    NextNode := GetNextNode(NextNode,APrev,All);
    Result := NextNode<>ANode;
  end;
begin
  //̃^Cv
  RegExp := False;
  All := AAll or CheckCharIn(AExp,'/');
  //ANext̎̃m[hJn
  if ANext then
    ANode := GetNextNode(ANode,APrev,All);
  //nil̏ꍇIĂm[h
  if ANode=nil then
    ANode := DirTree.Selected;
  if ANode=nil then
    ANode := DirTree.Items[0];
  //Ƃ肠݂̃m[hԒlƂĂ
  Result := ANode;
  //Next̏ꍇ݂̃m[h}b`OK
  if Comp(ANode) then
    Exit;
  //}b`m[h܂ŒTBI
  NextNode := ANode;
  while GoNext do
    if Comp(NextNode) then
    begin
      Result := NextNode;
      Exit;
    end;
end;

{Iꂽm[h폜}
procedure TMainForm.RemoveSelDir(Node:TTreeNode);
begin
  if node=nil then
    Exit;
  if not Root.Exists(node) then
    Exit;
  if (MessageDlg('remove?', mtConfirmation, [mbYes, mbNo], 0) = mrYes) then
  begin
    Root.Remove(node);
    node.Delete;
  end;
end;

{m[hfBNgpX擾}
function GetDirPath(ANode:TTreeNode):String;
begin
  Result := '';
  while ANode<>nil do
  begin
    if ANode.Data=nil then
      Result := ANode.Text+'\'+Result
    else
      Result := RmSlash(PString(ANode.Data)^)+'\'+Result;
    ANode := ANode.Parent;
  end;
end;

{fBNg̃t@CXg擾}
procedure TMainForm.GetFileList(ADirPath: String; AFileList: TStringList;
  Recurse: Boolean=False);
  procedure FindFiles(path: string);
  var
    Rec     : TSearchRec;
    Next  : boolean;
  begin
    path := RmSlash(path);
    Next  := FindFirst(path + '\*.*', faAnyFile, Rec) <> 0;
    while not Next  do
    begin
      if (Rec.Name <> '.') and (Rec.Name <> '..') then
      begin
        if (Rec.Attr and faDirectory) > 0 then
        begin
          if Recurse then
            FindFiles(path+'\'+Rec.Name);
        end
        else
        begin
          if (CompareText(ExtractFileExt(Rec.Name),'.mp3')=0)or
          SendListBtn.Down then
            AFileList.Add(path+'\'+Rec.Name);
        end;
      end;
      Next := FindNext(Rec) <> 0;
    end;
    FindClose(Rec);
  end;
begin
  FindFiles(ADirPath);
  AFileList.Sort;
end;


{fBNg̃t@CXg\j[}
procedure TMainForm.DirFileListMenuPopup(Sender: TObject);
var
  i : Integer;
  MenuItem : TMenuItem;
  Path : String;
  FileList : TStringList;
begin
  FileList := TStringList.Create;
  try
    Path := GetDirPath(DirTree.Selected);
    GetFileList(Path,FileList);
    DirFileListMenu.Items.Clear;
    for i:=0 to FileList.Count-1 do
    begin
      MenuItem := TMenuItem.Create(Self);
      with MenuItem do
        Caption := GetMenuCaption(FileList[i],i);
      DirFileListMenu.Items.Add(MenuItem);
    end;
  finally
    FileList.Free;
  end;
end;


///////////////////////////////////////////////////////////////////////////
{vpeB}
///////////////////////////////////////////////////////////////////////////

function TMainForm.GetCommand: String;
begin
  Result := CommandEdit.Lines.Text;
end;

procedure TMainForm.SetCommand(const Value: String);
begin
  CommandEdit.Lines.Text := Value;
end;


///////////////////////////////////////////////////////////////////////////
{GUI}
///////////////////////////////////////////////////////////////////////////

{c[I}
procedure TMainForm.DirTreeChange(Sender: TObject; Node: TTreeNode);
begin
  if Node<>nil then
    Node.MakeVisible;
end;

{c[WJ/}
procedure TMainForm.DirTreeExpanded(Sender: TObject; Node: TTreeNode);
begin
  if DirTree.Selected<>nil then
    DirTree.Selected.MakeVisible;
end;
procedure TMainForm.DirTreeCollapsed(Sender: TObject; Node: TTreeNode);
begin
  if DirTree.Selected<>nil then
    DirTree.Selected.MakeVisible;
end;

{tH[TCY}
procedure TMainForm.FormResize(Sender: TObject);
begin
  //ǂݍݒpl𒲐
  LoadingPanel.Width := ClientWidth div 3 * 2;
  LoadingPanel.Left := (ClientWidth - LoadingPanel.Width)div 2;
  LoadingPanel.Top := (ClientHeight - LoadingPanel.Height)div 2;
end;

{^uL[𖳌ɂ}
procedure TMainForm.CommandEditKeyPress(Sender: TObject; var Key: Char);
begin
  if Key=#9 then
    Key := #0;
end;

{vCt@CXg̃L[}
procedure TMainForm.PlayFileListKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  i : Integer;
  nextItem : TListItem;
begin
  case Key of
    VK_BACK:
    begin
      //R}hɃtH[JX
      CommandEdit.SetFocus;
    end;
    VK_RETURN:
    begin
      //It@CĐ
      PlaySelFile;
    end;
    VK_INSERT:
    begin
      //IĂȂƂ͖
      if PlayFileList.Selected=nil then
        Exit;
      for i:=PlayFileList.Items.Count-1 downto 0 do
        if PlayFileList.Selected<>PlayFileList.Items[i] then
          PlayFileList.Items[i].Delete;
    end;
    VK_DELETE:
    begin
      //IĂȂƂ͖
      if PlayFileList.Selected=nil then
        Exit;
      //폜ɈړׂACe擾
      if PlayFileList.Selected.Index<(PlayFileList.Items.Count-1) then
        nextItem := PlayFileList.Items[PlayFileList.Selected.Index+1]
      else
      if PlayFileList.Selected.Index>0 then
        nextItem := PlayFileList.Items[PlayFileList.Selected.Index-1]
      else
        nextItem := nil;
      //폜đIړ
      PlayFileList.Selected.Delete;
      PlayFileList.Selected := nextItem;
    end;
    VK_F1..VK_F24:
    begin
      //F?
      i := Key-VK_F1;
      //?t@CȏȂ疳
      if i>=PlayFileList.Items.Count then
        Exit;
      //ꂽFL[̃gbNĐ
      PlayFileList.Selected := PlayFileList.Items[i];
      PlaySelFile;
    end;
  end;
end;

{uv{^}
procedure TMainForm.SendListBtnClick(Sender: TObject);
begin
  ShowSelDir(False);
  RepeatAllBtn.Enabled := not SendListBtn.Down;
  RandomBtn.Enabled := not SendListBtn.Down;
end;

///////////////////////////////////////////////////////////////////////////
{R}h}
///////////////////////////////////////////////////////////////////////////

{R}h}
procedure TMainForm.CmdEditChange(Sender: TObject);
begin
  if Command<>'' then
    DirTree.Selected := FindEx(Command);
end;

{R}hs}
function TMainForm.ExecCommand:Boolean;
  function ct(A,B:String):Boolean;
  begin
    Result :=
      CmpText(A,Copy(B,1,Length(A)));
  end;
var
  cmd : String;
begin
  cmd := Command;
  Result := CheckCharIn(cmd,':');
  if not Result then
    Exit;
  Command := '';
  if ct(cmd,'reload') then
    ReloadDir
  else
  if ct(cmd,'collapse') then
    DirTree.FullCollapse
  else
  if ct(cmd,'expand') then
    DirTree.FullExpand
  else
  if ct(cmd,'play') then
    PlayBtn.Click
  else
  if ct(cmd,'next') then
    NextBtn.Click
  else
  if ct(cmd,'back')or ct(cmd,'prev')then
    PrevBtn.Click
  else
  if ct(cmd,'stop') then
    StopBtn.Click
  else
  if ct(cmd,'pause') then
    PauseBtn.Click
  else
  if ct(cmd,'+volume') then
    UpVolume.Click
  else
  if ct(cmd,'-volume') then
    DownVolume.Click
  else
  if ct(cmd,'opendirectory') then
    OpenDirectory.Click
  else
  if ct(cmd,'bye')or ct(cmd,'exit')or ct(cmd,'quit') then
    Close
  ;
end;

{R}h}
procedure TMainForm.CmdEditKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  OnCtrl,OnShift : Boolean;
begin
  //
  OnCtrl := ssCtrl in Shift;
  OnShift := ssShift in Shift;
  //Vtg - ͂ PlayFileList ɗ
  if OnShift and (not OnCtrl) then
  begin
    PostMessage(PlayFileList.Handle,WM_KEYDOWN,Key,0);
    Exit;
  end;
  //VtgȊO
  case Key of
    VK_INSERT:
    begin
      //͍폜
      Command := '';
    end;
    VK_RETURN,VK_RIGHT:
    begin
      //L[͓͂Ɏg邽ߋ̎̂ݗL
      if (Key=VK_RIGHT)and(Command<>'') then
        Exit;
      //R}hH
      if ExecCommand then
        Exit;
      //͂폜 - <% Ƃ͎cĂǂH>
      Command := '';
      //I̓gbvɈڍsďI
      if DirTree.Selected=nil then
      begin
        if Root.Count>0 then
          DirTree.Selected := root[0];
        Exit;
      end;
      //t݂
      PlaySelDir(OnCtrl and OnShift);
      //Έړ
      if DirTree.Selected.getFirstChild<>nil then
        DirTree.Selected := DirTree.Selected.getFirstChild;
    end;
    VK_DELETE:
    begin
      //Iꂽm[h폜
      RemoveSelDir(DirTree.Selected);
    end;
    VK_BACK,VK_LEFT:
    begin
      //͂Ƃ͖
      if Command<>'' then
        Exit;
      //ɍs
      if DirTree.Selected<>nil then
        DirTree.Selected := DirTree.Selected.Parent;
    end;
    VK_NEXT,VK_DOWN:
    begin
      //͂H  F m[h
      if Command<>'' then
        DirTree.Selected := FindEx(Command,True,nil,False,OnCtrl)
      else
        DirTree.Selected := GetNextNode(nil,False,OnCtrl);
    end;
    VK_PRIOR,VK_UP:
    begin
      //͂H  F m[h
      if Command<>'' then
        DirTree.Selected := FindEx(Command,True,nil,True,OnCtrl)
      else
        DirTree.Selected := GetNextNode(nil,True,OnCtrl);
    end;
    VK_PAUSE:
    begin
      //vCXgɃtH[JX
      PlayFileList.SetFocus;
    end;
    VK_TAB:
    begin
      //t@CXg\
      if DirTree.Selected<>nil then
        with DirTree.Selected.DisplayRect(True) do
          with DirTree.ClientToScreen(Point(Left,Bottom)) do
            DirFileListMenu.Popup(X,Y);
    end;
    VK_ESCAPE:
    begin
      Application.Minimize;
    end;
  end;
end;


///////////////////////////////////////////////////////////////////////////
{ǂݍݒpl}
///////////////////////////////////////////////////////////////////////////

procedure TMainForm.StartLoading;
begin
  Enabled := False;
  LoadingPanel.Visible := True;
  LoadingPanel.Repaint;
end;

procedure TMainForm.EndLoading;
begin
  LoadingPanel.Visible := False;
  Enabled := True;
end;


///////////////////////////////////////////////////////////////////////////
{t}
///////////////////////////////////////////////////////////////////////////

{̃t@CɈړ}
function TMainForm.GoNextItem:TListItem;
begin
  if PlayFileList.Items.Count=0 then
  begin
    //ĐXg
    LastItemIndex := -1;
  end
  else
  if RandomBtn.Down then
  begin
    //_
    LastItemIndex := Random(PlayFileList.Items.Count);
  end
  else
  begin
    //ʏĐ - ʂɎ擾
    if LastItemIndex<0 then
    begin
      //Ō̍ĐIndex̂ŏ߂ɐݒ
      LastItemIndex := 0
    end
    else
    begin
      //IndexXV
      Inc(LastItemIndex);
      //Index͈͂𒴂H-s[gH ߂ɖ߂ F ĐȂ
      if LastItemIndex>=PlayFileList.Items.Count then
        if RepeatAllBtn.Down then
          LastItemIndex := 0
        else
          LastItemIndex := -1;
    end;
  end;
  //ړ
  if LastItemIndex>=0 then
    Result := PlayFileList.Items[LastItemIndex]
  else
    Result := nil;
  PlayFileList.Selected := Result;
  if Result<>nil then
    Result.Focused := True;
end;

{̃t@CɈړ}
function TMainForm.GoPrevItem:TListItem;
begin
  if PlayFileList.Items.Count=0 then
  begin
    //ĐXg
    LastItemIndex := -1;
  end
  else
  if RandomBtn.Down then
  begin
    //_
    LastItemIndex := Random(PlayFileList.Items.Count);
  end
  else
  begin
    //ʏĐ - ʂɎ擾
    if LastItemIndex<0 then
    begin
      //Ō̍ĐIndex̂ŏ߂ɐݒ
      LastItemIndex := 0
    end
    else
    begin
      //IndexXV
      Dec(LastItemIndex);
      //Index͈͂𒴂H-s[gH ߂ɖ߂ F ĐȂ
      if LastItemIndex>=PlayFileList.Items.Count then
        if RepeatAllBtn.Down then
          LastItemIndex := 0
        else
          LastItemIndex := -1;
    end;
  end;
  //ړ
  if LastItemIndex>=0 then
    Result := PlayFileList.Items[LastItemIndex]
  else
    Result := nil;
  PlayFileList.Selected := Result;
  if Result<>nil then
    Result.Focused := True;
end;

{IĂfBNg\}
function TMainForm.ShowSelDir(Recurse:Boolean=False):Boolean;
var
  TempFileList : TStringList;
  function Exists(path:String):Boolean;
  var
    Rec     : TSearchRec;
  begin
    Result  := FindFirst(path + '\*.mp3', faAnyFile, Rec) = 0;
    FindClose(Rec);
  end;
var
  i : Integer;
  path : String;
  NewItem : TListItem;
begin
  Result := False;
  //pX
  path := GetDirPath(DirTree.Selected);
  //ċAŃt@C݂Ȃꍇ͒~
  if (not Exists(path)) and (not Recurse) then
    Exit;
  Result := True;
  //tĂΒ~
  if MP3Player.Status=mstStop then
    MP3Player.Stop;
  //Xg
  PlayFileList.Items.Clear;
  //t@CXg
  TempFileList := TStringList.Create;
  try
    //t@C
    GetFileList(path,TempFileList,Recurse);
    //t@CXgr[ɒǉ
    for i:=0 to TempFileList.Count-1 do
    begin
      NewItem := PlayFileList.Items.Add;
      NewItem.Data := NewPStr(TempFileList[i]);
      NewItem.Caption := GetFileListCaption(NewItem);
    end;
    if SendListBtn.Down then
    begin
      NewItem := PlayFileList.Items.Insert(0);
      NewItem.Data := NewPStr(TempFileList.Text);
      NewItem.Caption := '*ALL*';
    end;
  finally
    TempFileList.Free;
  end;
  LastItemIndex := -1;
  GoNextItem;
end;

{IĂfBNgt}
function TMainForm.PlaySelDir(Recurse:Boolean=False):Boolean;
begin
  Result := ShowSelDir(Recurse);
  if SendListBtn.Down then
    Exit;
  if Result then
    PlaySelFile;
end;

{IĂt@Ct}
procedure TMainForm.PlaySelFile;
begin
  //IĂȂΒ~
  if PlayFileList.Selected=nil then
    Exit;
  //t͈x
  MP3Player.Stop;
  //ĐʒuĐݒ
  LastItemIndex := PlayFileList.Selected.Index;
  //ĐJn
  if SendListBtn.Down then
    OApp_AddFiles(PString(PlayFileList.Selected.Data)^)
  else
    MP3Player.FileName := PString(PlayFileList.Selected.Data)^;
end;

{Đ}
procedure TMainForm.PlayNext;
begin
  GoNextItem;
  PlaySelFile;
end;

{OĐ}
procedure TMainForm.PlayPrev;
begin
  GoPrevItem;
  PlaySelFile;
end;

{c[_uNbN}
procedure TMainForm.DirTreeDblClick(Sender: TObject);
begin
  PlaySelDir(GetKeyStat(VK_CONTROL));
end;

{c[L[}
procedure TMainForm.DirTreeKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  //L[͂𖳌
  CommandEdit.SetFocus;
  PostMessage(CommandEdit.Handle,WM_KEYDOWN,Key,0);
end;

{vCt@CXg̃_uNbN}
procedure TMainForm.PlayFileListDblClick(Sender: TObject);
begin
  PlaySelFile;
end;

{tH[ŏ}
procedure TMainForm.ApplicationEvents1Minimize(Sender: TObject);
begin
  //ŏtO
  Minimized := True;
  //ACRǉ
  with NID do
  begin
    cbSize    := Sizeof(NID);
    hIcon     := Application.Icon.Handle;
    Wnd       := MainForm.Handle;
    uCallbackMessage := WM_TRAY;
    uFlags := NIF_MESSAGE or NIF_ICON or NIF_TIP ;
  end;
  Shell_NotifyIcon(NIM_ADD, @NID);
  ShowWindow(Application.Handle,SW_HIDE);
end;

{zbgL[ꂽƂ}
procedure TMainForm.WMHotKey(var Msg: TWMHotKey);
begin
  if Msg.HotKey = ActiveHotkey then
  begin
    if Minimized then
      Application.Restore
    else
      DoActive;
  end
  else
  if Msg.HotKey = VolUpHotkey then
    UpVolume.Click
  else
  if Msg.HotKey = VolDownHotkey then
    DownVolume.Click;
end;

{ACRbZ[W}
procedure TMainForm.WMTRAY(var Msg: TMsg);
begin
  //{^ŃXgA
  if (Msg.wParam = WM_LBUTTONDOWN) then
    Application.Restore;
end;

{tH[XgA}
procedure TMainForm.ApplicationEvents1Restore(Sender: TObject);
begin
  //ŏtO
  Minimized := False;
  //ACR폜
  Shell_NotifyIcon(NIM_DELETE, @NID);
  //^XNo[A
  ShowWindow(Application.Handle,SW_SHOW);
  //ANeBu
  DoActive;
end;

{ʒuo[ύX}
procedure TMainForm.PosBarScroll(Sender: TObject; ScrollCode: TScrollCode;
  var ScrollPos: Integer);
begin
  if ScrollCode=scEndScroll then
  begin
    MP3Player.Seek(ScrollPos);
    PosBarScrolln := False;
  end
  else
  if ScrollCode=scTrack then
    PosBarScrolln := True; 
end;

{ʃo[ύX}
procedure TMainForm.VolBarScroll(Sender: TObject; ScrollCode: TScrollCode;
  var ScrollPos: Integer);
begin
  if ScrollCode=scEndScroll then
  begin
    if SendListBtn.Down then
      OApp_SetVolume(ScrollPos)
    else
      MP3Player.Volume := ScrollPos;
  end;
end;

{tH[Ŝ̃L[(ǂł)}
procedure TMainForm.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  //
end;

///////////////////////////////////////////////////////////////////////////
{{^}
///////////////////////////////////////////////////////////////////////////

{|[Y}
procedure TMainForm.PauseBtnClick(Sender: TObject);
begin
  if SendListBtn.Down then
    OApp_Pause
  else
  begin
    if MP3Player.Status=mstPause then
      MP3Player.Unpause
    else
    if MP3Player.Status=mstPlay then
      MP3Player.Pause
  end;
end;

{Đ}
procedure TMainForm.PlayBtnClick(Sender: TObject);
begin
  if SendListBtn.Down then
    OApp_Play
  else
    MP3Player.Play;
end;

{Xgbv}
procedure TMainForm.StopBtnClick(Sender: TObject);
begin
  if SendListBtn.Down then
    OApp_Stop
  else
    MP3Player.Stop
end;

{O}
procedure TMainForm.PrevBtnClick(Sender: TObject);
begin
  if SendListBtn.Down then
    OApp_Prev
  else
    PlayPrev;
end;

{}
procedure TMainForm.NextBtnClick(Sender: TObject);
begin
  if SendListBtn.Down then
    OApp_Next
  else
    PlayNext;
end;

{+}
procedure TMainForm.UpVolumeClick(Sender: TObject);
var
  v : Integer;
begin
  VolBar.Position := VolBar.Position+10;
  v := VolBar.Position;
  VolBar.OnScroll(VolBar,scEndScroll,v);
end;

{-}
procedure TMainForm.DownVolumeClick(Sender: TObject);
var
  v : Integer;
begin
  VolBar.Position := VolBar.Position-10;
  v := VolBar.Position;
  VolBar.OnScroll(VolBar,scEndScroll,v);
end;

{}
procedure TMainForm.OpenDirectoryClick(Sender: TObject);
begin
  ShellExpOpen(GetDirPath(DirTree.Selected),'/e,/root');//
end;


///////////////////////////////////////////////////////////////////////////
{vCCxg}
///////////////////////////////////////////////////////////////////////////

{vC̏ԕύX}
procedure TMainForm.MP3PlayerChangeStatus(Sender: TObject);
begin
  case MP3Player.Status of
    mstPlay:
    begin
      Application.Title :=  GetFormCaption(PlayFileList.Items[LastItemIndex]);
      SetTrayTip(GetFormCaption(PlayFileList.Items[LastItemIndex]));
      Caption := Application.Title;
    end;
  end;
end;

{tI}
procedure TMainForm.MP3PlayerEndPlay(Sender: TObject;
  Reason: TMP3EndPlayReason);
begin
  //ȊȌI͖
  if Reason <> merSuccessful then
    Exit;
  //t@CXg͖̎
  if PlayFileList.Items.Count=0 then
    Exit;
  //Ɉړ
  GoNextItem;
  //t
  PlaySelFile;
end;

{Đʒu}
procedure TMainForm.MP3PlayerChangePosition(Sender: TObject);
begin
  if PosBarScrolln then
    Exit;
  PosBar.Max := MP3Player.Length;
  PosBar.Position := MP3Player.Position;
end;

///////////////////////////////////////////////////////////////////////////
{D&D}
///////////////////////////////////////////////////////////////////////////

procedure TMainForm.WMDropfiles(var Msg: TWMDropfiles);
var
  d : Boolean;
  i,count: integer;
  path : Array[0..65535] of Char;
begin
  count := dragqueryfile(msg.drop,Cardinal(-1),nil,0);
  d := False;
  for i := 0 to count -1 do
  begin
    dragqueryfile(msg.drop,i,path,SizeOf(path));
    if DirectoryExists(path) then
    begin
      AddRootNode(path);
      d := true;
    end;
  end;
  //fBNgǉꂽƂ
  if d then
    LoadDir;
end;

///////////////////////////////////////////////////////////////////////////
{̎j[}
///////////////////////////////////////////////////////////////////////////

procedure TMainForm.DarkLyricscom1Click(Sender: TObject);
begin
  if PlayFileList.Selected<>nil then
    OpenURL(URL_DarkLyricsCom(GetFileInfo(PlayFileList.Selected)));
end;
procedure TMainForm.Song365com1Click(Sender: TObject);
begin
  if PlayFileList.Selected<>nil then
    OpenURL(URL_Sing365Com(GetFileInfo(PlayFileList.Selected)));
end;

///////////////////////////////////////////////////////////////////////////
{Data̕}
///////////////////////////////////////////////////////////////////////////

{c[}
procedure TMainForm.DirTreeDeletion(Sender: TObject; Node: TTreeNode);
begin 
  if Node.Data<>nil then
    Dispose(PString(Node.Data));
end;

{t@CXg}
procedure TMainForm.PlayFileListDeletion(Sender: TObject; Item: TListItem);
begin 
  if Item.Data<>nil then
    Dispose(PString(Item.Data));
end;

///////////////////////////////////////////////////////////////////////////
{TvOCgύX}
///////////////////////////////////////////////////////////////////////////

{TvOCgύX - ~>ĐŊJ}
procedure TMainForm.ChangeSamplingRate(APer:Integer);
{$IFDEF ANEKOS}
  var
    LastStatus : TMP3Status;
    SeekPos : Integer;
{$ENDIF}
begin
  {$IFDEF ANEKOS}
    with MP3Player do
    begin
      LastStatus := Status;
      SeekPos := Position;
      if Status<>mstStop then
        Stop;
      SamplingRatePer := APer;
      case LastStatus of
        mstPlay:
        begin
          Play;
          Seek(SeekPos);
        end;
        mstPause:
        begin
          Play;
          Seek(SeekPos);
          Pause;
        end;
      end;
    end;
  {$ENDIF}
end;

{XN[o[ł̕ύX}
procedure TMainForm.PitchBarScroll(Sender: TObject;
  ScrollCode: TScrollCode; var ScrollPos: Integer);
begin
  if ScrollCode=scEndScroll then
    ChangeSamplingRate(ScrollPos);
end;

{100%ɖ߂}
procedure TMainForm.PitClick(Sender: TObject);
begin
  {$IFDEF ANEKOS}
    PitchBar.Position := 100;
    ChangeSamplingRate(100);
  {$ENDIF}
end;

///////////////////////////////////////////////////////////////////////////
{gC}
///////////////////////////////////////////////////////////////////////////

{^XNgCTipύX}
procedure TMainForm.SetTrayTip(const Value: String);
begin
  FTrayTip := Value;
  if FTrayTip = '' then
  begin
    NID.szTip[0] := #0;
  end
  else begin
    StrPLCopy(@NID.szTip, PChar(FTrayTip), 63);
  end;
end;


end.
