{
    MP3Player - Free Delphi Component
    Copyright (C) 1999  Kei Ishida

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
}
{$define ASM_X86}
//{$define _USE_REDUCTION_}
//{$define UseIntegerDecoder}
unit MP3decdr;

interface

uses
  Windows, SysUtils;


type
  TInOut = record
    InBytes: Integer;
    OutBytes: Integer;
  end;

  TBitDat = record
    BitBuf: Cardinal;
    Bits: Integer;
    BsPtr: PChar;
    BsPtr0: PChar;
    BsPtrEnd: PChar;
  end;
  PBitDat = ^TBitDat;

  TMpegHead = record
    Sync: Integer;
    ID: Integer;
    Option: Integer;
    Prot: Integer;
    BrIndex: Integer;
    SrIndex: Integer;
    Pad: Integer;
    PrivateBit: Integer;
    Mode: Integer;
    ModeExt: Integer;
    Cr: Integer;
    Original: Integer;
    Emphasis: Integer;
  end;
  PMpegHead = ^TMpegHead;
  TMpegRawHead = DWORD;
  PMpegRawHead = ^TMpegRawHead;

  TDecInfo = record
    Channels: Integer;
    Outvalues: Integer;
    Samprate: LongInt;
    Bits: Integer;
    Framebytes: Integer;
    DecType: Integer;
  end;
  PDecInfo = ^TDecInfo;


procedure _set_cpu_caps(caps: Integer); cdecl; external;

procedure _sbt_mono(sample: PSingle;  pcm: PSmallInt; n: Integer);  cdecl; external;
procedure _sbt_dual(sample: PSingle;  pcm: PSmallInt; n: Integer);  cdecl; external;
procedure _sbt_dual_mono(sample: PSingle;  pcm: PSmallInt; n: Integer);  cdecl; external;
procedure _sbt_dual_left(sample: PSingle;  pcm: PSmallInt; n: Integer);  cdecl; external;
procedure _sbt_dual_right(sample: PSingle;  pcm: PSmallInt; n: Integer);  cdecl; external;
{$ifdef _USE_REDUCTION_}
procedure _sbt16_mono(sample: PSingle;  pcm: PSmallInt; n: Integer);  cdecl; external;
procedure _sbt16_dual(sample: PSingle;  pcm: PSmallInt; n: Integer);  cdecl; external;
procedure _sbt16_dual_mono(sample: PSingle;  pcm: PSmallInt; n: Integer);  cdecl; external;
procedure _sbt16_dual_left(sample: PSingle;  pcm: PSmallInt; n: Integer);  cdecl; external;
procedure _sbt16_dual_right(sample: PSingle;  pcm: PSmallInt; n: Integer);  cdecl; external;
procedure _sbt8_mono(sample: PSingle;  pcm: PSmallInt; n: Integer);  cdecl; external;
procedure _sbt8_dual(sample: PSingle;  pcm: PSmallInt; n: Integer);  cdecl; external;
procedure _sbt8_dual_mono(sample: PSingle;  pcm: PSmallInt; n: Integer);  cdecl; external;
procedure _sbt8_dual_left(sample: PSingle;  pcm: PSmallInt; n: Integer);  cdecl; external;
procedure _sbt8_dual_right(sample: PSingle;  pcm: PSmallInt; n: Integer);  cdecl; external;
procedure _sbtB_mono(sample: PSingle;  pcm: PChar; n: Integer);  cdecl; external;
procedure _sbtB_dual(sample: PSingle;  pcm: PChar; n: Integer);  cdecl; external;
procedure _sbtB_dual_mono(sample: PSingle;  pcm: PChar; n: Integer);  cdecl; external;
procedure _sbtB_dual_left(sample: PSingle;  pcm: PChar; n: Integer);  cdecl; external;
procedure _sbtB_dual_right(sample: PSingle;  pcm: PChar; n: Integer);  cdecl; external;
procedure _sbtB16_mono(sample: PSingle;  pcm: PChar; n: Integer);  cdecl; external;
procedure _sbtB16_dual(sample: PSingle;  pcm: PChar; n: Integer);  cdecl; external;
procedure _sbtB16_dual_mono(sample: PSingle;  pcm: PChar; n: Integer);  cdecl; external;
procedure _sbtB16_dual_left(sample: PSingle;  pcm: PChar; n: Integer);  cdecl; external;
procedure _sbtB16_dual_right(sample: PSingle;  pcm: PChar; n: Integer);  cdecl; external;
procedure _sbtB8_mono(sample: PSingle;  pcm: PChar; n: Integer);  cdecl; external;
procedure _sbtB8_dual(sample: PSingle;  pcm: PChar; n: Integer);  cdecl; external;
procedure _sbtB8_dual_mono(sample: PSingle;  pcm: PChar; n: Integer);  cdecl; external;
procedure _sbtB8_dual_left(sample: PSingle;  pcm: PChar; n: Integer);  cdecl; external;
procedure _sbtB8_dual_right(sample: PSingle;  pcm: PChar; n: Integer);  cdecl; external;
{$endif}

{$ifdef UseIntegerDecoder}
procedure _i_sbt_mono(sample: PInteger; pcm: PSmallInt; n: Integer);  cdecl; external;
procedure _i_sbt_dual(sample: PInteger; pcm: PSmallInt; n: Integer);  cdecl; external;
procedure _i_sbt_dual_mono(sample: PInteger; pcm: PSmallInt; n: Integer);  cdecl; external;
procedure _i_sbt_dual_left(sample: PInteger; pcm: PSmallInt; n: Integer);  cdecl; external;
procedure _i_sbt_dual_right(sample: PInteger; pcm: PSmallInt; n: Integer);  cdecl; external;
procedure _i_sbt16_mono(sample: PInteger; pcm: PSmallInt; n: Integer);  cdecl; external;
procedure _i_sbt16_dual(sample: PInteger; pcm: PSmallInt; n: Integer);  cdecl; external;
procedure _i_sbt16_dual_mono(sample: PInteger; pcm: PSmallInt; n: Integer);  cdecl; external;
procedure _i_sbt16_dual_left(sample: PInteger; pcm: PSmallInt; n: Integer);  cdecl; external;
procedure _i_sbt16_dual_right(sample: PInteger; pcm: PSmallInt; n: Integer);  cdecl; external;
procedure _i_sbt8_mono(sample: PInteger; pcm: PSmallInt; n: Integer);  cdecl; external;
procedure _i_sbt8_dual(sample: PInteger; pcm: PSmallInt; n: Integer);  cdecl; external;
procedure _i_sbt8_dual_mono(sample: PInteger; pcm: PSmallInt; n: Integer);  cdecl; external;
procedure _i_sbt8_dual_left(sample: PInteger; pcm: PSmallInt; n: Integer);  cdecl; external;
procedure _i_sbt8_dual_right(sample: PInteger; pcm: PSmallInt; n: Integer);  cdecl; external;

procedure _i_sbtB_mono(sample: PInteger; pcm: PChar; n: Integer);  cdecl; external;
procedure _i_sbtB_dual(sample: PInteger; pcm: PChar; n: Integer);  cdecl; external;
procedure _i_sbtB_dual_mono(sample: PInteger; pcm: PChar; n: Integer);  cdecl; external;
procedure _i_sbtB_dual_left(sample: PInteger; pcm: PChar; n: Integer);  cdecl; external;
procedure _i_sbtB_dual_right(sample: PInteger; pcm: PChar; n: Integer);  cdecl; external;
procedure _i_sbtB16_mono(sample: PInteger; pcm: PChar; n: Integer);  cdecl; external;
procedure _i_sbtB16_dual(sample: PInteger; pcm: PChar; n: Integer);  cdecl; external;
procedure _i_sbtB16_dual_mono(sample: PInteger; pcm: PChar; n: Integer);  cdecl; external;
procedure _i_sbtB16_dual_left(sample: PInteger; pcm: PChar; n: Integer);  cdecl; external;
procedure _i_sbtB16_dual_right(sample: PInteger; pcm: PChar; n: Integer);  cdecl; external;
procedure _i_sbtB8_mono(sample: PInteger; pcm: PChar; n: Integer);  cdecl; external;
procedure _i_sbtB8_dual(sample: PInteger; pcm: PChar; n: Integer);  cdecl; external;
procedure _i_sbtB8_dual_mono(sample: PInteger; pcm: PChar; n: Integer);  cdecl; external;
procedure _i_sbtB8_dual_left(sample: PInteger; pcm: PChar; n: Integer);  cdecl; external;
procedure _i_sbtB8_dual_right(sample: PInteger; pcm: PChar; n: Integer);  cdecl; external;

function _i_audio_decode_init(const h: TMpegHead; framebytes_arg: Integer;
   reduction_code: Integer; transform_code: Integer; convert_code: Integer;
     freq_limit: Integer): Integer;  cdecl; external;
procedure _i_audio_decode_info(var info: TDecInfo);  cdecl; external;
function _i_audio_decode(var bs, pcm): TInOut;  cdecl; external;
procedure _i_sbt_init;  cdecl; external;

function _i_dct_coef_addr: PInteger;  cdecl; external;

procedure _i_dct32(sample: PInteger; vbuf: PInteger);  cdecl; external;
procedure _i_dct32_dual(sample: PInteger; vbuf: PInteger);  cdecl; external;
procedure _i_dct32_dual_mono(sample: PInteger; vbuf: PInteger);  cdecl; external;

procedure _i_dct16(sample: PInteger; vbuf: PInteger);  cdecl; external;
procedure _i_dct16_dual(sample: PInteger; vbuf: PInteger);  cdecl; external;
procedure _i_dct16_dual_mono(sample: PInteger; vbuf: PInteger);  cdecl; external;

procedure _i_dct8(sample: PInteger; vbuf: PInteger);  cdecl; external;
procedure _i_dct8_dual(sample: PInteger; vbuf: PInteger);  cdecl; external;
procedure _i_dct8_dual_mono(sample: PInteger; vbuf: PInteger);  cdecl; external;
{$endif}

function _L1audio_decode(var bs,  pcm): TInOut;  cdecl; external;
function _L2audio_decode(var bs,  pcm): TInOut;  cdecl; external;
function _L3audio_decode(var bs,  pcm): TInOut;  cdecl; external;
function _audio_decode(var bs, pcm): TInOut;  cdecl; external;

function _L1audio_decode_init(var h: TMpegHead; framebytes_arg: Integer;
       reduction_code: Integer; transform_code: Integer; convert_code: Integer;
      freq_limit: Integer): Integer;  cdecl; external;
function _L3audio_decode_init(var h: TMpegHead; framebytes_arg: Integer;
       reduction_code: Integer; transform_code: Integer; convert_code: Integer;
      freq_limit: Integer): Integer;  cdecl; external;

function _quant_init_global_addr: PSingle;  cdecl; external;
function _quant_init_scale_addr: Pointer;  cdecl; external;
function _quant_init_pow_addr: PSingle;  cdecl; external;
function _quant_init_subblock_addr: PSingle;  cdecl; external;

function _hwin_init_addr: Pointer;  cdecl; external;
function _bitget(n: Integer): Cardinal;  cdecl; external;
function _bitget_lb(n: Integer): Cardinal;  cdecl; external;
function _bitget2(n: Integer): Cardinal;  cdecl; external;

function _head_info(const buf; n: Cardinal; var h: TMpegHead): Integer;  cdecl; external;
function _head_info2(const buf; n: Cardinal; var h: TMpegHead; var br: Integer): Integer;  cdecl; external;
function _head_info3(const buf; n: Cardinal; var h: TMpegHead; var br: Integer; var searchForward: Cardinal): Integer;  cdecl; external;

function _audio_decode_init(const h: TMpegHead; framebytes_arg: Integer;
   reduction_code: Integer; transform_code: Integer; convert_code: Integer;
   freq_limit: Integer): Integer;  cdecl; external;
procedure _audio_decode_info(var info: TDecInfo);  cdecl; external;

{$ifdef _USE_REDUCTION_}
function _audio_decode8_init(var h: TMpegHead; framebytes_arg: Integer;
   reduction_code: Integer; transform_code: Integer; convert_code: Integer;
    freq_limit: Integer): Integer;  cdecl; external;
procedure _audio_decode8_info(var info: TDecInfo);  cdecl; external;
function _audio_decode8(var bs, pcm): TInOut;  cdecl; external;
{$endif}

function _equalizer_addr(n: Integer): PSingle; cdecl; external;
function _enableEQ_addr: PInteger; cdecl; external;
function _n_equalizer_addr(n: Integer):PSingle; cdecl; external;
function _n_enableEQ_addr: PInteger; cdecl; external;

procedure _set_invert_polarity(invert: Integer); cdecl; external;
function _get_invert_polarity: Integer; cdecl; external;

implementation

uses
  Math;


var
  __turboFloat: LongBool = False;

procedure _memmove(dest, source: Pointer; count: Integer);cdecl;
begin
  Move(source^, dest^, count);
end;

procedure _memset(P: Pointer; B: Byte; count: Integer);cdecl;
begin
  FillChar(P^, count, B);
end;

function _sin(x: Double): Double; cdecl;
begin
  Result := System.Sin(x);
end;

function _cos(x: Double): Double; cdecl;
begin
  Result := System.Cos(x);
end;

function _atan(x: Double): Double; cdecl;
begin
  Result := System.ArcTan(x);
end;

function _pow(x, y: Double): Double; cdecl;
begin
  Result := Math.Power(x, y);
end;

function _sqrt(x: Double): Double; cdecl;
begin
  Result := System.Sqrt(x);
end;

function  _fabs(x: Double): Double; cdecl;
begin
  Result := System.abs(x);
end;

function __ftol: Integer;
var
  f: double;
begin
  asm
    lea    eax, f
    fstp  qword ptr [eax]
  end;
  Result := Trunc(f);
end;

{$link 'cpucaps.obj'}
{$link 'mhead.obj'}
{$link 'cupl3.obj'}
{$link 'csbt.obj'}
{$link 'cdct.obj'}
{$link 'cup.obj'}
{$link 'cwinm.obj'}
{$ifdef _USE_REDUCTION_}
{$link 'dec8.obj'}
{$endif}
{$link 'hwin.obj'}
{$link 'l3dq.obj'}
{$link 'l3init.obj'}
{$link 'mdct.obj'}
{$link 'msis.obj'}
{$link 'uph.obj'}
{$link 'upsf.obj'}
{$link 'narroweq.obj'}

{$ifdef UseIntegerDecoder}
{$link 'icdct.obj'}
{$link 'isbt.obj'}
{$link 'iup.obj'}
{$link 'iwinm.obj'}
{$endif}


{$ifdef ASM_X86}
{$link 'msisasm.obj'}
{$link 'mdctasm.obj'}
{$link 'mdctasmP5.obj'}
{$link 'mdctasm3dn.obj'}
{$link 'cdctasm.obj'}
{$link 'cwin8asm.obj'}
{$link 'cwinasm.obj'}
{$link 'cupL3asm.obj'}
{$endif}

{$link vars.obj}

end.


