/*
	for MP3Player - Free Delphi Component (OCT. 1999)

        MP3 Decoder originally Copyright (C) 1995-1997 Xing Technology
        Corp.  http://www.xingtech.com
		
		FreeAmp - The Free MP3 Player
		Portions Copyright (C) 1998 GoodNoise

	Portions Copyright (C) 1999 Kei Ishida  kei-i@sams.co.jp

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
____________________________________________________________________________*/

/****  cwin.c  ***************************************************

include to cwinm.c

MPEG audio decoder, float window routines
portable C

******************************************************************/

#include "config.h"
#include "haveunit.h"

void (*window)(float *a, int b, short *c);
void (*window_dual)(float *vbuf, int vb_ptr, short *pcm);



/*-------------------------------------------------------------------------*/
#ifdef ASM_X86
extern void window_3dn(float *a, int b, short *c);
extern void window_e3dn_emmx(float *a, int b, short *c);
extern void window_fpu(float *a, int b, short *c);
extern void window_p5(float *a, int b, short *c);
extern void window_p6_cmov(float *a, int b, short *c);
#else
void window_c(float *vbuf, int vb_ptr, short *pcm)
{
   int i, j;
   int si, bx;
   float *coef;
   float sum;
   long tmp;

   si = vb_ptr + 16;
   bx = (si + 32) & 511;
   coef = wincoef;

/*-- first 16 --*/
   for (i = 0; i < 16; i++)
   {
      sum = 0.0F;
      for (j = 0; j < 8; j++)
      {
	 sum += (*coef++) * vbuf[si];
	 si = (si + 64) & 511;
	 sum -= (*coef++) * vbuf[bx];
	 bx = (bx + 64) & 511;
      }
      si++;
      bx--;
      tmp = (long) sum;
      if (tmp > 32767)
	 tmp = 32767;
      else if (tmp < -32768)
	 tmp = -32768;
      *pcm++ = tmp;
   }
/*--  special case --*/
   sum = 0.0F;
   for (j = 0; j < 8; j++)
   {
      sum += (*coef++) * vbuf[bx];
      bx = (bx + 64) & 511;
   }
   tmp = (long) sum;
   if (tmp > 32767)
      tmp = 32767;
   else if (tmp < -32768)
      tmp = -32768;
   *pcm++ = tmp;
/*-- last 15 --*/
   coef = wincoef + 255;	/* back pass through coefs */
   for (i = 0; i < 15; i++)
   {
      si--;
      bx++;
      sum = 0.0F;
      for (j = 0; j < 8; j++)
      {
	 sum += (*coef--) * vbuf[si];
	 si = (si + 64) & 511;
	 sum += (*coef--) * vbuf[bx];
	 bx = (bx + 64) & 511;
      }
      tmp = (long) sum;
      if (tmp > 32767)
	 tmp = 32767;
      else if (tmp < -32768)
	 tmp = -32768;
      *pcm++ = tmp;
   }
}
#endif

void set_cpu_caps_window(int caps)
{
#ifdef ASM_X86
    if (caps & tE3DN && caps & tEMMX) {
        window = window_e3dn_emmx;
    } else
    if (caps & t3DN) {
        window = window_3dn;
    
    } else 
    if ((caps & tINTEL) && (caps & (tFAMILY5|tFAMILY6)) && (caps & tCMOV)) {
        window = window_p6_cmov;
    
    } else 
    if ((caps & tINTEL) && (caps & (tFAMILY5|tFAMILY6)) ) {
        window = window_p5;
    
    } else 
    {
        window = window_fpu;
    }
#else
    {
        window = window_c;
    }
#endif
}

/*------------------------------------------------------------*/
#ifdef ASM_X86
extern void window_dual_fpu(float *a, int b, short *c);
extern void window_dual_3dn(float *a, int b, short *c);
extern void window_dual_e3dn_emmx(float *a, int b, short *c);
extern void window_dual_p5(float *a, int b, short *c);
extern void window_dual_p6_cmov(float *a, int b, short *c);

#else

#if 0
/*  asm  e3dn ł̌ */
void window_dual_e3dn_base(float *vbuf, int vb_ptr, short *pcm)
{
   int i, j;
   int si, bx;
   int si1, bx1;
   float *coef;
   float sum, sum0, sum1;
   long tmp;

   si = vb_ptr + 16;
   bx = (si + 32) & 511;
   coef = wincoef;

/*-- first 16 --*/
   for (i = 0; i < 16; i+= 2)
   {
      sum0 = 0.0F;
      sum1 = 0.0f;
      
	   si1 = si+1;
	   bx1 = bx-1;
	   
      for (j = 0; j < 8; j+=2)
      {
		 sum0 += (*(coef+j*2+0)) * vbuf[si];
		 si = (si + 64) & 511;
		 sum0 -= (*(coef+j*2+1)) * vbuf[bx];
		 bx = (bx + 64) & 511;

		 sum1 += (*(coef+j*2+16)) * vbuf[si1];
		 si1 = (si1 + 64) & 511;
		 sum1 -= (*(coef+j*2+17)) * vbuf[bx1];
		 bx1 = (bx1 + 64) & 511;
		 
		 sum0 += (*(coef+j*2+2)) * vbuf[si];
		 si = (si + 64) & 511;
		 sum0 -= (*(coef+j*2+3)) * vbuf[bx];
		 bx = (bx + 64) & 511;

		 sum1 += (*(coef+j*2+18)) * vbuf[si1];
		 si1 = (si1 + 64) & 511;
		 sum1 -= (*(coef+j*2+19)) * vbuf[bx1];
		 bx1 = (bx1 + 64) & 511;
      }
      si = si1+1;
      bx = bx1-1;

      coef += 32;

      tmp = (long) sum0;
      if (tmp > 32767)
	 tmp = 32767;
      else if (tmp < -32768)
	 tmp = -32768;
	*pcm = tmp;
    pcm += 2;

      tmp = (long) sum1;
      if (tmp > 32767)
	 tmp = 32767;
      else if (tmp < -32768)
	 tmp = -32768;
	*pcm = tmp;
    pcm += 2;
   }
/*--  special case --*/
   sum = 0.0F;
   for (j = 0; j < 8; j++)
   {
      sum += (*coef++) * vbuf[bx];
      bx = (bx + 64) & 511;
   }
   tmp = (long) sum;
   if (tmp > 32767)
      tmp = 32767;
   else if (tmp < -32768)
      tmp = -32768;
	*pcm = tmp;
    pcm += 2;
/*-- last 15 --*/
   coef = wincoef + 255;	/* back pass through coefs */
   {
      sum0 = 0.0F;
      si--;
      bx++;
      
      for (j = 0; j < 8; j+=2)
      {
		 sum0 += (*(coef-j*2-0)) * vbuf[si];
		 si = (si + 64) & 511;
		 sum0 += (*(coef-j*2-1)) * vbuf[bx];
		 bx = (bx + 64) & 511;

		 sum0 += (*(coef-j*2-2)) * vbuf[si];
		 si = (si + 64) & 511;
		 sum0 += (*(coef-j*2-3)) * vbuf[bx];
		 bx = (bx + 64) & 511;
      }
      
      coef -= 16;

      tmp = (long) sum0;
      if (tmp > 32767)
	 tmp = 32767;
      else if (tmp < -32768)
	 tmp = -32768;
	*pcm = tmp;
    pcm += 2;
   }
   for (i = 1; i < 15; i+=2)
   {
      sum0 = 0.0F;
      sum1 = 0.0F;
      si--;
      bx++;
      
      si1 = si-1;
      bx1 = bx+1;
      
      for (j = 0; j < 8; j++)
      {
		 sum0 += (*(coef-j*2-0)) * vbuf[si];
		 si = (si + 64) & 511;
		 sum0 += (*(coef-j*2-1)) * vbuf[bx];
		 bx = (bx + 64) & 511;

		 sum1 += (*(coef-j*2-16)) * vbuf[si1];
		 si1 = (si1 + 64) & 511;
		 sum1 += (*(coef-j*2-17)) * vbuf[bx1];
		 bx1 = (bx1 + 64) & 511;
      }
      
      si = si1;
      bx = bx1;
      coef -= 32;

      tmp = (long) sum0;
      if (tmp > 32767)
	 tmp = 32767;
      else if (tmp < -32768)
	 tmp = -32768;
	*pcm = tmp;
    pcm += 2;

      tmp = (long) sum1;
      if (tmp > 32767)
	 tmp = 32767;
      else if (tmp < -32768)
	 tmp = -32768;
	*pcm = tmp;
    pcm += 2;
   }
}
#endif

void window_dual_c(float *vbuf, int vb_ptr, short *pcm)
{
   int i, j;			/* dual window interleaves output */
   int si, bx;
   float *coef;
   float sum;
   long tmp;

   si = vb_ptr + 16;
   bx = (si + 32) & 511;
   coef = wincoef;

/*-- first 16 --*/
   for (i = 0; i < 16; i++)
   {
      sum = 0.0F;
      for (j = 0; j < 8; j++)
      {
	 sum += (*coef++) * vbuf[si];
	 si = (si + 64) & 511;
	 sum -= (*coef++) * vbuf[bx];
	 bx = (bx + 64) & 511;
      }
      si++;
      bx--;
      tmp = (long) sum;
      if (tmp > 32767)
	 tmp = 32767;
      else if (tmp < -32768)
	 tmp = -32768;
      *pcm = tmp;
      pcm += 2;
   }
/*--  special case --*/
   sum = 0.0F;
   for (j = 0; j < 8; j++)
   {
      sum += (*coef++) * vbuf[bx];
      bx = (bx + 64) & 511;
   }
   tmp = (long) sum;
   if (tmp > 32767)
      tmp = 32767;
   else if (tmp < -32768)
      tmp = -32768;
   *pcm = tmp;
   pcm += 2;
/*-- last 15 --*/
   coef = wincoef + 255;	/* back pass through coefs */
   for (i = 0; i < 15; i++)
   {
      si--;
      bx++;
      sum = 0.0F;
      for (j = 0; j < 8; j++)
      {
	 sum += (*coef--) * vbuf[si];
	 si = (si + 64) & 511;
	 sum += (*coef--) * vbuf[bx];
	 bx = (bx + 64) & 511;
      }
      tmp = (long) sum;
      if (tmp > 32767)
	 tmp = 32767;
      else if (tmp < -32768)
	 tmp = -32768;
      *pcm = tmp;
      pcm += 2;
   }
}
#endif

void set_cpu_caps_window_dual(int caps)
{
#ifdef ASM_X86
    if (caps & tE3DN && caps & tEMMX ) {
        window_dual = window_dual_e3dn_emmx;
    
    } else 
    if (caps & t3DN) {
        window_dual = window_dual_3dn;
    
    } else 
    if ((caps & tINTEL) && (caps & (tFAMILY5|tFAMILY6)) && (caps & tCMOV)) {
        window_dual = window_dual_p6_cmov;
    
    } else 
    if ((caps & tINTEL) && (caps & (tFAMILY5|tFAMILY6)) ) {
        window_dual = window_dual_p5;
    
    } else 
    {
        window_dual = window_dual_fpu;
    }
#else
    {
        window_dual = window_dual_c;
    }
#endif
}

#ifdef _USE_REDUCTION_
/*------------------------------------------------------------*/
/*------------------- 16 pt window ------------------------------*/

#ifndef ASM_X86
void window16(float *vbuf, int vb_ptr, short *pcm)
{
   int i, j;
   unsigned char si, bx;
   float *coef;
   float sum;
   long tmp;

   si = vb_ptr + 8;
   bx = si + 16;
   coef = wincoef;

/*-- first 8 --*/
   for (i = 0; i < 8; i++)
   {
      sum = 0.0F;
      for (j = 0; j < 8; j++)
      {
	 sum += (*coef++) * vbuf[si];
	 si += 32;
	 sum -= (*coef++) * vbuf[bx];
	 bx += 32;
      }
      si++;
      bx--;
      coef += 16;
      tmp = (long) sum;
      if (tmp > 32767)
	 tmp = 32767;
      else if (tmp < -32768)
	 tmp = -32768;
      *pcm++ = tmp;
   }
/*--  special case --*/
   sum = 0.0F;
   for (j = 0; j < 8; j++)
   {
      sum += (*coef++) * vbuf[bx];
      bx += 32;
   }
   tmp = (long) sum;
   if (tmp > 32767)
      tmp = 32767;
   else if (tmp < -32768)
      tmp = -32768;
   *pcm++ = tmp;
/*-- last 7 --*/
   coef = wincoef + 255;	/* back pass through coefs */
   for (i = 0; i < 7; i++)
   {
      coef -= 16;
      si--;
      bx++;
      sum = 0.0F;
      for (j = 0; j < 8; j++)
      {
	 sum += (*coef--) * vbuf[si];
	 si += 32;
	 sum += (*coef--) * vbuf[bx];
	 bx += 32;
      }
      tmp = (long) sum;
      if (tmp > 32767)
	 tmp = 32767;
      else if (tmp < -32768)
	 tmp = -32768;
      *pcm++ = tmp;
   }
}
#endif
/*--------------- 16 pt dual window (interleaved output) -----------------*/
#ifndef ASM_X86
void window16_dual(float *vbuf, int vb_ptr, short *pcm)
{
   int i, j;
   unsigned char si, bx;
   float *coef;
   float sum;
   long tmp;

   si = vb_ptr + 8;
   bx = si + 16;
   coef = wincoef;

/*-- first 8 --*/
   for (i = 0; i < 8; i++)
   {
      sum = 0.0F;
      for (j = 0; j < 8; j++)
      {
	 sum += (*coef++) * vbuf[si];
	 si += 32;
	 sum -= (*coef++) * vbuf[bx];
	 bx += 32;
      }
      si++;
      bx--;
      coef += 16;
      tmp = (long) sum;
      if (tmp > 32767)
	 tmp = 32767;
      else if (tmp < -32768)
	 tmp = -32768;
      *pcm = tmp;
      pcm += 2;
   }
/*--  special case --*/
   sum = 0.0F;
   for (j = 0; j < 8; j++)
   {
      sum += (*coef++) * vbuf[bx];
      bx += 32;
   }
   tmp = (long) sum;
   if (tmp > 32767)
      tmp = 32767;
   else if (tmp < -32768)
      tmp = -32768;
   *pcm = tmp;
   pcm += 2;
/*-- last 7 --*/
   coef = wincoef + 255;	/* back pass through coefs */
   for (i = 0; i < 7; i++)
   {
      coef -= 16;
      si--;
      bx++;
      sum = 0.0F;
      for (j = 0; j < 8; j++)
      {
	 sum += (*coef--) * vbuf[si];
	 si += 32;
	 sum += (*coef--) * vbuf[bx];
	 bx += 32;
      }
      tmp = (long) sum;
      if (tmp > 32767)
	 tmp = 32767;
      else if (tmp < -32768)
	 tmp = -32768;
      *pcm = tmp;
      pcm += 2;
   }
}
#endif
/*------------------- 8 pt window ------------------------------*/
#ifndef ASM_X86
void window8(float *vbuf, int vb_ptr, short *pcm)
{
   int i, j;
   int si, bx;
   float *coef;
   float sum;
   long tmp;

   si = vb_ptr + 4;
   bx = (si + 8) & 127;
   coef = wincoef;

/*-- first 4 --*/
   for (i = 0; i < 4; i++)
   {
      sum = 0.0F;
      for (j = 0; j < 8; j++)
      {
	 sum += (*coef++) * vbuf[si];
	 si = (si + 16) & 127;
	 sum -= (*coef++) * vbuf[bx];
	 bx = (bx + 16) & 127;
      }
      si++;
      bx--;
      coef += 48;
      tmp = (long) sum;
      if (tmp > 32767)
	 tmp = 32767;
      else if (tmp < -32768)
	 tmp = -32768;
      *pcm++ = tmp;
   }
/*--  special case --*/
   sum = 0.0F;
   for (j = 0; j < 8; j++)
   {
      sum += (*coef++) * vbuf[bx];
      bx = (bx + 16) & 127;
   }
   tmp = (long) sum;
   if (tmp > 32767)
      tmp = 32767;
   else if (tmp < -32768)
      tmp = -32768;
   *pcm++ = tmp;
/*-- last 3 --*/
   coef = wincoef + 255;	/* back pass through coefs */
   for (i = 0; i < 3; i++)
   {
      coef -= 48;
      si--;
      bx++;
      sum = 0.0F;
      for (j = 0; j < 8; j++)
      {
	 sum += (*coef--) * vbuf[si];
	 si = (si + 16) & 127;
	 sum += (*coef--) * vbuf[bx];
	 bx = (bx + 16) & 127;
      }
      tmp = (long) sum;
      if (tmp > 32767)
	 tmp = 32767;
      else if (tmp < -32768)
	 tmp = -32768;
      *pcm++ = tmp;
   }
}
#endif
/*--------------- 8 pt dual window (interleaved output) -----------------*/
#ifndef ASM_X86
void window8_dual(float *vbuf, int vb_ptr, short *pcm)
{
   int i, j;
   int si, bx;
   float *coef;
   float sum;
   long tmp;

   si = vb_ptr + 4;
   bx = (si + 8) & 127;
   coef = wincoef;

/*-- first 4 --*/
   for (i = 0; i < 4; i++)
   {
      sum = 0.0F;
      for (j = 0; j < 8; j++)
      {
	 sum += (*coef++) * vbuf[si];
	 si = (si + 16) & 127;
	 sum -= (*coef++) * vbuf[bx];
	 bx = (bx + 16) & 127;
      }
      si++;
      bx--;
      coef += 48;
      tmp = (long) sum;
      if (tmp > 32767)
	 tmp = 32767;
      else if (tmp < -32768)
	 tmp = -32768;
      *pcm = tmp;
      pcm += 2;
   }
/*--  special case --*/
   sum = 0.0F;
   for (j = 0; j < 8; j++)
   {
      sum += (*coef++) * vbuf[bx];
      bx = (bx + 16) & 127;
   }
   tmp = (long) sum;
   if (tmp > 32767)
      tmp = 32767;
   else if (tmp < -32768)
      tmp = -32768;
   *pcm = tmp;
   pcm += 2;
/*-- last 3 --*/
   coef = wincoef + 255;	/* back pass through coefs */
   for (i = 0; i < 3; i++)
   {
      coef -= 48;
      si--;
      bx++;
      sum = 0.0F;
      for (j = 0; j < 8; j++)
      {
	 sum += (*coef--) * vbuf[si];
	 si = (si + 16) & 127;
	 sum += (*coef--) * vbuf[bx];
	 bx = (bx + 16) & 127;
      }
      tmp = (long) sum;
      if (tmp > 32767)
	 tmp = 32767;
      else if (tmp < -32768)
	 tmp = -32768;
      *pcm = tmp;
      pcm += 2;
   }
}
#endif
/*------------------------------------------------------------*/
#endif

static int inverting = 0;

/*  ɐ𔽓]邩ǂ */
/*  invert  0 Ŕ]   */
void
set_invert_polarity(int invert)
{
	int i;
	
	if ((inverting && invert) || (!inverting && !invert)) return;
	
	for (i = 0; i < 264; i++) wincoef[i] *= -1.0;
	
	inverting = !inverting;
}

/*  ɐ𔽓]ǂ   */
/*  ߒl 0 Ȃ甽]  */
int
get_invert_polarity()
{
	return inverting;
}

