;/*
; *  for MP3Player - Free Delphi Component (OCT. 1999)
; *  modified by Kei Ishida  kei-i@sams.co.jp
; */

;/*
; * Window functions ASM version for the XingMPG Decoder
; * 16bits output version
; *
; * Copyright (c) 1999, Jean-Michel HERVE
; *
; * Code : TuO / StG
; * Date : 08/04/99
; *
; * NOTE : All functions tested succesfully
; * NOTE : Macros can only accept 2 or 4 as argument
; *
; * This program is free software; you can redistribute it and/or modify
; * it under the terms of the GNU General Public License as published by
; * the Free Software Foundation; either version 2 of the License, or
; * (at your option) any later version.
; * 
; * This program is distributed in the hope that it will be useful,
; * but WITHOUT ANY WARRANTY; without even the implied warranty of
; * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; * GNU General Public License for more details.
; * 
; * You should have received a copy of the GNU General Public License
; * along with this program; if not, write to the Free Software
; * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
; * 
; * $Id: cwinasm.asm,v 1.3 1999/04/22 08:24:01 mhw Exp $
; */

%include "nasm.h"

segment_data


EXTERN _wincoef

SI_MASK  equ 111111111b
SI_MASK2 equ 1111111b

Temp dd 0

SignReverse dd 0, 080000000h
InterleavesMask dd 0FFFFh, 00FFFFh
D_65535_0   dd  0FFFFh, 0
D_32767     dd  32767
D_M32768    dd  -32768
D_Geta_Geta	dd	0.5, 0.5
D_Geta_0	dd	0.5, 0.0
D_1_1		dd  1.0, 1.0

;/* Small table for all ((Value+64)&511) progression */
ADD64AND511:
%assign Value 0
%rep 512
        dd ((Value+64) & SI_MASK)
%assign Value Value+1
%endrep

;/* Small table for all ((Value+16)&127) progression */
ADD16AND127:
%assign Value 0
%rep 128
        dd ((Value+16) & SI_MASK2)
%assign Value Value+1
%endrep

;/*
; * This macro is general for mono and stereo output (full rate)
; * It allow to optimize only this piece of code for both versions
; */
%macro window32 1 ;// PROC vbuf, vb_ptr, pcm :  DWORD
%$vbuf      arg     4
%$vb_ptr    arg    4
%$pcm       arg     4

        pushd   ebx, esi, edi, ebp

        mov    esi,[sp(%$pcm)]             ;/* pcm is esi */
        lea    esi,[esi+16*%1]         ;/* Points to the end of half part */
        mov    edx,[sp(%$vb_ptr)]
        add    edx,16                  ;/* SI is edx */
        mov    ebp,[sp(%$vbuf)]               ;/* vbuf is ebp */
        mov    ebx,edx
        add    ebx,32
        and    ebx,SI_MASK             ;/* BX is ebx */
        mov    edi, _wincoef            ;/* coef is edi */

;/*-- first 16 --*/
        mov    ecx,-16                 ;/* Use negative to 0 counter */
      %%FirstLoop:
          fldz
;// Unrolled loop with avoided incrementation of buffer
%assign j 0
%rep 8
            fld     dword [edi+j*4]
            fmul    dword [ebp+edx*4]
            faddp   st1,st0
            mov     edx,dword [ADD64AND511+edx*4]
            fld     dword [edi+j*4+4]
            fmul    dword [ebp+ebx*4]
            fsubp   st1,st0
            mov     ebx,dword [ADD64AND511+ebx*4]
%assign j j+2
%endrep
          add    edi,64                ;/* Update buffer position */

          inc    edx
          dec    ebx

          fistp  dword [Temp]          ;/* Check for 16b validity */
          mov    eax,[Temp]
          cmp    eax,32767
          jle    %%GoodSup
          mov    eax,32767
          jmp    %%GoodDown
        %%GoodSup:
          cmp    eax,-32768
          jge    %%GoodDown
          mov    eax,-32768
        %%GoodDown:

          mov    word [esi+ecx*%1],ax  ;/* Store value using counter as index */

        inc    ecx                     ;/* Increment counter to next value */
        jnz    near %%FirstLoop

;/*--  special case --*/
        fldz
;// Unrolled loop
%assign j 0
%rep 8
          fld     dword [edi+j*4]
          fmul    dword [ebp+ebx*4]
          faddp   st1,st0
          mov     ebx,dword [ADD64AND511+ebx*4]
%assign j j+1
%endrep

        fistp  dword [Temp]            ;/* Check for 16b validity */
        mov    eax,[Temp]
        cmp    eax,32767
        jle    %%GoodSup2
        mov    eax,32767
        jmp    %%GoodDown2
      %%GoodSup2:
        cmp    eax,-32768
        jge    %%GoodDown2
        mov    eax,-32768
      %%GoodDown2:

        mov    word [esi],ax           ;/* Store value */

;/*-- last 15 --*/
        lea    edi,[_wincoef+255*4]    ;/* coef[255] is edi */
        lea    esi,[esi+16*%1]         ;/* Put to the end of second half */

        mov    ecx,-15                 ;/* Use negative to 0 counter */
      %%SecondLoop:

          dec     edx
          inc     ebx

          fldz
;// Unrolled loop with avoided incrementation of buffer
%assign j 0
%rep 8
            fld     dword [edi-j*4]
            fmul    dword [ebp+edx*4]
            faddp   st1,st0
            mov     edx,dword [ADD64AND511+edx*4]
            fld     dword [edi-j*4-4]
            fmul    dword [ebp+ebx*4]
            faddp   st1,st0
            mov     ebx,dword [ADD64AND511+ebx*4]
%assign j j+2
%endrep
          sub    edi,64                ;/* Update buffer position */

          fistp  dword [Temp]          ;/* Check for 16b validity */
          mov    eax,[Temp]
          cmp    eax,32767
          jle    %%GoodSup3
          mov    eax,32767
          jmp    %%GoodDown3
        %%GoodSup3:
          cmp    eax,-32768
          jge    %%GoodDown3
          mov    eax,-32768
        %%GoodDown3:

          mov    word [esi+ecx*%1],ax  ;/* Store value using counter has index */

        inc    ecx                     ;/* Increment counter */
        jnz    near %%SecondLoop

        popd    ebx, esi, edi, ebp
%endmacro

;/*
; * Window mpg ASM Version
; */
proc window_fpu
        window32 2                     ;/* 16b mono */
endproc

;/*
; * Window dual ASM Version
; */
proc window_dual_fpu
        window32 4                     ;/* 16b stereo */
endproc


%macro window32_p5 1 ;// PROC vbuf, vb_ptr, pcm :  DWORD
%$vbuf      arg     4
%$vb_ptr    arg    4
%$pcm       arg     4

        pushd   ebx, esi, edi, ebp

        mov    esi,[sp(%$pcm)]             ;/* pcm is esi */
        lea    esi,[esi+16*%1]         ;/* Points to the end of half part */
        mov    edx,[sp(%$vb_ptr)]
        add    edx,16                  ;/* SI is edx */
        mov    ebp,[sp(%$vbuf)]               ;/* vbuf is ebp */
        mov    ebx,edx
        add    ebx,32
        and    ebx,SI_MASK             ;/* BX is ebx */
        mov    edi, _wincoef            ;/* coef is edi */

;/*-- first 16 --*/
        mov    ecx,-16                 ;/* Use negative to 0 counter */
      %%FirstLoop:
          fldz
;// Unrolled loop with avoided incrementation of buffer
%assign j 0
%rep 8
            fld     dword [edi+j*4]
            fmul    dword [ebp+edx*4]
            fld     dword [edi+j*4+4]
            fmul    dword [ebp+ebx*4]
            fxch    st1
            faddp   st2,st0
            mov     edx,dword [ADD64AND511+edx*4]
            mov     ebx,dword [ADD64AND511+ebx*4]
            fsubp   st1,st0
%assign j j+2
%endrep
          add    edi,64                ;/* Update buffer position */

          inc    edx
          dec    ebx

          fistp  dword [Temp]          ;/* Check for 16b validity */
          mov    eax,[Temp]
          cmp    eax,32767
          jle    %%GoodSup
          mov    eax,32767
          jmp    %%GoodDown
        %%GoodSup:
          cmp    eax,-32768
          jge    %%GoodDown
          mov    eax,-32768
        %%GoodDown:

          mov    word [esi+ecx*%1],ax  ;/* Store value using counter as index */

        inc    ecx                     ;/* Increment counter to next value */
        jnz    near %%FirstLoop

;/*--  special case --*/
        fldz
;// Unrolled loop
%assign j 0
%rep 4
          fld     dword [edi+j*4]
          fmul    dword [ebp+ebx*4]
          mov     ebx,dword [ADD64AND511+ebx*4]
          fld     dword [edi+(j+1)*4]
          fxch    st1
          faddp   st2,st0
          fmul    dword [ebp+ebx*4]
          mov     ebx,dword [ADD64AND511+ebx*4]
          faddp   st1,st0
%assign j j+2
%endrep

        fistp  dword [Temp]            ;/* Check for 16b validity */
        mov    eax,[Temp]
        cmp    eax,32767
        jle    %%GoodSup2
        mov    eax,32767
        jmp    %%GoodDown2
      %%GoodSup2:
        cmp    eax,-32768
        jge    %%GoodDown2
        mov    eax,-32768
      %%GoodDown2:

        mov    word [esi],ax           ;/* Store value */

;/*-- last 15 --*/
        lea    edi,[_wincoef+255*4]    ;/* coef[255] is edi */
        lea    esi,[esi+16*%1]         ;/* Put to the end of second half */

        mov    ecx,-15                 ;/* Use negative to 0 counter */
      %%SecondLoop:

          dec     edx
          inc     ebx

          fldz
;// Unrolled loop with avoided incrementation of buffer
%assign j 0
%rep 8
            fld     dword [edi-j*4]
            fmul    dword [ebp+edx*4]
            fld     dword [edi-j*4-4]
            fmul    dword [ebp+ebx*4]
            fxch    st1
            faddp   st2,st0
            mov     edx,dword [ADD64AND511+edx*4]
            mov     ebx,dword [ADD64AND511+ebx*4]
            faddp   st1,st0
%assign j j+2
%endrep
          sub    edi,64                ;/* Update buffer position */

          fistp  dword [Temp]          ;/* Check for 16b validity */
          mov    eax,[Temp]
          cmp    eax,32767
          jle    %%GoodSup3
          mov    eax,32767
          jmp    %%GoodDown3
        %%GoodSup3:
          cmp    eax,-32768
          jge    %%GoodDown3
          mov    eax,-32768
        %%GoodDown3:

          mov    word [esi+ecx*%1],ax  ;/* Store value using counter has index */

        inc    ecx                     ;/* Increment counter */
        jnz    near %%SecondLoop

        popd    ebx, esi, edi, ebp
%endmacro

;/*
; * Window mpg ASM Version
; */
proc window_p5
        window32_p5 2                     ;/* 16b mono */
endproc

;/*
; * Window dual ASM Version
; */
proc window_dual_p5
        window32_p5 4                     ;/* 16b stereo */
endproc

%macro window32_p6_cmov 1 ;// PROC vbuf, vb_ptr, pcm :  DWORD
%$vbuf      arg     4
%$vb_ptr    arg    4
%$pcm       arg     4

        pushd   ebx, esi, edi, ebp

        mov    esi,[sp(%$pcm)]             ;/* pcm is esi */
        lea    esi,[esi+16*%1]         ;/* Points to the end of half part */
        mov    edx,[sp(%$vb_ptr)]
        add    edx,16                  ;/* SI is edx */
        mov    ebp,[sp(%$vbuf)]               ;/* vbuf is ebp */
        mov    ebx,edx
        add    ebx,32
        and    ebx,SI_MASK             ;/* BX is ebx */
        mov    edi, _wincoef            ;/* coef is edi */

;/*-- first 16 --*/
        mov    ecx,-16                 ;/* Use negative to 0 counter */
      %%FirstLoop:
          fldz
;// Unrolled loop with avoided incrementation of buffer
%assign j 0
%rep 8
            fld     dword [edi+j*4]
            fmul    dword [ebp+edx*4]
            fld     dword [edi+j*4+4]
            fmul    dword [ebp+ebx*4]
            fxch    st1
            faddp   st2,st0
            mov     edx,dword [ADD64AND511+edx*4]
            mov     ebx,dword [ADD64AND511+ebx*4]
            fsubp   st1,st0
%assign j j+2
%endrep
          add    edi,64                ;/* Update buffer position */

          inc    edx
          dec    ebx

          fistp  dword [Temp]          ;/* Check for 16b validity */
            mov eax, dword [Temp]
         cmp eax,dword [D_32767]
         cmovg eax, dword [D_32767]
         cmp eax,dword [D_M32768]
         cmovl eax, dword [D_M32768]
          mov    word [esi+ecx*%1],ax  ;/* Store value using counter as index */
        inc    ecx                     ;/* Increment counter to next value */
        jnz    near %%FirstLoop

;/*--  special case --*/
        fldz
;// Unrolled loop
%assign j 0
%rep 4
          fld     dword [edi+j*4]
          fmul    dword [ebp+ebx*4]
          mov     ebx,dword [ADD64AND511+ebx*4]
          fld     dword [edi+(j+1)*4]
          fxch    st1
          faddp   st2,st0
          fmul    dword [ebp+ebx*4]
          mov     ebx,dword [ADD64AND511+ebx*4]
          faddp   st1,st0
%assign j j+2
%endrep

          fistp  dword [Temp]          ;/* Check for 16b validity */
            mov eax, dword [Temp]
         cmp eax,dword [D_32767]
         cmovg eax, dword [D_32767]
         cmp eax,dword [D_M32768]
         cmovl eax, dword [D_M32768]
        mov    word [esi],ax           ;/* Store value */

;/*-- last 15 --*/
        lea    edi,[_wincoef+255*4]    ;/* coef[255] is edi */
        lea    esi,[esi+16*%1]         ;/* Put to the end of second half */

        mov    ecx,-15                 ;/* Use negative to 0 counter */
      %%SecondLoop:

          dec     edx
          inc     ebx

          fldz
;// Unrolled loop with avoided incrementation of buffer
%assign j 0
%rep 8
            fld     dword [edi-j*4]
            fmul    dword [ebp+edx*4]
            fld     dword [edi-j*4-4]
            fmul    dword [ebp+ebx*4]
            fxch    st1
            faddp   st2,st0
            mov     edx,dword [ADD64AND511+edx*4]
            mov     ebx,dword [ADD64AND511+ebx*4]
            faddp   st1,st0
%assign j j+2
%endrep
          sub    edi,64                ;/* Update buffer position */

          fistp  dword [Temp]          ;/* Check for 16b validity */
            mov eax, dword [Temp]
         cmp eax,dword [D_32767]
         cmovg eax, dword [D_32767]
         cmp eax,dword [D_M32768]
         cmovl eax, dword [D_M32768]
          mov    word [esi+ecx*%1],ax  ;/* Store value using counter has index */

        inc    ecx                     ;/* Increment counter */
        jnz    near %%SecondLoop

        popd    ebx, esi, edi, ebp
%endmacro

;/*
; * Window mpg ASM Version
; */
proc window_p6_cmov
        window32_p6_cmov 2                     ;/* 16b mono */
endproc

;/*
; * Window dual ASM Version
; */
proc window_dual_p6_cmov
        window32_p6_cmov 4                     ;/* 16b stereo */
endproc

;/*
; * This macro is general for mono and stereo output (half rate)
; * It allow to optimize only this piece of code for both versions
; */
%macro window16 1 ;// PROC vbuf, vb_ptr, pcm :  DWORD
                  ;//      ebp   ebp+4   ebp+8
        push   ebp
        lea    ebp,[esp+8]
        pushad

        mov    esi,[ebp+8]             ;/* pcm is esi */
        lea    esi,[esi+8*%1]          ;/* Points to the end of half part */
        mov    edx,[ebp+4]
        add    dl,8                    ;/* SI is edx */
        mov    ebp,[ebp]               ;/* vbuf is ebp */
        mov    ebx,edx
        add    bl,16                   ;/* BX is ebx */
        mov    edi, _wincoef            ;/* coef is edi */

;/*-- first 8 --*/
        mov    ecx,-8                  ;/* Use negative to 0 counter */
      %%FirstLoop:
          fldz
;// Unrolled loop with avoided incrementation of buffer
%assign j 0
%rep 8
            fld     dword [edi+j*4]
            fmul    dword [ebp+edx*4]
            faddp   st1,st0
            add     dl,32
            fld     dword [edi+j*4+4]
            fmul    dword [ebp+ebx*4]
            fsubp   st1,st0
            add     bl,32
%assign j j+2
%endrep
          add    edi,64+64             ;/* Update buffer position */

          inc    dl
          dec    bl

          fistp  dword [Temp]          ;/* Check for 16b validity */
          mov    eax,[Temp]
          cmp    eax,32767
          jle    %%GoodSup
          mov    eax,32767
          jmp    %%GoodDown
        %%GoodSup:
          cmp    eax,-32768
          jge    %%GoodDown
          mov    eax,-32768
        %%GoodDown:

          mov    word [esi+ecx*%1],ax  ;/* Store value using counter as index */

        inc    ecx                     ;/* Increment counter to next value */
        jnz    near %%FirstLoop

;/*--  special case --*/
        fldz
;// Unrolled loop
%assign j 0
%rep 8
          fld     dword [edi+j*4]
          fmul    dword [ebp+ebx*4]
          faddp   st1,st0
          add     bl,32
%assign j j+1
%endrep

        fistp  dword [Temp]            ;/* Check for 16b validity */
        mov    eax,[Temp]
        cmp    eax,32767
        jle    %%GoodSup2
        mov    eax,32767
        jmp    %%GoodDown2
      %%GoodSup2:
        cmp    eax,-32768
        jge    %%GoodDown2
        mov    eax,-32768
      %%GoodDown2:

        mov    word [esi],ax           ;/* Store value */

;/*-- last 7 --*/
        lea    edi,[_wincoef+(255-16)*4] ;/* coef[255] is edi */
        lea    esi,[esi+8*%1]          ;/* Put to the end of second half */

        mov    ecx,-7                  ;/* Use negative to 0 counter */
      %%SecondLoop:

          dec     dl
          inc     bl

          fldz
;// Unrolled loop with avoided incrementation of buffer
%assign j 0
%rep 8
            fld     dword [edi-j*4]
            fmul    dword [ebp+edx*4]
            faddp   st1,st0
            add     dl,32
            fld     dword [edi-j*4-4]
            fmul    dword [ebp+ebx*4]
            faddp   st1,st0
            add     bl,32
%assign j j+2
%endrep
          sub    edi,64+64             ;/* Update buffer position */

          fistp  dword [Temp]          ;/* Check for 16b validity */
          mov    eax,[Temp]
          cmp    eax,32767
          jle    %%GoodSup3
          mov    eax,32767
          jmp    %%GoodDown3
        %%GoodSup3:
          cmp    eax,-32768
          jge    %%GoodDown3
          mov    eax,-32768
        %%GoodDown3:

          mov    word [esi+ecx*%1],ax  ;/* Store value using counter has index */

        inc    ecx                     ;/* Increment counter */
        jnz    near %%SecondLoop

        popad
        pop    ebp
%endmacro

;/*
; * This macro is general for mono and stereo output (quarter rate)
; * It allow to optimize only this piece of code for both versions
; */
%macro window8 1  ;// PROC vbuf, vb_ptr, pcm :  DWORD
                  ;//      ebp   ebp+4   ebp+8
        push   ebp
        lea    ebp,[esp+8]
        pushad

        mov    esi,[ebp+8]             ;/* pcm is esi */
        lea    esi,[esi+4*%1]          ;/* Points to the end of half part */
        mov    edx,[ebp+4]
        add    edx,4                   ;/* SI is edx */
        mov    ebp,[ebp]               ;/* vbuf is ebp */
        mov    ebx,edx
        add    ebx,8
        and    ebx,SI_MASK2            ;/* BX is ebx */
        mov    edi, _wincoef            ;/* coef is edi */

;/*-- first 16 --*/
        mov    ecx,-4                  ;/* Use negative to 0 counter */
      %%FirstLoop:
          fldz
;// Unrolled loop with avoided incrementation of buffer
%assign j 0
%rep 8
            fld     dword [edi+j*4]
            fmul    dword [ebp+edx*4]
            faddp   st1,st0
            mov     edx,dword [ADD16AND127+edx*4]
            fld     dword [edi+j*4+4]
            fmul    dword [ebp+ebx*4]
            fsubp   st1,st0
            mov     ebx,dword [ADD16AND127+ebx*4]
%assign j j+2
%endrep
          add    edi,64+48*4           ;/* Update buffer position */

          inc    edx
          dec    ebx

          fistp  dword [Temp]          ;/* Check for 16b validity */
          mov    eax,[Temp]
          cmp    eax,32767
          jle    %%GoodSup
          mov    eax,32767
          jmp    %%GoodDown
        %%GoodSup:
          cmp    eax,-32768
          jge    %%GoodDown
          mov    eax,-32768
        %%GoodDown:

          mov    word [esi+ecx*%1],ax  ;/* Store value using counter as index */

        inc    ecx                     ;/* Increment counter to next value */
        jnz    near %%FirstLoop

;/*--  special case --*/
        fldz
;// Unrolled loop
%assign j 0
%rep 8
          fld     dword [edi+j*4]
          fmul    dword [ebp+ebx*4]
          faddp   st1,st0
          mov     ebx,dword [ADD16AND127+ebx*4]
%assign j j+1
%endrep

        fistp  dword [Temp]            ;/* Check for 16b validity */
        mov    eax,[Temp]
        cmp    eax,32767
        jle    %%GoodSup2
        mov    eax,32767
        jmp    %%GoodDown2
      %%GoodSup2:
        cmp    eax,-32768
        jge    %%GoodDown2
        mov    eax,-32768
      %%GoodDown2:

        mov    word [esi],ax           ;/* Store value */

;/*-- last 15 --*/
        lea    edi,[_wincoef+(255-48)*4] ;/* coef[255] is edi */
        lea    esi,[esi+4*%1]          ;/* Put to the end of second half */

        mov    ecx,-3                  ;/* Use negative to 0 counter */
      %%SecondLoop:

          dec     edx
          inc     ebx

          fldz
;// Unrolled loop with avoided incrementation of buffer
%assign j 0
%rep 8
            fld     dword [edi-j*4]
            fmul    dword [ebp+edx*4]
            faddp   st1,st0
            mov     edx,dword [ADD16AND127+edx*4]
            fld     dword [edi-j*4-4]
            fmul    dword [ebp+ebx*4]
            faddp   st1,st0
            mov     ebx,dword [ADD16AND127+ebx*4]
%assign j j+2
%endrep
          sub    edi,64+48*4           ;/* Update buffer position */

          fistp  dword [Temp]          ;/* Check for 16b validity */
          mov    eax,[Temp]
          cmp    eax,32767
          jle    %%GoodSup3
          mov    eax,32767
          jmp    %%GoodDown3
        %%GoodSup3:
          cmp    eax,-32768
          jge    %%GoodDown3
          mov    eax,-32768
        %%GoodDown3:

          mov    word [esi+ecx*%1],ax  ;/* Store value using counter has index */

        inc    ecx                     ;/* Increment counter */
        jnz    near %%SecondLoop

        popad
        pop    ebp
%endmacro


;/*
; * 3DNow p
; * 
; */
%macro window32_3dn 1 ;// PROC vbuf, vb_ptr, pcm :  DWORD
%$vbuf      arg     4
%$vb_ptr    arg    4
%$pcm       arg     4

        pushd   ebx, esi, edi, ebp

        FEMMS

        mov    esi,[sp(%$pcm)]             ;/* pcm is esi */
        lea    esi,[esi+16*%1]         ;/* Points to the end of half part */
        mov    edx,[sp(%$vb_ptr)]
        add    edx,16                  ;/* SI is edx */
        mov    eax,[sp(%$vbuf)]               ;/* vbuf is eax */
        mov    ebx,edx
        add    ebx,32
        and    ebx,SI_MASK             ;/* BX is ebx */
        mov    edi, _wincoef            ;/* coef is edi */

;/*-- first 16 --*/
        mov    ecx,-16                 ;/* Use negative to 0 counter */

	        movq  mm7, qword [SignReverse]

      %%FirstLoop: 

;// Unrolled loop with avoided incrementation of buffer
            mov     ebp,  ADD64AND511

            movd    mm0, dword [eax+edx*4]
            mov     edx,dword [ebp+edx*4]
            punpckldq mm0, qword [eax+ebx*4]  ; vbuf[bx]:vbuf[si]
            mov     ebx,dword [ebp+ebx*4]
            movd    mm1, dword [eax+edx*4]
            mov     edx,dword [ebp+edx*4]
            pfmul   mm0, qword [edi]      ; *= *(coef+1):*coef
            punpckldq mm1, qword [eax+ebx*4]  ; vbuf[bx]:vbuf[si]
            mov     ebx,dword [ebp+ebx*4]
            movd    mm2, dword [eax+edx*4]
            mov     edx,dword [ebp+edx*4]
			pfadd	mm0, qword [D_Geta_0]
            pfmul   mm1, qword [edi+ 8]      ; *= *(coef+1):*coef
            punpckldq mm2, qword [eax+ebx*4]  ; vbuf[bx]:vbuf[si]
            mov     ebx,dword [ebp+ebx*4]
            movd    mm3, dword [eax+edx*4]
            mov     edx,dword [ebp+edx*4]
            pfmul   mm2, qword [edi+16]      ; *= *(coef+1):*coef
            pfadd   mm0, mm1
            punpckldq mm3, qword [eax+ebx*4]  ; vbuf[bx]:vbuf[si]
            mov     ebx,dword [ebp+ebx*4]
            movd    mm4, dword [eax+edx*4]
            mov     edx,dword [ebp+edx*4]
            pfmul   mm3, qword [edi+24]      ; *= *(coef+1):*coef
            pfadd   mm0, mm2
            punpckldq mm4, qword [eax+ebx*4]  ; vbuf[bx]:vbuf[si]
            mov     ebx,dword [ebp+ebx*4]
            movd    mm5, dword [eax+edx*4]
            mov     edx,dword [ebp+edx*4]
            pfmul   mm4, qword [edi+32]      ; *= *(coef+1):*coef
            pfadd   mm0, mm3
            punpckldq mm5, qword [eax+ebx*4]  ; vbuf[bx]:vbuf[si]
            mov     ebx,dword [ebp+ebx*4]
            movd    mm6, dword [eax+edx*4]
            mov     edx,dword [ebp+edx*4]
            pfmul   mm5, qword [edi+40]      ; *= *(coef+1):*coef
            pfadd   mm0, mm4
            punpckldq mm6, qword [eax+ebx*4]  ; vbuf[bx]:vbuf[si]
            mov     ebx,dword [ebp+ebx*4]
            movd    mm1, dword [eax+edx*4]
            pfadd   mm0, mm5
            pfmul   mm6, qword [edi+48]      ; *= *(coef+1):*coef
            punpckldq mm1, qword [eax+ebx*4]  ; vbuf[bx]:vbuf[si]
            pfadd   mm0, mm6
            pfmul   mm1, qword [edi+56]      ; *= *(coef+1):*coef
            mov     edx,dword [ebp+edx*4]
            pfadd   mm0, mm1
            mov     ebx,dword [ebp+ebx*4]
            pxor    mm0, mm7

			pxor	mm4, mm4
            pfacc  mm0, mm0
            add    edi,64                ;/* Update buffer position */
			pfcmpge	mm4, mm0
			pand	mm4, qword [D_1_1]
			pfsub	mm0, mm4
            inc    edx
            pf2id  mm0, mm0
            dec    ebx
            packssdw mm0, mm0
            movd   ebp, mm0
            mov    word [esi+ecx*%1],bp  


        inc    ecx                     ;/* Increment counter to next value */
        jnz    near %%FirstLoop

;/*--  special case --*/


        mov     ebp,  ADD64AND511

          mov     ecx,dword [ebp+ebx*4]
          movd    mm0, dword [eax+ebx*4]
          mov     ebx,dword [ebp+ecx*4]
          punpckldq    mm0, qword [eax+ecx*4]
          mov     ecx, dword [ebp+ebx*4]
          movd    mm2, dword [eax+ebx*4]
          mov     ebx,dword [ebp+ecx*4]
          pfmul   mm0, qword [edi+0]
          punpckldq    mm2, qword [eax+ecx*4]
          mov     ecx,dword [ebp+ebx*4]
          movd    mm3, dword [eax+ebx*4]
          mov     ebx,dword [ebp+ecx*4]
          pfadd	mm0, qword [D_Geta_0]
          pfmul   mm2, qword [edi+8]
          punpckldq    mm3, qword [eax+ecx*4]
          mov     ecx,dword [ebp+ebx*4]
          movd    mm4, dword [eax+ebx*4]
          pfadd   mm0, mm2
          pfmul   mm3, qword [edi+16]
          mov     ebx,dword [ebp+ecx*4]
          punpckldq    mm4, qword [eax+ecx*4]
          pfadd   mm0, mm3
          pfmul   mm4, qword [edi+24]
          pfadd   mm0, mm4

        lea    edi,[_wincoef+127*8]    ;/* coef[255] is edi */
        pfacc  mm0, mm0
		pxor	mm1, mm1
		pfcmpge	mm1, mm0
		pand	mm1, qword [D_1_1]
		pfsub	mm0, mm1
        pf2id  mm0, mm0
        packssdw mm0, mm0
        movd   ecx, mm0
        mov    word [esi],cx           ;/* Store value */
        mov    ecx,-15                 ;/* Use negative to 0 counter */
        lea    esi,[esi+16*%1]         ;/* Put to the end of second half */

      %%SecondLoop:

       mov     ebp,  ADD64AND511
          dec     edx
          inc     ebx

;// Unrolled loop with avoided incrementation of buffer
            movd    mm0, dword [eax+ebx*4]
            mov     ebx,dword [ebp+ebx*4]
            punpckldq    mm0, qword [eax+edx*4]
            mov     edx,dword [ebp+edx*4]
            movd    mm1, dword [eax+ebx*4]
            mov     ebx,dword [ebp+ebx*4]
            pfmul   mm0, qword [edi-0]
            punpckldq    mm1, qword [eax+edx*4]
            mov     edx,dword [ebp+edx*4]
            movd    mm2, dword [eax+ebx*4]
            mov     ebx,dword [ebp+ebx*4]
          pfadd	mm0, qword [D_Geta_0]
            pfmul   mm1, qword [edi-8]
            punpckldq    mm2, qword [eax+edx*4]
            mov     edx,dword [ebp+edx*4]
            movd    mm3, dword [eax+ebx*4]
            mov     ebx,dword [ebp+ebx*4]
            pfadd   mm0, mm1
            pfmul   mm2, qword [edi-16]
            punpckldq    mm3, qword [eax+edx*4]
            mov     edx,dword [ebp+edx*4]
            movd    mm4, dword [eax+ebx*4]
            mov     ebx,dword [ebp+ebx*4]
            pfadd   mm0, mm2
            pfmul   mm3, qword [edi-24]
            punpckldq    mm4, qword [eax+edx*4]
            mov     edx,dword [ebp+edx*4]
            movd    mm5, dword [eax+ebx*4]
            mov     ebx,dword [ebp+ebx*4]
            pfadd   mm0, mm3
            pfmul   mm4, qword [edi-32]
            punpckldq    mm5, qword [eax+edx*4]
            mov     edx,dword [ebp+edx*4]
            movd    mm6, dword [eax+ebx*4]
            mov     ebx,dword [ebp+ebx*4]
            pfadd   mm0, mm4
            pfmul   mm5, qword [edi-40]
            punpckldq    mm6, qword [eax+edx*4]
            mov     edx,dword [ebp+edx*4]
            movd    mm7, dword [eax+ebx*4]
            pfadd   mm0, mm5
            pfmul   mm6, qword [edi-48]
            punpckldq    mm7, qword [eax+edx*4]
            mov     ebx,dword [ebp+ebx*4]
            pfadd   mm0, mm6
            pfmul   mm7, qword [edi-56]
            mov     edx,dword [ebp+edx*4]
            pfadd   mm0, mm7
   		  pxor	mm1, mm1
          pfacc  mm0, mm0
   		  pfcmpge	mm1, mm0
		  pand	mm1, qword [D_1_1]
		  pfsub	mm0, mm1


          sub    edi,64                ;/* Update buffer position */
          pf2id  mm0, mm0
          packssdw mm0, mm0
          movd   ebp, mm0
          mov    word [esi+ecx*%1],bp  ;/* Store value using counter as index */
        inc    ecx                     ;/* Increment counter */
        jnz    near %%SecondLoop

        FEMMS

        popd    ebx, esi, edi, ebp
%endmacro


; 3DNow p
; SISD ȏŁB͂܂̑ΏƗpɎcĂ܂B
; }NȂ̂ŁAWJȂ΁AoCi͑傫ȂȂB
%macro window32_3dn_sisd 1 ;// PROC vbuf, vb_ptr, pcm :  DWORD
                  ;//      ebp   ebp+4   ebp+8
        push   ebp
        lea    ebp,[esp+8]
        pushad

        FEMMS

        mov    esi,[ebp+8]             ;/* pcm is esi */
        lea    esi,[esi+16*%1]         ;/* Points to the end of half part */
        mov    edx,[ebp+4]
        add    edx,16                  ;/* SI is edx */
        mov    eax,[ebp]               ;/* vbuf is ebp */
        mov    ebx,edx
        add    ebx,32
        and    ebx,SI_MASK             ;/* BX is ebx */
        mov    edi, _wincoef            ;/* coef is edi */

;/*-- first 16 --*/
        mov    ecx,-16                 ;/* Use negative to 0 counter */

      %%FirstLoop:
        pxor mm0, mm0

;// Unrolled loop with avoided incrementation of buffer
%assign j 0
%assign k 0
%assign l 4
%rep 8
            movd    mm1, dword [edi+k]
            movd    mm2, dword [eax+edx*4]
            pfmul   mm1, mm2
            pfadd   mm0, mm1
            mov     edx,dword [ADD64AND511+edx*4]

            movd    mm1, dword [edi+l]
            movd    mm2, dword [eax+ebx*4]
            pfmul   mm1, mm2
            pfsub   mm0, mm1
            mov     ebx,dword [ADD64AND511+ebx*4]
%assign j j+2
%assign k k+8
%assign l l+8
%endrep
          add    edi,64                ;/* Update buffer position */

          inc    edx
          dec    ebx

          pf2id  mm0, mm0
          movd   dword [Temp], mm0
          mov    ebp,[Temp]
          cmp    ebp,32767
          jle    %%GoodSup
          mov    ebp,32767
          jmp    %%GoodDown
        %%GoodSup:
          cmp    ebp,-32768
          jge    %%GoodDown
          mov    ebp,-32768
        %%GoodDown:

          mov    word [esi+ecx*%1],bp  ;/* Store value using counter as index */

        inc    ecx                     ;/* Increment counter to next value */
        jnz    near %%FirstLoop

;/*--  special case --*/
        pxor mm0, mm0
;// Unrolled loop
%assign j 0
%assign k 0
%rep 8
          movd    mm1, dword [edi+k]
          movd    mm2, dword [eax+ebx*4]
          pfmul   mm1, mm2
          pfadd   mm0, mm1
          mov     ebx,dword [ADD64AND511+ebx*4]
%assign j j+1
%assign k k+4
%endrep

          pf2id  mm0, mm0
          movd   dword [Temp], mm0
          mov    ebp,[Temp]
          cmp    ebp,32767
          jle    %%GoodSup2
          mov    ebp,32767
          jmp    %%GoodDown2
        %%GoodSup2:
          cmp    ebp,-32768
          jge    %%GoodDown2
          mov    ebp,-32768
        %%GoodDown2:
        mov    word [esi],bp           ;/* Store value */

;/*-- last 15 --*/
        lea    edi,[_wincoef+255*4]    ;/* coef[255] is edi */
        lea    esi,[esi+16*%1]         ;/* Put to the end of second half */

        mov    ecx,-15                 ;/* Use negative to 0 counter */
      %%SecondLoop:

          dec     edx
          inc     ebx

          pxor mm0, mm0
;// Unrolled loop with avoided incrementation of buffer
%assign j 0
%assign k 0
%assign l 4
%rep 8
            movd    mm1, dword [edi-k]
            movd    mm2, dword [eax+edx*4]
            pfmul   mm1, mm2
            pfadd   mm0, mm1
            mov     edx,dword [ADD64AND511+edx*4]

            movd    mm1, dword [edi-l]
            movd    mm2, dword [eax+ebx*4]
            pfmul   mm1, mm2
            pfadd   mm0, mm1
            mov     ebx,dword [ADD64AND511+ebx*4]
%assign j j+2
%assign k k+8
%assign l l+8
%endrep
          sub    edi,64                ;/* Update buffer position */

          pf2id  mm0, mm0
          movd   dword [Temp], mm0
          mov    ebp,[Temp]
          cmp    ebp,32767
          jle    %%GoodSup3
          mov    ebp,32767
          jmp    %%GoodDown3
        %%GoodSup3:
          cmp    ebp,-32768
          jge    %%GoodDown3
          mov    ebp,-32768
        %%GoodDown3:


          mov    word [esi+ecx*%1],bp  ;/* Store value using counter has index */

        inc    ecx                     ;/* Increment counter */
        jnz    near %%SecondLoop

        FEMMS

        popad
        pop    ebp
%endmacro

%idefine    coef(j) [ecx+(j)*4]
%idefine    vbuf(j) [eax+(j)*4]
%idefine    pcm(j)  [edi+(j)*2]

%imacro     next64 1
        mov     %1,dword [ADD64AND511+%1*4]
%endmacro

;/*
; * E3DNow p
; * 
; */
%if 1
%macro window32_e3dn_emmx 1
%$arg_vbuf      arg     4
%$arg_vb_ptr    arg    4
%$arg_pcm       arg     4

%$i     local   4

        alloc

        femms

        pushd   ebx, esi, edi, ebp

        mov    edi, [sp(%$arg_pcm)]
        mov    edx, [sp(%$arg_vb_ptr)]
        add    edx, 16                  ;/* SI is edx */
        mov    eax, [sp(%$arg_vbuf)]        ;/* vbuf is eax */
        mov    ebx, edx
        add    ebx, 32
        and    ebx, SI_MASK             ;/* BX is ebx */
        mov    ecx, _wincoef            ;/* coef is edi */
        
        mov     dword [sp(%$i)], 8

        prefetchw   pcm(0)
%if %1=4
        movq    mm6, qword [InterleavesMask]
        prefetchw   pcm(32)
%endif
        movq    mm5, qword [D_65535_0]

        align   4
    .FirstLoop:
        movq	mm7, qword [D_Geta_Geta]         ; sum1:sum0
        mov     esi, edx
        mov     ebp, ebx
        inc     esi             ; si1 is esi
        dec     ebp             ; bx1 is ebp

        prefetch    coef(32)
        prefetch    coef(48)
%assign j 0
%rep    4
        movd    mm0, dword vbuf(edx)
        movd    mm1, dword vbuf(esi)
        next64  edx
        next64  esi
        punpckldq   mm0, qword vbuf(ebx)
        punpckldq   mm1, qword vbuf(ebp)
        movd    mm2, dword vbuf(edx)
        movd    mm3, dword vbuf(esi)
        next64  ebx
        next64  ebp
        pfmul   mm0, qword coef(j*2+0)
        pfmul   mm1, qword coef(j*2+16)
        punpckldq   mm2, qword vbuf(ebx)
        punpckldq   mm3, qword vbuf(ebp)
        pfmul   mm2, qword coef(j*2+2)
        pfmul   mm3, qword coef(j*2+18)
        next64  edx
        next64  esi
        pfadd   mm0, mm2
        pfadd   mm1, mm3
        next64  ebx
        pfnacc  mm0, mm1
        next64  ebp
        pfadd   mm7, mm0
%assign j j+2
%endrep
		pxor	mm4, mm4
        mov     edx, esi
		pfcmpge	mm4, mm7
        mov     ebx, ebp
		pand	mm4, qword [D_1_1]
        inc     edx
		pfsub	mm7, mm4
        dec     ebx
        pf2iw   mm7, mm7
        add     ecx, 32*4
%if %1=4
        maskmovq    mm7, mm6
%else
        packssdw    mm7, mm7
        movd    dword pcm(0), mm7
%endif
        add     edi, %1*2
        dec     dword [sp(%$i)]
        jnz     near .FirstLoop

        movq	mm7, qword [D_Geta_0]        ; 
%assign j 0
%rep 2
        movd    mm0, dword vbuf(ebx)
        next64  ebx
        punpckldq   mm0, qword vbuf(ebx)
        next64  ebx
        movd    mm1, dword vbuf(ebx)
        next64  ebx
        pfmul   mm0, qword coef(j)
        punpckldq   mm1, qword vbuf(ebx)
        pfadd   mm7, mm0
        pfmul   mm1, qword coef(j+2)
        next64  ebx
        pfadd   mm7, mm1
%assign j j+4
%endrep
		pxor	mm4, mm4
        pfacc   mm7, mm7
		pfcmpge	mm4, mm7
		pand	mm4, qword [D_1_1]
		pfsub	mm7, mm4
        pf2iw   mm7, mm7
        maskmovq    mm7, mm5
        add     edi, %1

        lea     ecx, [_wincoef+255*4]

        movq	mm7, qword [D_Geta_0]        ; 
        dec     edx
        inc     ebx

%assign j 0
%rep    4
        movd    mm0, dword vbuf(edx)
        next64  edx
        punpckldq   mm0, qword vbuf(ebx)
        next64  ebx
        pswapd  mm1, qword coef(-(j*2)-1)
        movd    mm2, dword vbuf(edx)
        pfmul   mm0, mm1
        punpckldq   mm2, qword vbuf(ebx)
        pfadd   mm7, mm0
        pswapd  mm3, qword coef(-(j*2)-3)
        next64  edx
        pfmul   mm2, mm3
        next64  ebx
        pfadd   mm7, mm2
%assign j j+2
%endrep
		pxor	mm4, mm4
        pfacc   mm7, mm7
        sub     ecx, 16*4
		pfcmpge	mm4, mm7
		pand	mm4, qword [D_1_1]
		pfsub	mm7, mm4
        pf2iw   mm7, mm7
        maskmovq    mm7, mm5
        add     edi, %1

        mov     dword [sp(%$i)], 7
        align   4
    .FinalLoop:
        movq	mm7, qword [D_Geta_Geta]        ; sum1:sum0
        dec     edx
        inc     ebx
        mov     esi, edx
        mov     ebp, ebx
        dec     esi             ; si1 is esi
        inc     ebp             ; bx1 is ebp

%assign j 0
%rep    8
        movd    mm0, dword vbuf(edx)
        movd    mm2, dword vbuf(esi)
        pswapd  mm1, qword coef(-(j*2)-1)
        pswapd  mm3, qword coef(-(j*2)-17)
        punpckldq   mm0, qword vbuf(ebx)
        punpckldq   mm2, qword vbuf(ebp)
        next64  edx
        next64  esi
        pfmul   mm0, mm1
        pfmul   mm2, mm3
        next64  ebx
        pfacc   mm0, mm2
        next64  ebp
        pfadd   mm7, mm0
%assign j j+1
%endrep
		pxor	mm4, mm4
		pfcmpge	mm4, mm7
        mov     edx, esi
		pand	mm4, qword [D_1_1]
        mov     ebx, ebp
		pfsub	mm7, mm4
        sub     ecx, 32*4
        pf2iw   mm7, mm7
%if %1=4
        maskmovq    mm7, mm6
%else
        packssdw    mm7, mm7
        movd    dword pcm(0), mm7
%endif
        add     edi, %1*2
        dec     dword [sp(%$i)]
        jnz     near .FinalLoop

.exit:
        femms

        popd    ebx, esi, edi, ebp
%endmacro

%else

%macro window32_e3dn_emmx 1
%$arg_vbuf      arg     4
%$arg_vb_ptr    arg    4
%$arg_pcm       arg     4

%$i     local   4

        alloc

        femms

        pushd   ebx, esi, edi, ebp


        mov    edi, [sp(%$arg_pcm)]
        mov    edx, [sp(%$arg_vb_ptr)]
        add    edx, 16                  ;/* SI is edx */
        mov    eax, [sp(%$arg_vbuf)]        ;/* vbuf is eax */
        mov    ebx, edx
        add    ebx, 32
        and    ebx, SI_MASK             ;/* BX is ebx */
        mov    ecx, _wincoef            ;/* coef is edi */
        
        mov     dword [sp(%$i)], 8

%if %1=4
        movq    mm6, qword [InterleavesMask]
%endif
        movq    mm5, qword [D_65535_0]

        align   4
    .FirstLoop:
        pxor    mm7, mm7        ; sum1:sum0
        mov     esi, edx
        mov     ebp, ebx
        inc     esi             ; si1 is esi
        dec     ebp             ; bx1 is ebp

%assign j 0
%rep    4
        movd    mm0, dword vbuf(edx)
        next64  edx
        punpckldq   mm0, qword vbuf(ebx)
        next64  ebx
        pfmul   mm0, qword coef(j*2+0)

        movd    mm1, dword vbuf(esi)
        next64  esi
        punpckldq   mm1, qword vbuf(ebp)
        next64  ebp
        pfmul   mm1, qword coef(j*2+16)

        movd    mm2, dword vbuf(edx)
        next64  edx
        punpckldq   mm2, qword vbuf(ebx)
        next64  ebx
        pfmul   mm2, qword coef(j*2+2)

        movd    mm3, dword vbuf(esi)
        next64  esi
        punpckldq   mm3, qword vbuf(ebp)
        next64  ebp
        pfmul   mm3, qword coef(j*2+18)

        pfadd   mm0, mm2
        pfadd   mm1, mm3
        pfnacc  mm0, mm1
        pfadd   mm7, mm0
%assign j j+2
%endrep
        mov     edx, esi
        mov     ebx, ebp
        inc     edx
        dec     ebx
        add     ecx, 32*4

        pf2iw   mm7, mm7
%if %1=4
        maskmovq    mm7, mm6
%else
        packssdw    mm7, mm7
        movd    dword pcm(0), mm7
%endif
        add     edi, %1*2
        dec     dword [sp(%$i)]
        jnz     near .FirstLoop

        pxor        mm7, mm7
%assign j 0
%rep 2
        movd    mm4, dword vbuf(ebx)
        next64  ebx
        punpckldq   mm4, qword vbuf(ebx)
        next64  ebx
        pfmul   mm4, qword coef(j)
        pfadd   mm7, mm4

        movd    mm3, dword vbuf(ebx)
        next64  ebx
        punpckldq   mm3, qword vbuf(ebx)
        next64  ebx
        pfmul   mm3, qword coef(j+2)
        pfadd   mm7, mm3
%assign j j+4
%endrep
        pfacc   mm7, mm7
        pf2iw   mm7, mm7
        maskmovq    mm7, mm5
        add     edi, %1

        lea     ecx, [_wincoef+255*4]

        pxor    mm7, mm7        ; sum0
        dec     edx
        inc     ebx

%assign j 0
%rep    4
        movd    mm0, dword vbuf(edx)
        next64  edx
        punpckldq   mm0, qword vbuf(ebx)
        next64  ebx
        pswapd  mm1, qword coef(-(j*2)-1)
        pfmul   mm0, mm1
        pfadd   mm7, mm0

        movd    mm2, dword vbuf(edx)
        next64  edx
        punpckldq   mm2, qword vbuf(ebx)
        next64  ebx
        pswapd  mm3, qword coef(-(j*2)-3)
        pfmul   mm2, mm3
        pfadd   mm7, mm2
%assign j j+2
%endrep
        sub     ecx, 16*4
        pfacc   mm7, mm7
        pf2iw   mm7, mm7
        maskmovq    mm7, mm5
        add     edi, %1

        mov     dword [sp(%$i)], 7
        align   4
    .FinalLoop:
        pxor    mm7, mm7        ; sum1:sum0
        dec     edx
        inc     ebx
        mov     esi, edx
        mov     ebp, ebx
        dec     esi             ; si1 is esi
        inc     ebp             ; bx1 is ebp

%assign j 0
%rep    8
        movd    mm0, dword vbuf(edx)
        next64  edx
        punpckldq   mm0, qword vbuf(ebx)
        next64  ebx
        pswapd  mm1, qword coef(-(j*2)-1)
        pfmul   mm0, mm1

        movd    mm2, dword vbuf(esi)
        next64  esi
        punpckldq   mm2, qword vbuf(ebp)
        next64  ebp
        pswapd  mm3, qword coef(-(j*2)-17)
        pfmul   mm2, mm3
        pfacc   mm0, mm2
        pfadd   mm7, mm0
%assign j j+1
%endrep
        mov     edx, esi
        mov     ebx, ebp
        sub     ecx, 32*4

        pf2iw   mm7, mm7
%if %1=4
        maskmovq    mm7, mm6
%else
        packssdw    mm7, mm7
        movd    dword pcm(0), mm7
%endif
        add     edi, %1*2
        dec     dword [sp(%$i)]
        jnz     near .FinalLoop

.exit:
        femms

        popd    ebx, esi, edi, ebp
%endmacro

%endif

;/*
; * Window mpg ASM Version for e3dn
; */
proc window_e3dn_emmx
        window32_e3dn_emmx 2                     ;/* 16b mono */
endproc

;/*
; * Window dual ASM Version for e3dn
; */
proc window_dual_e3dn_emmx
        window32_e3dn_emmx 4                     ;/* 16b stereo */
endproc

;/*
; * Window mpg ASM Version for 3dn
; */
proc window_3dn
        window32_3dn 2                     ;/* 16b mono */
endproc

;/*
; * Window dual ASM Version for 3dn
; */
proc window_dual_3dn
        window32_3dn 4                     ;/* 16b stereo */
endproc

%undef  coef
%undef  vbu
%undef  pcm



%ifdef _USE_REDUCTION_
;/*
; * Window16 ASM Version
; */
proc window16
        window16 2                     ;/* 16b mono */
endproc

;/*
; * Window16 Dual ASM Version
; */
proc window16_dual
        window16 4                     ;/* 16b stereo */
endproc

;/*
; * Window8 ASM Version
; */
proc window8
        window8 1                      ;/* 16b mono */
endproc

;/*
; * Window8 Dual ASM Version
; */
proc window8_dual
        window8 2                      ;/* 16b stereo */
endproc
%endif

end
