;/*
; *  for MP3Player - Free Delphi Component (OCT. 1999)
; *  modified by Kei Ishida  kei-i@sams.co.jp
; */

;/*
; * mdct.c ASM version for the XingMPG Decoder
; * Include hybrid and FreqInvert functions
; *
; * Copyright (c) 1999, Jean-Michel HERVE
; *
; * This is hardcore coding, really! But should work pedity fine. If you find
; * a bug mmmmh... tell me where :)
; *
; * Code : TuO / StG
; * Date : 05/04/99
; *
; * This program is free software; you can redistribute it and/or modify
; * it under the terms of the GNU General Public License as published by
; * the Free Software Foundation; either version 2 of the License, or
; * (at your option) any later version.
; * 
; * This program is distributed in the hope that it will be useful,
; * but WITHOUT ANY WARRANTY; without even the implied warranty of
; * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; * GNU General Public License for more details.
; * 
; * You should have received a copy of the GNU General Public License
; * along with this program; if not, write to the Free Software
; * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
; * 
; * $Id: mdctasm.asm,v 1.3 1999/04/22 08:24:01 mhw Exp $
; */

%include "nasm.h"

segment_data

EXTERN _mdct18w
EXTERN _mdct18w2
EXTERN _mdct6_3v
EXTERN _mdct6_3v2
EXTERN _coef
EXTERN _coef87
EXTERN _win
EXTERN _band_limit_nsb

WINSIZE equ 144

My_FPU_Half dd 0.5, 0.5
D_1_1 dd 1.0, 1.0

SaveReturn dd 0

%macro div18 0
;   eax/18  edx ɕԂ
;   input   eax
;   output  edx
    mov edx,3817748708
    mul edx
    shr edx,4
%endmacro

%macro div36 0
;   eax/36  edx ɕԂ
;   input   eax
;   output  edx
    mov edx,3817748708
    mul edx
    shr edx,5
%endmacro


; a, b ׂ̕ fpu łƈႤ
%idefine    a(p)        [esp+((p)*2)*4]
%idefine    b(p)        [esp+((p)*2+1)*4]
%idefine    mdct18w(p)  [_mdct18w+(p)*4]
%idefine    mdct18w2(p) [_mdct18w2+(p)*4]
%idefine    coef(i,j)   [_coef+(i)*16+(j)*4]
%idefine    f(p)        [edi+(p)*4]

%if 1
; C^[X ver
proc imdct18_e3dn_inner
; void imdct18_e3dn(float f[18]) ̉
;   input   edi     f[18]
;   uses    eax
;   emms ͌Ăԑł邱
;   f[]  prefetch ǂ΁AĂԑł邱
;  C ̃\[X f[0] e f  2step ŌvZĂ
; 1step  f', ŏIʂ f ƃRg
        mov     eax, esp
        sub     esp, 18*4+4
        and     esp, ~8
        mov     [esp+18*4], eax         ; save the original ESP

        prefetchw   a(0)
        prefetchw   a(8)
%assign p 0                            ;/* Use compiler var as counter */
%rep 2
        movq    mm3, qword mdct18w(7-p)
        movq    mm1, qword mdct18w(16-p)
        movq    mm4, qword mdct18w(9+p)
        movq    mm0, qword mdct18w(p)
        pfmul   mm3, qword f(7-p)
        pfmul   mm1, qword f(16-p)
        pfmul   mm4, qword f(9+p)       ; g2
        pfmul   mm0, qword f(p)         ; g1
        pswapd  mm3, mm3                ; g1
        pswapd  mm1, mm1                ; g2
        movq    mm5, mm3
        movq    mm2, mm0
        pfsub   mm3, mm4
        pfsub   mm0, mm1
        pfadd   mm5, mm4                ; a8p
        pfadd   mm2, mm1                ; ap
        pswapd  mm6, qword mdct18w2(7-p)
        pfmul   mm0, qword mdct18w2(p)  ; bp
        movq    mm7, mm2
        pfmul   mm3, mm6                ; b8p
        movq    mm1, mm0
        pfadd   mm7, mm5                ; ap+a8p
        pfadd   mm1, mm3                ; bp+b8p
        pfsub   mm2, mm5                ; ap-a8p
        pfsub   mm0, mm3                ; bp-b8p
        movq    mm4, mm7
        movq    mm6, mm2
        punpckldq   mm7, mm1
        punpckldq   mm2, mm0
        movq    qword a(p), mm7
        movq    qword a(5+p), mm2
        punpckhdq   mm4, mm1
        punpckhdq   mm6, mm0
        movq    qword a(p+1), mm4
        movq    qword a(6+p), mm6
%assign p p+2
%endrep
        prefetch    coef(0,0)
        prefetch    coef(4,0)

%assign p 4
        movd    mm4, dword mdct18w(p)
        pfmul   mm4, qword f(p)         ; g1
        movd    mm5, dword mdct18w(17-p)
        pfmul   mm5, qword f(17-p)      ; g2
        movq    mm6, mm4
        movq    mm3, qword a(1)
        pfadd   mm4, mm5                ; a[p]
        pfsub   mm6, mm5
        movq    mm2, qword a(0)
        pfmul   mm6, qword mdct18w2(p)  ; b[p]
        pfadd   mm2, qword a(2)
        punpckldq   mm4, mm6
        movq    mm6, qword coef(1,0)
        pfadd   mm3, qword a(3)
        movq    mm1, qword coef(2,0)
        pfadd   mm2, mm4
        movq    mm7, mm6
        pfadd   mm2, mm3
        movq    mm3, mm1
        movq    qword a(p), mm4
        punpckldq   mm6, mm6
        movq    mm4, qword coef(1,2)
        punpckhdq   mm7, mm7
        pfmul   mm6, qword a(5)
        punpckldq   mm1, mm1
        pfmul   mm2, qword [My_FPU_Half]    ; f1':f0
        movq    mm5, mm4
        pfmul   mm7, qword a(6)     
        punpckhdq   mm3, mm3
        pswapd  mm0, mm2                    ; f0:f1'
        pfmul   mm1, qword a(0)
        punpckldq   mm4, mm4
        pfadd   mm6, mm7
        pfmul   mm3, qword a(1)     
        pfnacc  mm0, mm0                    ; f1:f1
        punpckhdq   mm5, mm5
        pfmul   mm4, qword a(7)
        pfadd   mm1, mm3
        punpckhdq   mm0, mm2                ; f1':f1        
        pfmul   mm5, qword a(8)     
        punpckldq   mm2, mm0                ; f1:f0
        pfadd   mm4, mm5
        movq    qword f(0), mm2     
        pfadd   mm6, mm4                    
        movq    mm2, qword coef(2,2)
        pfsub   mm6, mm0                    ; f3':f2
        movq    mm0, mm2
        pswapd  mm4, mm6                    ; f2:f3'
        punpckldq   mm2, mm2
        punpckhdq   mm0, mm0
        pfnacc  mm4, mm4                    ; f3:f3
        pfmul   mm2, qword a(2)
        pfmul   mm0, qword a(3)     
        punpckhdq   mm4, mm6                ; f3':f3
        pfadd   mm2, mm0
        movq    mm0, qword coef(4,2)
        punpckldq   mm6, mm4                ; f3:f2
        movq    mm7, qword a(5)
        pfadd   mm1, mm2
        movq    mm2, qword coef(4,0)
        movq    qword f(2), mm6     
        pfsub   mm1, qword a(4)             
        movq    mm5, qword coef(3,0)
        pfsub   mm1, mm4                    ; f5':f4
        pfsub   mm7, qword a(7)
        pswapd  mm3, mm1                    
        punpckldq   mm5, mm5
        pfnacc  mm3, mm3                    
        pfsub   mm7, qword a(8)
        punpckhdq   mm3, mm1                
        pfmul   mm5, mm7
        punpckldq   mm1, mm3                
        pfsub   mm5, mm3                    ; f7':f6
        movq    qword f(4), mm1     
        movq    mm1, mm0
        movq    mm3, mm2
        punpckldq   mm0, mm0
        punpckhdq   mm3, mm3
        pswapd  mm7, mm5                    
        pfmul   mm3, qword a(1)     
        punpckhdq   mm1, mm1
        pfmul   mm0, qword a(2)
        punpckldq   mm2, mm2
        pfmul   mm1, qword a(3)     
        pfnacc  mm7, mm7                    
        pfmul   mm2, qword a(0)
        punpckhdq   mm7, mm5                
        pfadd   mm2, mm3
        pfadd   mm0, mm1
        punpckldq   mm5, mm7                
        pfadd   mm2, mm0
        movq    mm6, qword coef(5,0)
        pfadd   mm2, qword a(4)             
        movq    mm4, qword coef(5,2)
        pfsub   mm2, mm7                    ; f9':f8
        movq    mm7, mm6
        movq    qword f(6), mm5     
        punpckldq   mm6, mm6
        movq    mm5, mm4
        pfmul   mm6, qword a(5)
        punpckhdq   mm7, mm7
        pswapd  mm0, mm2                    
        punpckldq   mm4, mm4
        pfmul   mm7, qword a(6)     
        pfnacc  mm0, mm0                    
        punpckhdq   mm5, mm5
        pfadd   mm6, mm7
        pfmul   mm4, qword a(7)
        punpckhdq   mm0, mm2                
        pfmul   mm5, qword a(8)     
        punpckldq   mm2, mm0                
        pfadd   mm4, mm5
        movq    mm1, qword a(0)
        movq    qword f(8), mm2     
        movq    mm3, qword a(1)
        pfadd   mm6, mm4                    
        pfadd   mm1, qword a(2)
        pfsub   mm6, mm0                    ; f11':f10
        pfadd   mm3, qword a(4)
        pswapd  mm4, mm6                    
        pfadd   mm1, qword a(3)
        pfnacc  mm4, mm4                    
        pfmul   mm1, qword [My_FPU_Half]
        punpckhdq   mm4, mm6                
        pfsub   mm1, mm3
        punpckldq   mm6, mm4                
        pfsub   mm1, mm4                    ; f13':f12
        movq    mm5, qword coef(7,0)
        movq    qword f(10), mm6        
        movq    mm6, qword coef(7,2)
        movq    mm7, mm5
        movq    mm4, mm6
        punpckldq   mm5, mm5
        punpckldq   mm6, mm6
        punpckhdq   mm7, mm7
        punpckhdq   mm4, mm4
        pfmul   mm5, qword a(5)
        pfmul   mm6, qword a(7)
        pfmul   mm7, qword a(6)     
        pswapd  mm3, mm1                    
        pfmul   mm4, qword a(8)     
        pfnacc  mm3, mm3                    
        pfadd   mm5, mm7
        punpckhdq   mm3, mm1                
        pfadd   mm6, mm4
        punpckldq   mm1, mm3                
        movq    mm2, qword coef(8,0)
        pfadd   mm5, mm6                    
        movq    mm0, qword coef(8,2)
        movq    qword f(12), mm1        
        movq    mm1, mm0
        pfsub   mm5, mm3                    ; f15':f14
        movq    mm3, mm2
        punpckldq   mm2, mm2
        punpckldq   mm0, mm0
        punpckhdq   mm3, mm3
        punpckhdq   mm1, mm1
        pfmul   mm2, qword a(0)
        pfmul   mm0, qword a(2)
        pfmul   mm3, qword a(1)     
        pfmul   mm1, qword a(3)     
        pswapd  mm7, mm5                    
        pfadd   mm2, mm3
        pfnacc  mm7, mm7                    
        pfadd   mm0, mm1
        punpckhdq   mm7, mm5                
        pfadd   mm2, mm0
        punpckldq   mm5, mm7                
        pfadd   mm2, qword a(4)             
        movq    qword f(14), mm5        
        pfsub   mm2, mm7                    ; f17':f16
        pswapd  mm0, mm2                    
        pfnacc  mm0, mm0                    
        punpckldq   mm2, mm0                
        movq    qword f(16), mm2        

        mov     esp,[esp+18*4]
endproc
%else
proc imdct18_e3dn_inner
; void imdct18_e3dn(float f[18]) ̉
;   input   edi     f[18]
;   uses    none
;   emms ͌Ăԑł邱
;   f[]  prefetch ǂ΁AĂԑł邱

        mov     eax, esp
        sub     esp, 18*4+4
        and     esp, ~8
        mov     [esp+18*4], eax         ; save the original ESP

        prefetchw   a(0)
        prefetchw   a(8)
%assign p 0                            ;/* Use compiler var as counter */
%rep 2
        movq    mm0, qword mdct18w(p)
        pfmul   mm0, qword f(p)         ; g1

        movq    mm1, qword mdct18w(16-p)
        pfmul   mm1, qword f(16-p)
        pswapd  mm1, mm1                ; g2

        movq    mm2, mm0
        pfadd   mm2, mm1                ; ap

        pfsub   mm0, mm1
        pfmul   mm0, qword mdct18w2(p)  ; bp

        movq    mm3, qword mdct18w(7-p)
        pfmul   mm3, qword f(7-p)
        pswapd  mm3, mm3                ; g1

        movq    mm4, qword mdct18w(9+p)
        pfmul   mm4, qword f(9+p)       ; g2

        movq    mm5, mm3
        pfadd   mm5, mm4                ; a8p

        pfsub   mm3, mm4
        pswapd  mm6, qword mdct18w2(7-p)
        pfmul   mm3, mm6                ; b8p

        movq    mm7, mm2
        pfadd   mm7, mm5                ; ap+a8p
        pfsub   mm2, mm5                ; ap-a8p

        movq    mm1, mm0
        pfadd   mm1, mm3                ; bp+b8p
        pfsub   mm0, mm3                ; bp-b8p

        movq    mm4, mm7
        punpckldq   mm7, mm1
        movq    qword a(p), mm7
        punpckhdq   mm4, mm1
        movq    qword a(p+1), mm4

        movq    mm6, mm2
        punpckldq   mm2, mm0
        movq    qword a(5+p), mm2
        punpckhdq   mm6, mm0
        movq    qword a(6+p), mm6
%assign p p+2
%endrep
        prefetch    coef(0,0)
        prefetch    coef(4,0)

%assign p 4
        movd    mm4, dword mdct18w(p)
        pfmul   mm4, qword f(p)         ; g1
        movd    mm5, dword mdct18w(17-p)
        pfmul   mm5, qword f(17-p)      ; g2
        movq    mm6, mm4
        pfadd   mm4, mm5                ; a[p]
        pfsub   mm6, mm5
        pfmul   mm6, qword mdct18w2(p)  ; b[p]
        punpckldq   mm4, mm6
        movq    qword a(p), mm4

        ;  C ̃\[X f[0] e f  2step ŌvZĂ
        ; ȍ~A1step  f', ŏIʂ f ƃRg
        movq    mm2, qword a(0)
        movq    mm3, qword a(1)
        pfadd   mm2, qword a(2)
        pfadd   mm3, qword a(3)
        pfadd   mm2, qword a(4)
        pfadd   mm2, mm3
        pfmul   mm2, qword [My_FPU_Half]    ; f1':f0
        pswapd  mm0, mm2                    ; f0:f1'
        pfnacc  mm0, mm0                    ; f1:f1
        punpckhdq   mm0, mm2                ; f1':f1        
        punpckldq   mm2, mm0                ; f1:f0
        movq    qword f(0), mm2     

        movq    mm6, qword coef(1,0)
        movq    mm4, qword coef(1,2)
        movq    mm7, mm6
        movq    mm5, mm4
        punpckldq   mm6, mm6
        punpckldq   mm4, mm4
        punpckhdq   mm7, mm7
        punpckhdq   mm5, mm5
        pfmul   mm6, qword a(5)
        pfmul   mm4, qword a(7)
        pfmul   mm7, qword a(6)     
        pfmul   mm5, qword a(8)     
        pfadd   mm6, mm7
        pfadd   mm4, mm5
        pfadd   mm6, mm4                    
        pfsub   mm6, mm0                    ; f3':f2
        pswapd  mm4, mm6                    ; f2:f3'
        pfnacc  mm4, mm4                    ; f3:f3
        punpckhdq   mm4, mm6                ; f3':f3
        punpckldq   mm6, mm4                ; f3:f2
        movq    qword f(2), mm6     

        movq    mm1, qword coef(2,0)
        movq    mm2, qword coef(2,2)
        movq    mm3, mm1
        movq    mm0, mm2
        punpckldq   mm1, mm1
        punpckldq   mm2, mm2
        punpckhdq   mm3, mm3
        punpckhdq   mm0, mm0
        pfmul   mm1, qword a(0)
        pfmul   mm2, qword a(2)
        pfmul   mm3, qword a(1)     
        pfmul   mm0, qword a(3)     
        pfadd   mm1, mm3
        pfadd   mm2, mm0
        pfadd   mm1, mm2
        pfsub   mm1, qword a(4)             
        pfsub   mm1, mm4                    ; f5':f4
        pswapd  mm3, mm1                    
        pfnacc  mm3, mm3                    
        punpckhdq   mm3, mm1                
        punpckldq   mm1, mm3                
        movq    qword f(4), mm1     

        movq    mm5, qword coef(3,0)
        movq    mm7, qword a(5)
        punpckldq   mm5, mm5
        pfsub   mm7, qword a(7)
        pfsub   mm7, qword a(8)
        pfmul   mm5, mm7
        pfsub   mm5, mm3                    ; f7':f6
        pswapd  mm7, mm5                    
        pfnacc  mm7, mm7                    
        punpckhdq   mm7, mm5                
        punpckldq   mm5, mm7                
        movq    qword f(6), mm5     

        movq    mm2, qword coef(4,0)
        movq    mm0, qword coef(4,2)
        movq    mm3, mm2
        movq    mm1, mm0
        punpckldq   mm2, mm2
        punpckldq   mm0, mm0
        punpckhdq   mm3, mm3
        punpckhdq   mm1, mm1
        pfmul   mm2, qword a(0)
        pfmul   mm0, qword a(2)
        pfmul   mm3, qword a(1)     
        pfmul   mm1, qword a(3)     
        pfadd   mm2, mm3
        pfadd   mm0, mm1
        pfadd   mm2, mm0
        pfadd   mm2, qword a(4)             
        pfsub   mm2, mm7                    ; f9':f8
        pswapd  mm0, mm2                    
        pfnacc  mm0, mm0                    
        punpckhdq   mm0, mm2                
        punpckldq   mm2, mm0                
        movq    qword f(8), mm2     

        movq    mm6, qword coef(5,0)
        movq    mm4, qword coef(5,2)
        movq    mm7, mm6
        movq    mm5, mm4
        punpckldq   mm6, mm6
        punpckldq   mm4, mm4
        punpckhdq   mm7, mm7
        punpckhdq   mm5, mm5
        pfmul   mm6, qword a(5)
        pfmul   mm4, qword a(7)
        pfmul   mm7, qword a(6)     
        pfmul   mm5, qword a(8)     
        pfadd   mm6, mm7
        pfadd   mm4, mm5
        pfadd   mm6, mm4                    
        pfsub   mm6, mm0                    ; f11':f10
        pswapd  mm4, mm6                    
        pfnacc  mm4, mm4                    
        punpckhdq   mm4, mm6                
        punpckldq   mm6, mm4                
        movq    qword f(10), mm6        

        movq    mm1, qword a(0)
        movq    mm3, qword a(1)
        pfadd   mm1, qword a(2)
        pfadd   mm3, qword a(4)
        pfadd   mm1, qword a(3)
        pfmul   mm1, qword [My_FPU_Half]
        pfsub   mm1, mm3
        pfsub   mm1, mm4                    ; f13':f12
        pswapd  mm3, mm1                    
        pfnacc  mm3, mm3                    
        punpckhdq   mm3, mm1                
        punpckldq   mm1, mm3                
        movq    qword f(12), mm1        

        movq    mm5, qword coef(7,0)
        movq    mm6, qword coef(7,2)
        movq    mm7, mm5
        movq    mm4, mm6
        punpckldq   mm5, mm5
        punpckldq   mm6, mm6
        punpckhdq   mm7, mm7
        punpckhdq   mm4, mm4
        pfmul   mm5, qword a(5)
        pfmul   mm6, qword a(7)
        pfmul   mm7, qword a(6)     
        pfmul   mm4, qword a(8)     
        pfadd   mm5, mm7
        pfadd   mm6, mm4
        pfadd   mm5, mm6                    
        pfsub   mm5, mm3                    ; f15':f14
        pswapd  mm7, mm5                    
        pfnacc  mm7, mm7                    
        punpckhdq   mm7, mm5                
        punpckldq   mm5, mm7                
        movq    qword f(14), mm5        

        movq    mm2, qword coef(8,0)
        movq    mm0, qword coef(8,2)
        movq    mm3, mm2
        movq    mm1, mm0
        punpckldq   mm2, mm2
        punpckldq   mm0, mm0
        punpckhdq   mm3, mm3
        punpckhdq   mm1, mm1
        pfmul   mm2, qword a(0)
        pfmul   mm0, qword a(2)
        pfmul   mm3, qword a(1)     
        pfmul   mm1, qword a(3)     
        pfadd   mm2, mm3
        pfadd   mm0, mm1
        pfadd   mm2, mm0
        pfadd   mm2, qword a(4)             
        pfsub   mm2, mm7                    ; f17':f16
        pswapd  mm0, mm2                    
        pfnacc  mm0, mm0                    
        punpckldq   mm2, mm0                
        movq    qword f(16), mm2        

        mov     esp,[esp+18*4]
endproc
%endif

%undef    a
%undef    b
%undef    mdct18w
%undef    mdct18w2
%undef    coef
%undef    f

%idefine    a(p,i)      [esp+((p)*6+((i)% 3)*2+(i)/3)*4]
%idefine    mdct6_3v(p) [_mdct6_3v+(p)*4]
%idefine    mdct6_3v2(p) [_mdct6_3v2+(p)*4]
%idefine    f(p)        [edi+(p)*4]
%idefine    c(p,i)      [edi+((p)*6+(i))*4]

%if 1
proc imdct6_3_e3dn_inner
; void imdct6_3(float f[]) ̉
;   input   edi     f[]
;   uses    eax
;   emms ͌Ăԑł邱
;   f[]  prefetch ǂ΁AĂԑł邱

        mov     eax, esp
        sub     esp, 18*4+4
        and     esp, ~8
        mov     [esp+18*4], eax         ; save the original ESP

        prefetchw   a(0,0)
        prefetchw   [esp+64]

        movq    mm2, qword [D_1_1]
        movq    mm0, qword mdct6_3v(0)
        pswapd  mm6, qword mdct6_3v(4)
        movq    mm3, mm2
        movq    mm4, mm2
        movq    mm1, mm0
        punpckldq   mm2, qword mdct6_3v2(0)
        punpckldq   mm0, mm6
        punpckldq   mm3, qword mdct6_3v2(1)
        punpckhdq   mm1, mm6
        punpckldq   mm4, qword mdct6_3v2(2)

%assign p 0
%rep 3
        movd    mm5, dword f(0+p)
        movd    mm6, dword f(3+p)
        movd    mm7, dword f(6+p)
        punpckldq   mm5, qword f(15+p)
        punpckldq   mm6, qword f(12+p)
        punpckldq   mm7, qword f(9+p)
        pfmul   mm5, mm0
        pfmul   mm6, mm1
        pfmul   mm7, qword mdct6_3v(2)
        pfpnacc mm5, mm5
        pfpnacc mm6, mm6
        pfpnacc mm7, mm7
        pswapd  mm5, mm5
        pswapd  mm6, mm6
        pswapd  mm7, mm7
        pfmul   mm5, mm2
        pfmul   mm6, mm3
        pfmul   mm7, mm4
        movq    qword a(p,0), mm5
        movq    qword a(p,1), mm6
        movq    qword a(p,2), mm7
%assign p p+1
%endrep

%assign p 0
%assign q 1
%assign r 2
        movq    mm0, qword a(p,0)
        movq    mm2, qword a(q,0)
        movq    mm4, qword a(r,0)
        pfadd   mm0, qword a(p,2)           
        pfadd   mm2, qword a(q,2)           
        movd    mm7, dword [_coef87]
        pfadd   mm0, qword a(p,1)           ; c1':c0
        movq    mm6, mm2
        pfadd   mm4, qword a(r,2)
        pswapd  mm1, mm0                    ; c0:c1'
        pfadd   mm2, qword a(q,1)           ; c1':c0
        punpckldq   mm7, mm7
        pfadd   mm4, qword a(r,1)           ; c1':c0
        pfnacc  mm1, mm1                    ; c1:c1
        pswapd  mm3, mm2                    ; c0:c1'
        pswapd  mm5, mm4                    ; c0:c1'
        punpckhdq   mm1, mm0                ; c1':c1
        pfnacc  mm3, mm3                    ; c1:c1
        pfnacc  mm5, mm5                    ; c1:c1
        punpckldq   mm0, mm1                ; c1:c0
        punpckhdq   mm3, mm2                ; c1':c1
        punpckhdq   mm5, mm4                ; c1':c1
        movq    qword c(p,0), mm0     
        punpckldq   mm2, mm3                ; c1:c0
        punpckldq   mm4, mm5                ; c1:c0
        movq    mm0, qword a(p,0)
        movq    qword c(q,0), mm2     
        movq    qword c(r,0), mm4     
        pfsub   mm0, qword a(p,2)
        movq    mm2, qword a(q,0)
        movq    mm4, qword a(r,0)
        pfmul   mm0, mm7
        pfsub   mm2, qword a(q,2)
        pfsub   mm4, qword a(r,2)
        pfsub   mm0, mm1                    ; c3':c2
        pfmul   mm2, mm7
        pfmul   mm7, mm4
        pswapd  mm1, mm0                    
        pfsub   mm2, mm3                    ; c3':c2
        movq    mm4, qword a(r,1)
        pfnacc  mm1, mm1                    
        pswapd  mm3, mm2                    
        pfsub   mm7, mm5                    ; c3':c2
        punpckhdq   mm1, mm0                
        pfsub   mm6, qword a(q,1)
        pfadd   mm4, mm4
        punpckldq   mm0, mm1                
        pfnacc  mm3, mm3                    
        pswapd  mm5, mm7                    
        movq    qword c(p,2), mm0     
        punpckhdq   mm3, mm2                
        pfsubr  mm4, qword a(r,0)
        movq    mm0, qword a(p,1)
        pfsub   mm6, qword a(q,1)
        pfnacc  mm5, mm5                    
        pfadd   mm0, mm0
        punpckldq   mm2, mm3                
        pfadd   mm4, qword a(r,2)
        pfsubr  mm0, qword a(p,0)
        movq    qword c(q,2), mm2     
        punpckhdq   mm5, mm7                
        pfadd   mm0, qword a(p,2)
        pfsub   mm6, mm3                    ; c5':c4
        punpckldq   mm7, mm5                
        pfsub   mm0, mm1                    ; c5':c4
        pswapd  mm3, mm6                    
        pfsub   mm4, mm5                    ; c5':c4
        pswapd  mm1, mm0                    
        pfnacc  mm3, mm3                    
        pswapd  mm5, mm4                    
        pfnacc  mm1, mm1                    
        punpckldq   mm6, mm3                
        pfnacc  mm5, mm5                    
        punpckldq   mm0, mm1                
        movq    qword c(q,4), mm6     
        punpckldq   mm4, mm5                
        movq    qword c(p,4), mm0     
        movq    qword c(r,2), mm7     
        movq    qword c(r,4), mm4     

        mov     esp,[esp+18*4]
endproc
%else
proc imdct6_3_e3dn_inner
; void imdct6_3(float f[]) ̉
;   input   edi     f[]
;   uses    none
;   emms ͌Ăԑł邱
;   f[]  prefetch ǂ΁AĂԑł邱

        mov     eax, esp
        sub     esp, 18*4+4
        and     esp, ~8
        mov     [esp+18*4], eax         ; save the original ESP

        prefetchw   a(0,0)
        prefetchw   [esp+64]


        movq    mm0, qword mdct6_3v(0)
        pswapd  mm6, qword mdct6_3v(4)
        movq    mm1, mm0
        punpckldq   mm0, mm6
        punpckhdq   mm1, mm6
        
        movq    mm2, qword [D_1_1]
        movq    mm3, mm2
        movq    mm4, mm2
        punpckldq   mm2, qword mdct6_3v2(0)
        punpckldq   mm3, qword mdct6_3v2(1)
        punpckldq   mm4, qword mdct6_3v2(2)

%assign p 0
%rep 3
        movd    mm5, dword f(0+p)
        punpckldq   mm5, qword f(15+p)
        pfmul   mm5, mm0
        pfpnacc mm5, mm5
        pswapd  mm5, mm5
        pfmul   mm5, mm2
        movq    qword a(p,0), mm5
        
        movd    mm6, dword f(3+p)
        punpckldq   mm6, qword f(12+p)
        pfmul   mm6, mm1
        pfpnacc mm6, mm6
        pswapd  mm6, mm6
        pfmul   mm6, mm3
        movq    qword a(p,1), mm6

        movd    mm7, dword f(6+p)
        punpckldq   mm7, qword f(9+p)
        pfmul   mm7, qword mdct6_3v(2)
        pfpnacc mm7, mm7
        pswapd  mm7, mm7
        pfmul   mm7, mm4
        movq    qword a(p,2), mm7
%assign p p+1
%endrep
        movd    mm7, dword [_coef87]
        punpckldq   mm7, mm7

%assign p 0
%assign q 1
%assign r 2
        movq    mm0, qword a(p,0)
        pfadd   mm0, qword a(p,2)           
        pfadd   mm0, qword a(p,1)           ; c1':c0
        pswapd  mm1, mm0                    ; c0:c1'
        pfnacc  mm1, mm1                    ; c1:c1
        punpckhdq   mm1, mm0                ; c1':c1
        punpckldq   mm0, mm1                ; c1:c0
        movq    qword c(p,0), mm0     
        
        movq    mm0, qword a(p,0)
        pfsub   mm0, qword a(p,2)
        pfmul   mm0, mm7
        pfsub   mm0, mm1                    ; c3':c2
        pswapd  mm1, mm0                    
        pfnacc  mm1, mm1                    
        punpckhdq   mm1, mm0                
        punpckldq   mm0, mm1                
        movq    qword c(p,2), mm0     

        movq    mm0, qword a(p,1)
        pfadd   mm0, mm0
        pfsubr  mm0, qword a(p,0)
        pfadd   mm0, qword a(p,2)
        pfsub   mm0, mm1                    ; c5':c4
        pswapd  mm1, mm0                    
        pfnacc  mm1, mm1                    
        punpckldq   mm0, mm1                
        movq    qword c(p,4), mm0     


        movq    mm2, qword a(q,0)
        pfadd   mm2, qword a(q,2)           
        movq    mm6, mm2
        pfadd   mm2, qword a(q,1)           ; c1':c0
        pswapd  mm3, mm2                    ; c0:c1'
        pfnacc  mm3, mm3                    ; c1:c1
        punpckhdq   mm3, mm2                ; c1':c1
        punpckldq   mm2, mm3                ; c1:c0
        movq    qword c(q,0), mm2     
        
        movq    mm2, qword a(q,0)
        pfsub   mm2, qword a(q,2)
        pfmul   mm2, mm7
        pfsub   mm2, mm3                    ; c3':c2
        pswapd  mm3, mm2                    
        pfnacc  mm3, mm3                    
        punpckhdq   mm3, mm2                
        punpckldq   mm2, mm3                
        movq    qword c(q,2), mm2     

        pfsub   mm6, qword a(q,1)
        pfsub   mm6, qword a(q,1)
        pfsub   mm6, mm3                    ; c5':c4
        pswapd  mm3, mm6                    
        pfnacc  mm3, mm3                    
        punpckldq   mm6, mm3                
        movq    qword c(q,4), mm6     


        movq    mm4, qword a(r,0)
        pfadd   mm4, qword a(r,2)
        pfadd   mm4, qword a(r,1)           ; c1':c0
        pswapd  mm5, mm4                    ; c0:c1'
        pfnacc  mm5, mm5                    ; c1:c1
        punpckhdq   mm5, mm4                ; c1':c1
        punpckldq   mm4, mm5                ; c1:c0
        movq    qword c(r,0), mm4     
        
        movq    mm4, qword a(r,0)
        pfsub   mm4, qword a(r,2)
        pfmul   mm7, mm4
        pfsub   mm7, mm5                    ; c3':c2
        pswapd  mm5, mm7                    
        pfnacc  mm5, mm5                    
        punpckhdq   mm5, mm7                
        punpckldq   mm7, mm5                
        movq    qword c(r,2), mm7     

        movq    mm4, qword a(r,1)
        pfadd   mm4, mm4
        pfsubr  mm4, qword a(r,0)
        pfadd   mm4, qword a(r,2)
        pfsub   mm4, mm5                    ; c5':c4
        pswapd  mm5, mm4                    
        pfnacc  mm5, mm5                    
        punpckldq   mm4, mm5                
        movq    qword c(r,4), mm4     

        mov     esp,[esp+18*4]
endproc
%endif

%undef    a
%undef    mdct6_3v
%undef    mdct6_3v2
%undef    f
%undef    c

;/*
; * imdct18 ASM Version
; */
proc imdct18_e3dn ;// PROC f[]
%$f     arg     4
        pushd   edi
        mov     edi, [sp(%$f)]
        call    _imdct18_e3dn_inner
        femms
        popd    edi
endproc

;/*
; * imdct6_3 ASM Version
; */
proc imdct6_3_e3dn ;// PROC f[]
%$f     arg     4
        pushd   edi
        mov     edi, [sp(%$f)]
        call    _imdct6_3_e3dn_inner
        femms
        popd    edi
endproc

;/*
; * hybrid ASM for e3dn Version
; */

%idefine    win(j)  [ebx+(j)*4]
%idefine    x(j)    [edi+(j)*4]
%idefine    x0(j)   [esi+(j)*4]
%idefine    y(j,i)  [ebp+(j)*128+(i)*4]

%if 1
;   C^[X ver
;    C R[hƂ悻Ԃ ver 

proc hybrid_e3dn_cmov ;// xin[] xprev[] y[18][32] btype  nlong  ntot   nprev
%$xin   arg     4
%$xprev arg     4
%$yout  arg     4
%$btype arg     4
%$nlong arg     4
%$ntot  arg     4
%$nprev arg     4

        pushd   ebx, esi, edi, ebp

        mov     ebx, [sp(%$btype)]
        xor     ecx, ecx        ; loop counter i
        cmp     ebx, 2
        mov     eax, WINSIZE
        cmovz   ebx, ecx
        mul     ebx
        lea     ebx, [_win+eax] ; ebx is win[btype]

        mov     edi, [sp(%$xin)]    ; edi is x
        mov     esi, [sp(%$xprev)]  ; esi is x0
        mov     ebp, [sp(%$yout)]   ; ebp is y

        mov     eax, [sp(%$nlong)]
        add     eax, 17
        div18                   ; edx is n
        cmp     ecx, edx
        jge     near .ExitLongBlockLoop

        ;/* Long block loop */
        prefetch    win(0)
        prefetch    win(16)
        align 4
    .LongBlockLoop:
        prefetchw   x(18)
        prefetch    x0(18)

        call _imdct18_e3dn_inner
        ;/* Unrool first J-controlled loop */
%assign j 0
        movd    mm0, dword x(9+j)
        movd    mm1, dword x(17-j)
        pfmul   mm0, qword win(j)
        pfmul   mm1, qword win(9+j)
        pfadd   mm0, qword x0(j)
        pfadd   mm1, qword x0(9+j)
        movd    dword y(j, ecx), mm0
        movd    dword y(9+j, ecx), mm1
%assign j 1
%rep 2
        movq    mm0, qword x(9+j)
        pswapd  mm1, qword x(16-j)
        movq    mm2, qword x(9+j+2)
        pswapd  mm3, qword x(16-j-2)

        pfmul   mm0, qword win(j)
        pfmul   mm1, qword win(9+j)
        pfmul   mm2, qword win(j+2)
        pfmul   mm3, qword win(9+j+2)

        pfadd   mm0, qword x0(j)
        pfadd   mm1, qword x0(9+j)
        pfadd   mm2, qword x0(j+2)
        pfadd   mm3, qword x0(9+j+2)

        movd    dword y(j, ecx), mm0
        movd    dword y(9+j, ecx), mm1
        movd    dword y(j+2, ecx), mm2
        movd    dword y(9+2+j, ecx), mm3

        psrlq   mm0, 32
        psrlq   mm1, 32
        psrlq   mm2, 32
        psrlq   mm3, 32

        movd    dword y(j+1, ecx), mm0
        movd    dword y(10+j, ecx), mm1
        movd    dword y(j+2+1, ecx), mm2
        movd    dword y(10+2+j, ecx), mm3
%assign j j+4
%endrep

        ;/* Unrool second J-controlled loop */
%assign j 0
%rep 2
        movq    mm0, qword x(j)         ;xa(j+1):xa(j)
        movq    mm1, qword x(7-j)       ;xb(j):xb(j+1)
        movq    mm4, qword win(18+9+j)  ;win(19+9+j):win(18+9+j)
        movq    mm5, qword win(17+17-j) ;win(18+17-j):win(17+17-j)
        pswapd  mm2, mm0                ;xa(j):xa(j+1)
        pswapd  mm3, mm1                ;xb(j+1):xb(j)
        movq    mm6, qword win(17+8-j)  ;win(18+8-j):win(17+8-j)
        movq    mm7, qword win(18+j)    ;win(19+j):win(18+j)

        pfmul   mm4, mm0
        pfmul   mm5, mm1                ;
        pfmul   mm6, mm2                ;win(18+8-j)*xa(j):win(17+8-j)*xa(j+1)
        pfmul   mm7, mm3                ;

        movq    qword x(9+j), mm4
        movq    qword x(16-j), mm5
        movq    qword x(7-j), mm6
        movq    qword x(j), mm7
%assign j j+2
%endrep

        ;/* Handle last special case */
%assign j 4
        movd    mm0, dword x(j)         ;xa
        movd    mm1, dword win(18+j)    ;win
        movd    mm2, dword win(18+9+j)
        pfmul   mm1, mm0
        pfmul   mm2, mm0
        movd    dword x(j), mm1
        movd    dword x(9+j), mm2

        add     edi,18*4                ;/* Update x */
        add     esi,18*4                ;/* Update x0 */
        inc     ecx                     ;/* Increment counter */
        cmp     ecx, edx
        jl      near .LongBlockLoop
    .ExitLongBlockLoop:

        mov     eax, [sp(%$ntot)]
        add     eax, 17
        div18
        cmp     ecx, edx
        jge     near .ExitShortBlockLoop

        ;/* Short block loop */
        mov         ebx, _win+(WINSIZE*2)    ;/* address of win[2] is in edx */
        prefetch    win(0)
        prefetch    win(16)
        align 4
    .ShortBlockLoop:
        prefetchw   x(18)
        prefetch    x0(18)

        call _imdct6_3_e3dn_inner

        ;/* First unrolled loop */
%assign j 0
        movd    mm0, dword x0(j)
        mov     eax, dword x0(3+j)
        movd    mm6, dword win(j)
        movd    mm7, dword win(3+j)
        movd    dword y(j, ecx), mm0
        mov     dword y(3+j, ecx), eax

        movd    mm0, dword x(3+j)
        movd    mm1, dword x(5-j)

        pfmul   mm0, mm6
        pfmul   mm1, mm7

        pfadd   mm0, qword x0(6+j)
        pfadd   mm1, qword x0(9+j)
        pfmul   mm6, qword x(6+3+j)
        pfmul   mm7, qword x(6+5-j)

        movd    dword y(6+j, ecx), mm0
        movd    dword y(9+j, ecx), mm1
        movd    mm2, dword x(2-j)
        movd    mm4, dword x(j)

        pfmul   mm2, qword win(6+j)
        pfmul   mm4, qword win(9+j)

        pfadd   mm2, mm6
        pfadd   mm4, mm7

        pfadd   mm2, qword x0(12+j)
        pfadd   mm4, qword x0(15+j)

        movd    dword y(12+j, ecx), mm2
        movd    dword y(15+j, ecx), mm4

%assign j 1
        movq    mm0, qword x0(j)
        movq    mm1, qword x0(3+j)

        movq    mm6, qword win(j)
        movq    mm7, qword win(3+j)

        movd    dword y(j, ecx), mm0
        movd    dword y(3+j, ecx), mm1

        psrlq   mm1, 32
        psrlq   mm0, 32

        movd    dword y(j+1, ecx), mm0
        movd    dword y(3+j+1, ecx), mm1
        pswapd  mm5, qword x(5+5-j)

        movq    mm0, qword x(3+j)
        pswapd  mm1, qword x(4-j)

        pfmul   mm0, mm6
        pfmul   mm1, mm7

        pfadd   mm0, qword x0(6+j)
        pfadd   mm1, qword x0(9+j)
        pfmul   mm6, qword x(6+3+j)
        pfmul   mm7, mm5

        movd    dword y(6+j, ecx), mm0
        movd    dword y(9+j, ecx), mm1
        pswapd  mm2, qword x(1-j)
        movq    mm4, qword x(j)

        psrlq   mm0, 32
        psrlq   mm1, 32
        pfmul   mm2, qword win(6+j)
        pfmul   mm4, qword win(9+j)

        movd    dword y(6+j+1, ecx), mm0
        movd    dword y(9+j+1, ecx), mm1
        pfadd   mm2, mm6
        pfadd   mm4, mm7

        pfadd   mm2, qword x0(12+j)
        pfadd   mm4, qword x0(15+j)

        movd    dword y(12+j, ecx), mm2
        movd    dword y(15+j, ecx), mm4

        psrlq   mm2, 32
        psrlq   mm4, 32

        movd    dword y(12+j+1, ecx), mm2
        movd    dword y(15+j+1, ecx), mm4

%assign j 1
        movq    mm6, qword win(6+j)
        movq    mm7, qword win(9+j)

        ;/* Second unrolled loop */
%assign j 0
        movd    mm0, dword x(12+3+j)
        movd    mm1, dword x(6+2-j)
        movd    mm2, dword x(12+5-j)
        movd    mm3, dword x(6+j)
        pfmul   mm0, qword win(j)
        pfmul   mm1, qword win(6+j)
        pfmul   mm2, qword win(3+j)
        pfmul   mm3, qword win(9+j)
        pfadd   mm0, mm1
        pfadd   mm2, mm3
        movd    dword x(j), mm0
        movd    dword x(3+j), mm2

%assign j 1
        movq    mm0, qword x(12+3+j)
        pswapd  mm1, qword x(5+2-j)
        pswapd  mm2, qword x(11+5-j)
        movq    mm3, qword x(6+j)
        pfmul   mm0, qword win(j)
        pfmul   mm2, qword win(3+j)
        pfmul   mm1, mm6
        pfmul   mm3, mm7
        pfadd   mm0, mm1
        pfadd   mm2, mm3
        movq    qword x(j), mm0
        movq    qword x(3+j), mm2

        ;/* Third unrolled loop */
%assign j 0
%assign k 1
        movd    mm0, dword x(12+2-j)
        movd    mm1, dword x(12+j)
        pswapd  mm2, qword x(11+2-k)
        pfmul   mm7, qword x(12+k)
        pfmul   mm0, qword win(6+j)
        pfmul   mm1, qword win(9+j)
        pfmul   mm2, mm6
        movq    qword x(9+k), mm7
        movd    dword x(6+j), mm0
        movd    dword x(9+j), mm1
        movq    qword x(6+k), mm2


        ;/* Fourth unrolled loop */
        pxor    mm0, mm0
%assign j 0
%rep 3
        movq    qword x(12+(j*2)), mm0
%assign j j+1
%endrep

        add    edi,18*4                ;/* Update x */
        add    esi,18*4                ;/* Update x0 */

        inc    ecx
        cmp    ecx, edx
        jl     near .ShortBlockLoop
    .ExitShortBlockLoop:

        mov     eax, [sp(%$nprev)]
        add     eax,17
        div18
        cmp     ecx, edx
        jge     near .ExitLastBlockLoop
        ;/* Short block loop */
        align 4
      .LastBlockLoop:
        prefetch    x0(18)
%assign j 0
        movq    mm0, x0(j+ 0)
        movq    mm1, x0(j+ 2)
        movq    mm2, x0(j+ 4)
        movq    mm3, x0(j+ 6)
        movd    dword y(j+ 0, ecx), mm0
        movd    dword y(j+ 2, ecx), mm1
        movd    dword y(j+ 4, ecx), mm2
        movd    dword y(j+ 6, ecx), mm3
        psrlq   mm0, 32
        psrlq   mm1, 32
        psrlq   mm2, 32
        psrlq   mm3, 32
        movd    dword y(j+ 1, ecx), mm0
        movd    dword y(j+ 3, ecx), mm1
        movd    dword y(j+ 5, ecx), mm2
        movd    dword y(j+ 7, ecx), mm3
%assign j 8
        movq    mm7, x0(j+ 0)
        movq    mm6, x0(j+ 2)
        movq    mm5, x0(j+ 4)
        movq    mm4, x0(j+ 6)
        movq    mm3, x0(j+ 8)
        movd    dword y(j+ 0, ecx), mm7
        movd    dword y(j+ 2, ecx), mm6
        movd    dword y(j+ 4, ecx), mm5
        movd    dword y(j+ 6, ecx), mm4
        movd    dword y(j+ 8, ecx), mm3
        psrlq   mm7, 32
        psrlq   mm6, 32
        psrlq   mm5, 32
        psrlq   mm4, 32
        psrlq   mm3, 32
        movd    dword y(j+ 1, ecx), mm7
        movd    dword y(j+ 3, ecx), mm6
        movd    dword y(j+ 5, ecx), mm5
        movd    dword y(j+ 7, ecx), mm4
        movd    dword y(j+ 9, ecx), mm3

        add    esi,18*4

        inc    ecx
        cmp    ecx, edx
        jl     near .LastBlockLoop
      .ExitLastBlockLoop:

        ;/* Compute return value */
        mov     eax,18
        mul     ecx
        mov     edx, dword [_band_limit_nsb]
        cmp     ecx, edx
        jge     near .SkipFinalClear
        
        xor     edi, edi
    .FinalClear:
%assign j 0
%rep 18
        mov    dword y(j, ecx), edi
%assign j j+1
%endrep
        inc    ecx
        cmp    ecx, edx
        jl     near .FinalClear
    .SkipFinalClear:
        femms

        popd    ebx, esi, edi, ebp
endproc

%else
;   C R[hƂ悻Ԃ ver

proc hybrid_e3dn_cmov ;// xin[] xprev[] y[18][32] btype  nlong  ntot   nprev
%$xin   arg     4
%$xprev arg     4
%$yout  arg     4
%$btype arg     4
%$nlong arg     4
%$ntot  arg     4
%$nprev arg     4

        pushd   ebx, esi, edi, ebp

        mov     ebx, [sp(%$btype)]
        xor     ecx, ecx        ; loop counter i
        cmp     ebx, 2
        mov     eax, WINSIZE
        cmovz   ebx, ecx
        mul     ebx
        lea     ebx, [_win+eax] ; ebx is win[btype]

        mov     edi, [sp(%$xin)]    ; edi is x
        mov     esi, [sp(%$xprev)]  ; esi is x0
        mov     ebp, [sp(%$yout)]   ; ebp is y

        mov     eax, [sp(%$nlong)]
        add     eax, 17
        div18                   ; edx is n
        cmp     ecx, edx
        jge     near .ExitLongBlockLoop

        ;/* Long block loop */
        prefetch    win(0)
        prefetch    win(16)
        align 4
    .LongBlockLoop:
        prefetchw   x(18)
        prefetch    x0(18)

        call _imdct18_e3dn_inner
        ;/* Unrool first J-controlled loop */
%assign j 0
        movd    mm0, dword x(9+j)
        pfmul   mm0, qword win(j)
        pfadd   mm0, qword x0(j)
        movd    dword y(j, ecx), mm0

        movd    mm1, dword x(17-j)
        pfmul   mm1, qword win(9+j)
        pfadd   mm1, qword x0(9+j)
        movd    dword y(9+j, ecx), mm1
%assign j 1
%rep 2
        movq    mm0, qword x(9+j)
        pfmul   mm0, qword win(j)
        pfadd   mm0, qword x0(j)
        movd    dword y(j, ecx), mm0
        psrlq   mm0, 32
        movd    dword y(j+1, ecx), mm0

        pswapd  mm1, qword x(16-j)
        pfmul   mm1, qword win(9+j)
        pfadd   mm1, qword x0(9+j)
        movd    dword y(9+j, ecx), mm1
        psrlq   mm1, 32
        movd    dword y(10+j, ecx), mm1

        movq    mm2, qword x(9+j+2)
        pfmul   mm2, qword win(j+2)
        pfadd   mm2, qword x0(j+2)
        movd    dword y(j+2, ecx), mm2
        psrlq   mm2, 32
        movd    dword y(j+2+1, ecx), mm2

        pswapd  mm3, qword x(16-j-2)
        pfmul   mm3, qword win(9+j+2)
        pfadd   mm3, qword x0(9+j+2)
        movd    dword y(9+2+j, ecx), mm3
        psrlq   mm3, 32
        movd    dword y(10+2+j, ecx), mm3
%assign j j+4
%endrep

        ;/* Unrool second J-controlled loop */
%assign j 0
%rep 2
        movq    mm0, qword x(j)         ;xa(j+1):xa(j)
        movq    mm1, qword x(7-j)       ;xb(j):xb(j+1)
        pswapd  mm2, mm0                ;xa(j):xa(j+1)
        pswapd  mm3, mm1                ;xb(j+1):xb(j)

        movq    mm4, qword win(18+9+j)  ;win(19+9+j):win(18+9+j)
        pfmul   mm4, mm0
        movq    qword x(9+j), mm4

        movq    mm5, qword win(17+17-j) ;win(18+17-j):win(17+17-j)
        pfmul   mm5, mm1                ;
        movq    qword x(16-j), mm5

        movq    mm6, qword win(17+8-j)  ;win(18+8-j):win(17+8-j)
        pfmul   mm6, mm2                ;win(18+8-j)*xa(j):win(17+8-j)*xa(j+1)
        movq    qword x(7-j), mm6

        movq    mm7, qword win(18+j)    ;win(19+j):win(18+j)
        pfmul   mm7, mm3                ;
        movq    qword x(j), mm7
%assign j j+2
%endrep

        ;/* Handle last special case */
%assign j 4
        movd    mm0, dword x(j)         ;xa
        movd    mm1, dword win(18+j)    ;win
        movd    mm2, dword win(18+9+j)
        pfmul   mm1, mm0
        pfmul   mm2, mm0
        movd    dword x(j), mm1
        movd    dword x(9+j), mm2

        add     edi,18*4                ;/* Update x */
        add     esi,18*4                ;/* Update x0 */
        inc     ecx                     ;/* Increment counter */
        cmp     ecx, edx
        jl      near .LongBlockLoop
    .ExitLongBlockLoop:

        mov     eax, [sp(%$ntot)]
        add     eax, 17
        div18
        cmp     ecx, edx
        jge     near .ExitShortBlockLoop

        ;/* Short block loop */
        mov         ebx, _win+(WINSIZE*2)    ;/* address of win[2] is in edx */
        prefetch    win(0)
        prefetch    win(16)
        align 4
    .ShortBlockLoop:
        prefetchw   x(18)
        prefetch    x0(18)

        call _imdct6_3_e3dn_inner

        ;/* First unrolled loop */
%assign j 0
        movd    mm6, dword win(j)
        movd    mm7, dword win(3+j)

        movd    mm0, dword x0(j)
        movd    dword y(j, ecx), mm0

        mov     eax, dword x0(3+j)
        mov     dword y(3+j, ecx), eax

        movd    mm0, dword x(3+j)
        pfmul   mm0, mm6
        pfadd   mm0, qword x0(6+j)
        movd    dword y(6+j, ecx), mm0
        
        movd    mm1, dword x(5-j)
        pfmul   mm1, mm7
        pfadd   mm1, qword x0(9+j)
        movd    dword y(9+j, ecx), mm1

        pfmul   mm6, qword x(6+3+j)
        movd    mm2, dword x(2-j)
        pfmul   mm2, qword win(6+j)
        pfadd   mm2, mm6
        pfadd   mm2, qword x0(12+j)
        movd    dword y(12+j, ecx), mm2
        
        pfmul   mm7, qword x(6+5-j)
        movd    mm4, dword x(j)
        pfmul   mm4, qword win(9+j)
        pfadd   mm4, mm7
        pfadd   mm4, qword x0(15+j)
        movd    dword y(15+j, ecx), mm4

%assign j 1
        movq    mm6, qword win(j)
        movq    mm7, qword win(3+j)

        movq    mm0, qword x0(j)
        movd    dword y(j, ecx), mm0
        psrlq   mm0, 32
        movd    dword y(j+1, ecx), mm0

        movq    mm1, qword x0(3+j)
        movd    dword y(3+j, ecx), mm1
        psrlq   mm1, 32
        movd    dword y(3+j+1, ecx), mm1

        movq    mm0, qword x(3+j)
        pfmul   mm0, mm6
        pfadd   mm0, qword x0(6+j)
        movd    dword y(6+j, ecx), mm0
        psrlq   mm0, 32
        movd    dword y(6+j+1, ecx), mm0
        
        pswapd  mm1, qword x(4-j)
        pfmul   mm1, mm7
        pfadd   mm1, qword x0(9+j)
        movd    dword y(9+j, ecx), mm1
        psrlq   mm1, 32
        movd    dword y(9+j+1, ecx), mm1

        pfmul   mm6, qword x(6+3+j)
        pswapd  mm2, qword x(1-j)
        pfmul   mm2, qword win(6+j)
        pfadd   mm2, mm6
        pfadd   mm2, qword x0(12+j)
        movd    dword y(12+j, ecx), mm2
        psrlq   mm2, 32
        movd    dword y(12+j+1, ecx), mm2
        
        pswapd  mm5, qword x(5+5-j)
        pfmul   mm7, mm5
        movq    mm4, qword x(j)
        pfmul   mm4, qword win(9+j)
        pfadd   mm4, mm7
        pfadd   mm4, qword x0(15+j)
        movd    dword y(15+j, ecx), mm4
        psrlq   mm4, 32
        movd    dword y(15+j+1, ecx), mm4

%assign j 1
        movq    mm6, qword win(6+j)
        movq    mm7, qword win(9+j)

        ;/* Second unrolled loop */
%assign j 0
        movd    mm0, dword x(12+3+j)
        pfmul   mm0, qword win(j)
        movd    mm1, dword x(6+2-j)
        pfmul   mm1, qword win(6+j)
        pfadd   mm0, mm1
        movd    dword x(j), mm0

        movd    mm2, dword x(12+5-j)
        pfmul   mm2, qword win(3+j)
        movd    mm3, dword x(6+j)
        pfmul   mm3, qword win(9+j)
        pfadd   mm2, mm3
        movd    dword x(3+j), mm2

%assign j 1
        movq    mm0, qword x(12+3+j)
        pfmul   mm0, qword win(j)
        pswapd  mm1, qword x(5+2-j)
        pfmul   mm1, mm6
        pfadd   mm0, mm1
        movq    qword x(j), mm0

        pswapd  mm2, qword x(11+5-j)
        pfmul   mm2, qword win(3+j)
        movq    mm3, qword x(6+j)
        pfmul   mm3, mm7
        pfadd   mm2, mm3
        movq    qword x(3+j), mm2

        ;/* Third unrolled loop */
%assign j 0
        movd    mm0, dword x(12+2-j)
        pfmul   mm0, qword win(6+j)
        movd    dword x(6+j), mm0

        movd    mm1, dword x(12+j)
        pfmul   mm1, qword win(9+j)
        movd    dword x(9+j), mm1

%assign j 1
        pswapd  mm2, qword x(11+2-j)
        pfmul   mm2, mm6
        movq    qword x(6+j), mm2

        pfmul   mm7, qword x(12+j)
        movq    qword x(9+j), mm7

        ;/* Fourth unrolled loop */
        pxor    mm0, mm0
%assign j 0
%rep 3
        movq    qword x(12+(j*2)), mm0
%assign j j+1
%endrep

        add    edi,18*4                ;/* Update x */
        add    esi,18*4                ;/* Update x0 */

        inc    ecx
        cmp    ecx, edx
        jl     near .ShortBlockLoop
    .ExitShortBlockLoop:

        mov     eax, [sp(%$nprev)]
        add     eax,17
        div18
        cmp     ecx, edx
        jge     near .ExitLastBlockLoop
        ;/* Short block loop */
        align 4
      .LastBlockLoop:
        prefetch    x0(18)
%assign j 0
        movq    mm0, x0(j+ 0)
        movq    mm1, x0(j+ 2)
        movq    mm2, x0(j+ 4)
        movq    mm3, x0(j+ 6)
        movd    dword y(j+ 0, ecx), mm0
        movd    dword y(j+ 2, ecx), mm1
        movd    dword y(j+ 4, ecx), mm2
        movd    dword y(j+ 6, ecx), mm3
        psrlq   mm0, 32
        psrlq   mm1, 32
        psrlq   mm2, 32
        psrlq   mm3, 32
        movd    dword y(j+ 1, ecx), mm0
        movd    dword y(j+ 3, ecx), mm1
        movd    dword y(j+ 5, ecx), mm2
        movd    dword y(j+ 7, ecx), mm3
%assign j 8
        movq    mm7, x0(j+ 0)
        movq    mm6, x0(j+ 2)
        movq    mm5, x0(j+ 4)
        movq    mm4, x0(j+ 6)
        movq    mm3, x0(j+ 8)
        movd    dword y(j+ 0, ecx), mm7
        movd    dword y(j+ 2, ecx), mm6
        movd    dword y(j+ 4, ecx), mm5
        movd    dword y(j+ 6, ecx), mm4
        movd    dword y(j+ 8, ecx), mm3
        psrlq   mm7, 32
        psrlq   mm6, 32
        psrlq   mm5, 32
        psrlq   mm4, 32
        psrlq   mm3, 32
        movd    dword y(j+ 1, ecx), mm7
        movd    dword y(j+ 3, ecx), mm6
        movd    dword y(j+ 5, ecx), mm5
        movd    dword y(j+ 7, ecx), mm4
        movd    dword y(j+ 9, ecx), mm3

        add    esi,18*4

        inc    ecx
        cmp    ecx, edx
        jl     near .LastBlockLoop
      .ExitLastBlockLoop:

        ;/* Compute return value */
        mov     eax,18
        mul     ecx
        mov     edx, dword [_band_limit_nsb]
        cmp     ecx, edx
        jge     near .SkipFinalClear
        
        xor     edi, edi
    .FinalClear:
%assign j 0
%rep 18
        mov    dword y(j, ecx), edi
%assign j j+1
%endrep
        inc    ecx
        cmp    ecx, edx
        jl     near .FinalClear
    .SkipFinalClear:
        femms

        popd    ebx, esi, edi, ebp
endproc

%endif
%undef  win
%undef  x
%undef  x0
%undef  y

end
