;/*
; *  for MP3Player - Free Delphi Component (OCT. 1999)
; *  modified by Kei Ishida  kei-i@sams.co.jp
; */

;/*
; * Antialias ASM version for the XingMPG Decoder
; *
; * Copyright (c) 1999, Jean-Michel HERVE
; *
; * Code : TuO / StG
; * Date : 24/02/99
; *
; * This program is free software; you can redistribute it and/or modify
; * it under the terms of the GNU General Public License as published by
; * the Free Software Foundation; either version 2 of the License, or
; * (at your option) any later version.
; * 
; * This program is distributed in the hope that it will be useful,
; * but WITHOUT ANY WARRANTY; without even the implied warranty of
; * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
; * GNU General Public License for more details.
; * 
; * You should have received a copy of the GNU General Public License
; * along with this program; if not, write to the Free Software
; * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
; * 
; * $Id: msisasm.asm,v 1.3 1999/04/22 08:24:02 mhw Exp $
; */

%include "nasm.h"

segment_data

EXTERN _csa

;SignReverseHigh dd 0, 080000000h


;/*
; * Antialias ASM Version
; */
proc antialias_fpu ;// PROC x, n :  DWORD
                ;//      ebp ebp+4
;//   for (k = 0; k < n; k++)
;//   {
        mov    ecx,[esp+8]

        or      ecx, ecx
        je     near .Skip1

        mov    eax,[esp+4]
        mov     edx, _csa

        align 4
      .Loop1:
;//      for (i = 0; i < 8; i++)
;//      {
%assign i 0
%rep 8
;//        a = x[17 - i];
        fld    dword [eax+(17-i)*4]    ;/* a */
;//        b = x[18 + i];
        fld    dword [eax+(18+i)*4]    ;/* b a */
;//        x[17 - i] = a * csa[i][0] - b * csa[i][1];
        fld    st1                     ;/* a b a */
        fmul   dword [edx+i*8]        ;/* a*csa[i][0] b a */
        fld    st1                     ;/* b a*csa[i][0] b a */
        fmul   dword [edx+i*8+4]      ;/* b*csa[i][1] a*csa[i][0] b a */
        fsubp  st1,st0                 ;/* x[17-i] b a */
        fstp   dword [eax+(17-i)*4]    ;/* b a */
;//        x[18 + i] = b * csa[i][0] + a * csa[i][1];
        fmul   dword [edx+i*8]        ;/* b*csa[i][0] a */
        fxch   st1                     ;/* a b*csa[i][0] */
        fmul   dword [edx+i*8+4]      ;/* a*csa[i][1] b*csa[i][0] */
        faddp  st1,st0                 ;/* x[18+i] */
        fstp   dword [eax+(18+i)*4]    ;/* - */
;//      }
%assign i i+1
%endrep
;//      x += 18;
        add    eax,18*4
;//   }
        dec    ecx
        jnz    near .Loop1

      .Skip1:
endproc

;/*
; * Antialias ASM Version
; * 3D Now! p
; */
proc antialias_3dn ;// PROC x, n :  DWORD
                ;//      ebp ebp+4

;//   for (k = 0; k < n; k++)
;//   {
        mov     ecx, [esp+8]
        or      ecx, ecx
        je     near .Skip2

        femms

        mov     eax, [esp+4]
        mov     edx, _csa
        add     eax, 17*4

        align 4
      .Loop2:
;//      for (i = 0; i < 8; i++)
;//      {
%assign i 0
%rep 4
;//        a = x[17 - i];
;//        b = x[18 + i];
;//        x[17 - i] = a * csa[i][0] - b * csa[i][1];
;//        x[18 + i] = b * csa[i][0] + a * csa[i][1];
        movq    mm0, qword [eax+(16-17-i)*4]           ; a[i]:a[i+1]
        movq    mm1, qword [eax+(18-17+i)*4]           ; b[i+1]:b[i]
        punpckldq   mm6, mm0
        movq    mm2, qword [edx+(i+0)*8]            ; csa[i][1]:csa[i][0]
        movq    mm3, qword [edx+(i+1)*8]            ; csa[i+1][1]:csa[i+1][0]
        punpckhdq   mm0, mm6                ; a[i+1]:a[i]
        movq    mm4, mm2
        movq    mm5, mm2
        movq    mm7, mm0
        punpckldq   mm4, mm3                ; csa[i+1][0]:csa[i][0]
        punpckhdq   mm5, mm3                ; csa[i+1][1]:csa[i][1]
        pfmul   mm7, mm4                    ; a[i+1]*csa[i+1][0]:a[i]*csa[i][0]
        pfmul   mm4, mm1                    ; b[i+1]*csa[i+1][0]:b[i]*csa[i][0]
        pfmul   mm1, mm5                    ; b[i+1]*csa[i+1][1]:b[i]*csa[i][1]
        pfmul   mm5, mm0                    ; a[i+1]*csa[i+1][1]:a[i]*csa[i][1]
        pfsub   mm7, mm1                    ; x[17-(i+1)]:x[17-i]
        pfadd   mm4, mm5                    ; x[18+(i+1)]:x[18+i]
        punpckldq   mm3, mm7
        movq    qword [eax+(18-17+i)*4], mm4
        punpckhdq   mm7, mm3                ; x[17-i]:x[17-(i+1)]
        movq    qword [eax+(16-17-i)*4], mm7
;//      }
%assign i i+2
%endrep
;//      x += 18;
        add    eax,18*4
;//   }
        dec    ecx
        jnz    near .Loop2

        femms

      .Skip2:
endproc

;/*
; * Antialias ASM Version
; * E3D Now! p
; */
proc antialias_e3dn ;// PROC x, n :  DWORD
                ;//      ebp ebp+4

;//   for (k = 0; k < n; k++)
;//   {
        mov     ecx, [esp+8]
        or      ecx, ecx
        je     near .Skip2

        femms

        mov     eax, [esp+4]
        mov     edx, _csa
        add     eax, 17*4

        align 4
      .Loop2:
        prefetch [eax+(18-17-7)*4]
;//      for (i = 0; i < 8; i++)
;//      {
%assign i 0
%rep 4
;//        a = x[17 - i];
;//        b = x[18 + i];
;//        x[17 - i] = a * csa[i][0] - b * csa[i][1];
;//        x[18 + i] = b * csa[i][0] + a * csa[i][1];
        pswapd  mm0, qword [eax+(16-17-i)*4]           ; a[i+1]:a[i]
        movq    mm1, qword [eax+(18-17+i)*4]           ; b[i+1]:b[i]
        movq    mm2, qword [edx+(i+0)*8]            ; csa[i][1]:csa[i][0]
        movq    mm3, qword [edx+(i+1)*8]            ; csa[i+1][1]:csa[i+1][0]
        movq    mm4, mm2
        movq    mm5, mm2
        movq    mm7, mm0
        punpckldq   mm4, mm3                ; csa[i+1][0]:csa[i][0]
        punpckhdq   mm5, mm3                ; csa[i+1][1]:csa[i][1]
        pfmul   mm7, mm4                    ; a[i+1]*csa[i+1][0]:a[i]*csa[i][0]
        pfmul   mm4, mm1                    ; b[i+1]*csa[i+1][0]:b[i]*csa[i][0]
        pfmul   mm1, mm5                    ; b[i+1]*csa[i+1][1]:b[i]*csa[i][1]
        pfmul   mm5, mm0                    ; a[i+1]*csa[i+1][1]:a[i]*csa[i][1]
        pfsub   mm7, mm1                    ; x[17-(i+1)]:x[17-i]
        pfadd   mm4, mm5                    ; x[18+(i+1)]:x[18+i]
        pswapd  mm7, mm7                    ; x[17-i]:x[17-(i+1)]
        movq    qword [eax+(18-17+i)*4], mm4
        movq    qword [eax+(16-17-i)*4], mm7
;//      }
%assign i i+2
%endrep
;//      x += 18;
        add    eax,18*4
;//   }
        dec    ecx
        jnz    near .Loop2

        femms

      .Skip2:
endproc

end
